#ifndef __BOOL_H__
#define __BOOL_H__

#include "value.h"
#include "text.h"
#include "float.h"

// Der bool.h sollte moeglichst nach allen anderen Headern eingebunden
// werden,falls diese (wie im Fall der X-Header) Bool abermals #define-en!
#undef Bool

class Bool;
class Bool: public Value
{
protected:
	Widget rowcol,on,off;
	Text onstr,offstr; // Sollten noch Pointer werden!
	bool val;

public:
	Bool(NetClass* nc,bool hidden = false);
	Bool(bool b = false): rowcol(0),on(0),off(0),val(b) {}
	Bool(const Bool& b);
	~Bool() { UncatchDestroy(&rowcol,&on,&off); }
	Value* Copy() const { return new Bool(*this); }
	Value* Cast() const { return new Float(val?1:0); }

	Widget CreateWidget(Widget parent);
	bool EvalWidget();
	
	istream& Parse(istream& is);
	istream& Input(istream& is);
	ostream& Output(ostream& os) const;
	
	int to_int() const { return val ? 1 : 0; }
	bool to_bool() const { return val; }
	//AH Changed Start added  const_cast<char*> 
	//to convert from a const to a non const (same as char *)
	char* to_charPtr() const { return val ? (const_cast<char*>("true")) : (const_cast<char*>("false")); }
	//AH Changed End

	Value& operator =(const bool b);
	Value& operator =(const Bool& b) { return *this=b.to_bool(); }
	Value& operator =(const Value& v) { return *this=v.to_bool(); }
};

typedef Bool* BoolP;

#endif
