#ifndef __CONNCL_H__
#define __CONNCL_H__

#include "objcl.h"
#include "linked.h"
#include "position.h"

class Net;
class NetClass;
class Node;
class NodeClass;
class Connector;

class ConnectorClass;
class ConnectorClass: public ObjectClass
{
	struct Rule
	{
		LinkedList<NodeClass*> in,out;
		Rule(LinkedList<NodeClass*>& i,LinkedList<NodeClass*>& o): in(i),out(o) {}
		bool AllowedConnection(NodeClass* i,NodeClass* o)
			{	return (!in || in.IsIn(i)) && (!out || out.IsIn(o)); }
		int operator ==(const Rule&) { return 0; }
		int operator !=(const Rule&) { return 0; }
	};
	LinkedList<Rule> rules;
	OpaqueIterator<Rule> iter;
	
	friend class NetClass;
	ConnectorClass(NetClass& nc);
	~ConnectorClass();	

public:
	void DrawButton(Display* dpy,Drawable d,int x,int y,int w,int h);
	bool IsNodeClass() { return false; }
	bool AllowedConnection(Node* in,Node* out);
	
	istream& Input(istream&);
};

typedef ConnectorClass *ConnectorClassP;

#endif
