#ifndef __CONNECT_H__
#define __CONNECT_H__

#include "object.h"
#include "linked.h"
#include "conncl.h"

class Node;

class Connector;
class Connector: public Object
{
	ConnectorClass* conncl;
	LinkedList<Position*> pos;
	Position* curr;
	Node* input,* output;
	
	Position LocateLink(Position& npos,bool input);

	friend class Editor;
	void EnterEditor(Editor* ed);
	void LeaveEditor();
	
	friend class Page;
	Position* Insert(const Position pos);
	bool Event(Display* dpy,EventInfo& ev);

public:
        void Move(const Position rel); // ehemals private, wird von SPNLControl gebraucht
	bool IsNode() { return false; }
	ConnectorClass* Class() { return conncl; }
	
	bool Virtual() { return attr==0; }
	Position Mid();
		
	Connector(ConnectorClass* cl,Page* parent,char* name = 0);
	Connector(Connector& c,Page* parent);
	Connector* Copy(Page* parent);
	~Connector();
	
	void SetConnections(Node* in,Node* out);
	Node* GetInput() { return input; }
	Node* GetOutput() { return output; }
	
	istream& Input(istream&);
	ostream& Output(ostream&);
	
	int NumPositions() { return pos.Length(); }
	Iterator<Position*> Positions() { return Iterator<Position*>(pos); }
	Position* InsertPos(int p,const Position psn);
	void RemovePos(const Position psn);

	void Rearrange();
	void MoveInput(const Position rel);
	void MoveOutput(const Position rel);
	
	void SetClass(ConnectorClass* cl);

	ShapeData GetShapeData(double zoom, bool draft);
	ExprData GetExprData(bool mono, bool draft);
};

typedef Connector *ConnectorP;

#endif
