/* expr.h:

*/

#ifndef __EXPR_H__
#define __EXPR_H__

#include <iostream.h>

#include "ident.h"

class Struct;
class Context;

struct ExprData
{
	Struct& attr;
	char* name;
	bool sel,virt,draft,mono;
	Context* context;
	
	ExprData(Struct& at,char* nam,bool selct,bool v,bool d,bool m):
		attr(at),
		name(nam),
		sel(selct),
		virt(v),
		draft(d),
		mono(m),
		context(0) {}
 
   //AH Changed Start: function inserted
   ExprData(Struct& at,Ident& i,bool selct,bool v,bool d,bool m):
 		attr(at),
 		name(i.to_charPtr()),
 		sel(selct),
 		virt(v),
 		draft(d),
 		mono(m),
 		context(0) {}
   //AH Changed End
 
};

class Value;
class Expression;
class ExpressionNode;
class Expression
{
	Value* result;
	ExpressionNode* root;
	
	// BNF-Rule-Functions
	ExpressionNode* QOp(istream& is);
	ExpressionNode* Or(istream& is);
	ExpressionNode* And(istream& is);
	ExpressionNode* Comp(istream& is);
	ExpressionNode* Expr(istream& is);
	ExpressionNode* Term(istream& is);
	ExpressionNode* Factor(istream& is);
	ExpressionNode* Const(istream& is);
	ExpressionNode* Ref(istream& is);
public:

	Expression(): result(0),root(0) {}
	Expression(istream& is): result(0),root(0) { Input(is); }
	~Expression();
	
	Value* Evaluate(ExprData& ob);
	istream& Input(istream& is);
	ostream& Output(ostream& os);
	
	operator Value*() { return result; }
};

typedef Expression* ExpressionP;

inline istream& operator >>(istream& is,Expression& e) {	return e.Input(is); }
inline ostream& operator <<(ostream& os,Expression& e) {	return e.Output(os); }

#endif
