#ifndef __FLOAT_H__
#define __FLOAT_H__

#include <strstream.h>

#include "value.h"

/*AH CHANGED:
inserted various "::"

dazu>>
Changes in GCC 2.95:
* For class D derived from B which has a member 'int i', &D::i is now of
  type 'int B::*' instead of 'int D::*'.

(imho kompletter Schwachsinn)

*/


class Float;
class Float: public Value
{
protected:
	double val,max,min;
	Widget text;

	void UpdateWidget();

public:
       	Float(NetClass* nc,bool hidden = false);
	Float(double d = 0.0);
	Float(const Float& f);
 	~Float() { 	UncatchDestroy(&text); }

	Value* Copy() const { return new ::Float(*this); }
	Value* Cast() const { return Copy(); }

	Widget CreateWidget(Widget parent);
	bool EvalWidget();
	
	istream& Parse(istream& is);
	istream& Input(istream& is);
	ostream& Output(ostream& os) const { return os<<val; }
	
 	int to_int() const { return int(val); }
 	double to_double() const { return val; }
 	char* to_charPtr() const; 

	Value& operator =(const double d);
	Value& operator =(const int i) { return *this=double(i); };
 	Value& operator =(const ::Float& f) { return *this=f.to_double(); };
 	Value& operator =(const Value& v) { return *this=v.to_double(); };
	
	bool operator ==(double v) { return val==v; }
	bool operator !=(double v) { return val!=v; }
	bool operator >(double v)  { return val>v; }
	bool operator <(double v)  { return val<v; }
	::Float operator -()      { return ::Float(-val); }
	::Float operator !() 		 { return ::Float(!int(val)); }
	::Float operator -(double v)  { return ::Float(val-v); }
	::Float operator +(double v)  { return ::Float(val+v); }
	::Float operator *(double v)  { return ::Float(val*v); }
	::Float operator /(double v)  { return ::Float(val/v); }
	
private:
	friend class Operation;
 	Value* Eq(Value& v) { return new ::Float(val==v.to_double()?1:0); }
 	Value* Gt(Value& v)  { return new ::Float(val>v.to_double()?1:0); }
 	Value* Lt(Value& v)  { return new ::Float(val<v.to_double()?1:0); }
	Value* Neg()      { return new ::Float(-val); }
	Value* Not() 		 { return new ::Float(!int(val)); }
 	Value* Sub(Value& v)  { return new ::Float(val-v.to_double()); }
 	Value* Add(Value& v)  { return new ::Float(val+v.to_double()); }
 	Value* Mul(Value& v)  { return new ::Float(val*v.to_double()); }
 	Value* Div(Value& v)  { return new ::Float(val/v.to_double()); }
	
 	Value* And(Value& v) { return new ::Float(val && v.to_double()); }
 	Value* Or(Value& v) { return new ::Float(val || v.to_double()); }
};

typedef Float* FloatP;

#endif
