#ifndef __FORMAT_H__
#define __FORMAT_H__

#include "shape.h"
#include "label.h"
#include "keytable.h"
#include "metrics.h"

class Format;
class Format: public Label
{
public:
  // Struktur eines Fragmentes
  struct Fragment;
  struct Fragment {
    char*     chars;
    int       nchars;
    Font      font;
    Fragment* next;

    Fragment(char* ch, int nch, Font f):
      chars(ch), nchars(nch), font(f)
      {
	next = 0;
      }

    void Print()
      { cout << "Fragment:" << chars << ' ' << nchars << '\n'; }
  };

  // Struktur einer Fragmentliste
  struct Frag_list;
  struct Frag_list {
    static bool comment;
    int       no_entries;
    Font      bold_font;
    Font      normal_font;
    Fragment* first;
    Fragment* last;
    
    Frag_list(char* string, Font bold, Font normal);
    ~Frag_list();
    void Insert(char* frag, int len, bool test, bool before_or_after_a_digit= false);
    void Print();
  };

  Format();
  Format(istream& is,Context* super);
  void DoDraw(Display* dpy,Drawable d,GC gc,ShapeData&,ExprData&);
  char* Type() { return "format"; }
  Metrics GetMetrics(Display* dpy,ShapeData& sd,ExprData& ed);
};

typedef Format* FormatP;

#endif
