#ifndef __METRICS_H__
#define __METRICS_H__

#include "position.h"

#define MINSPACE 10

struct Metrics;
struct Metrics {
  static double epsilon;
  double y_beg;
  double y_end;
  double x_beg;
  double x_end;
  bool   set;

  Metrics():y_beg(undefined), y_end(undefined),
    x_beg(undefined), x_end(undefined), set(false) {}
  Metrics(double yb, double ye,
	  double xb=undefined, double xe=undefined , bool st=true):
    y_beg(yb), y_end(ye), x_beg(xb), x_end(xe), set(st) {}

  void Compare(Metrics comp);
  void Compare(Position pos);
  void Print();
  double VertExtension() { return (y_end-y_beg); }
  double HorExtension() { return (x_end-x_beg); }
  double Overlap(Metrics met);
  bool Within(Position pos);
  bool Within(Metrics met);
  bool IsLower(Metrics met);
  Position ForceIn(Position pos);
  Position ForceIn(Position pos,Metrics met);
  Position Orig() { return Position(x_beg,y_beg); }
  void Move(Position rel);
};


#endif
