#ifndef __PLINE_H__
#define __PLINE_H__

#include "shape.h"
#include "linked.h"
#include "metrics.h"

class Pline;
class Pline: public Shape
{
protected:
	double sqlength(double x1,double y1,double x2,double y2)
	{ return (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1); }
	double fsign(double x) { return x>=0.0 ? 1 : -1; }
	XSegment* segs;
	int nsegs,msegs;
	XArc* arcs;
	int narcs,marcs;
	XPoint* pnts;
	int mpnts;
	LinkedList<Position*> p;
	Iterator<Position*> piter;

	void Spline(LinkedList<Position>& pos,double spline);

	istream& Input(istream& is,int field);

public:
	char* Type() { return "pline"; }

	LinkedList<Position> Positions(ShapeData& sd);
        Metrics GetMetrics(Display*,ShapeData& sd,ExprData&);

	Pline(): segs(0),arcs(0),pnts(0),piter(p) {}
	Pline(istream& is,Context* super): Shape(super),
		segs(0),arcs(0),pnts(0),piter(p) { is>>*this; }
	~Pline();
	
	double Distance(ShapeData& sd,Position& ps,Position& nearest);
	int Inside(Display* dpy,Position,ShapeData&,ExprData&);
	Position PointToMid(ShapeData& sd,Position& ps);
	void DoDraw(Display* dpy,Drawable d,GC gc,ShapeData& sd,ExprData& ed);
};

#endif


