// -----------------------------------------------------------------
// Importe
// -----------------------------------------------------------------

#include "EDSPNtokengam.h"

 //AH Changed Start replaced numerous charP(_bla_) by _bla_.to_charPtr()
 // typecasts charP(_bla_) removed where they are unnecessary: Text += Text
 // inserted numerous .to_bool() .to_double()
 //AH Changed End 
 

MODULE_NOTIFY(EDSPNTokengame)

// -----------------------------------------------------------------
// protected Tokengame-Hilfsfunktionen
// -----------------------------------------------------------------

bool EDSPNTokengame::ParseAllMarkings() 
{
  bool Pars_OK = true;
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)
  // fuer jeden Knoten tue
    
    if (IsPlace(node)) 
    // Knoten ist eine Stelle?

      if (isalpha(((*GetMarking(node))).to_charPtr()[0]))
	{// Markierungsparameter in der Stelle?
	  
 	  NodeP markpar=FindMarkingParameter((*GetMarking(node)).to_charPtr());
	  if (markpar)
	    *GetMarking(node)= GetMarkPar(markpar);
	  else
	    {
	      ParserObject= node;
	      ParserText= GetMarking(node);
	      ParserError("mark_par does not exist:",
 		      (*GetMarking(node)).to_charPtr(),(int)strlen((*GetMarking(node)).to_charPtr()));
              Pars_OK = false;
	    }
	}
  this->ed->Update();
  // Editor-Screen update

  return Pars_OK;
}

// -----------------------------------------------------------------

NodeP EDSPNTokengame::FindMarkingParameter(charP Name)
{
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)

    if (!strcmp((node->Name()).to_charPtr(), Name))

      if (IsParameter(node) && IsMarkPar(node))
	return (node);

   //AH Changed Start => (NodeP)
   return (NodeP)NULL;
   //AH Changed End
  // nicht gefunden
}

// -----------------------------------------------------------------

void EDSPNTokengame::MakeReadyToFire(NodeP node)
{
  FireItemP item= new FireItem(node);
  
  int *index= new int;
  *index= 0;
  item->Bindings.Append(index);
  // nur ein Uebergang ist je Transition moeglich (Nummer 0), gemaess Netzklasse
  
  ReadyToFire.Append(item);
}

// -----------------------------------------------------------------

void EDSPNTokengame::CollectEnabledTrans() 
{
  HighestPriority= 0;
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP n=ListNodes; n; n=++ListNodes)

    if (IsTransition(n) && Enabled(n))
      {// Transition und schaltfaehig?
	  
	if (IsImmediate(n))
	  {// Immediate Transition?
	      
	    if (GetPriority(n) > HighestPriority)
	      HighestPriority= GetPriority(n);
	    // hoechste Prioritaet merken
	      
	    Immediates.Append(n);
	    // zeitlose Transition merken
	  }
	  
	else
	  Timed.Append(n);
	// und zeitbehaftete Transition merken
      }    
}

// -----------------------------------------------------------------

bool  EDSPNTokengame::Enabled(NodeP node)
{
  if (IsImmediate(node))
    {
      ParserObject= node;
      ParserText= Get_md_enable(node);
      Recursion.Clear();

      if (!Parse_md_enable(   (*Get_md_enable(node)).to_charPtr()    )) 
	return false;
    }// global guard disabled?
  
  Iterator<ConnectorP> InputConns= node->Inputs();

  for (ConnectorP c= InputConns; c; c=++InputConns)
    {// fuer alle Eingaenge der Transition tue

      ParserObject= c;
      ParserText= GetMultiplicity(c);
      Recursion.Clear();

      if (IsInhibitor(c))
	{// hemmende Kante?
	  
 	  if ((*GetMarking(c->GetInput())).to_double() >=
 	      Parse_md_arc_mult(  (*GetMultiplicity(c)).to_charPtr()   ))
	    return false;
	}
      else
 	if ((*GetMarking(c->GetInput())).to_double() < 
 	    Parse_md_arc_mult((*GetMultiplicity(c)).to_charPtr() ))
	  return false;
    }

  return true;
  // alle Tests negativ -> Transition ist schaltfaehig
}

// -----------------------------------------------------------------

void EDSPNTokengame::ShowEnabledTrans()
{
  /*AH CHANGED START:
    mark transitions as selected,
    then update page only once for 
    all transitions
  */
  for (int i= 0; i<ReadyToFire.Length(); ++i)
    (*ReadyToFire[i])->node->MarkSelected(true);

  /*AH CHANGED update visible page*/
  net.GetPage(this->ed)->Update();

  // alle schaltfaehigen Transitionen selektieren

  if (BackwardEnable)
    {
      if (!--StepsCnt || !FiredCount)
	{
	  BackwardEnable= false;
	  StepsCnt= Steps;
	}
      
      if (FiredCount)
	{
	  FiredItemP item= *Fired[FiredCount-1];
	  
	  SelectTrans(item->node);
	  
	  if (FiredCount==FiredCount_save)
	    {
	      Text DialogContense;
 	      DialogContense+= Text("Warning: this command ");
 	      DialogContense+= Text("may lead to an inconsistent ");
 	      DialogContense+= Text("net-status, ");
 	      DialogContense+= Text("if you changed the net!");
	      
	      OpenMsgDialog(*this->ed, "EDSPNTokengame_Warning",
 			    DialogContense.to_charPtr(),false,"Ok");
	    }
	  
	  item->Do(BACKWARD, this);  
	}
    }
  else if (ForwardEnable)
    {
      if (!--StepsCnt || FiredCount==Fired.Length())
	{
	  ForwardEnable= false;
	  StepsCnt= Steps;
	}
      
      if (FiredCount<Fired.Length())
	{
	  FiredItemP item= *Fired[FiredCount];
	  
	  SelectTrans(item->node);
	  
	  item->Do(FORWARD, this);
	}
    }
}

// -----------------------------------------------------------------

void EDSPNTokengame::SaveParams(StructP params)
{
  Steps= Steps2Int(params);
  StepsCnt= Steps;
}

// -----------------------------------------------------------------

Text EDSPNTokengame::Int2Steps(int value)
{
  if (value == 1)
    return Text("onestep");
  else if (value == 10)
    return Text("tensteps");
  else
    return Text("fiftysteps");
}

// -----------------------------------------------------------------

int EDSPNTokengame::Steps2Int(StructP params)
{
  charP member= (*params->GetMember("steps")).to_charPtr();

  if (!strcmp(member,"onestep"))
    return (1);
  else if (!strcmp(member,"tensteps"))
    return (10);
  else if (!strcmp(member,"fiftysteps"))
    return (50);
  else return (1);
}

// -----------------------------------------------------------------

void EDSPNTokengame::OnDialogButton(Ident& button)
{

  StructP params= GetParams();
  
  if ((button=="Forward") && EventEnable())
    {// Forward angeklickt?

      SaveParams(params);

      ForwardEnable= true;
    }
  else if ((button=="Backward") && EventEnable())
    {// Backward angeklickt?

      SaveParams(params);

      BackwardEnable= true;
    }
  else if ((button=="Stop"))
    {// Stop angeklickt?

      SaveParams(params);

      StepsCnt= Steps;
      BackwardEnable= false;
      ForwardEnable= false;
    }
  else if ((button=="Close"))
    {// Close angeklickt?

      SaveParams(params);

      CloseDialog();
      DestroyDialog();
    }
  else if (button=="Cancel")
    {// Cancel angeklickt?

      TokenGameEnable= true;
      XmToggleButtonSetState(this->ToggleWidget,true,true);
      // ToggleButton selektieren

      CloseDialog();
      DestroyDialog();
    }
  else if (button=="Ok")
    {// Ok angeklickt?

      CloseDialog();
      DestroyDialog();
    }
  else if ((button=="reset marking"))
    {// Restore angeklickt?

      DeInitTokengame(true);

      CloseDialog();
      DestroyDialog();
    }
  else if ((button=="keep current marking"))
    {// Quit angeklickt?

      DeInitTokengame(false);

      CloseDialog();
      DestroyDialog();
    }
}

// -----------------------------------------------------------------
// Parser-Hilfsfunktionen
// -----------------------------------------------------------------

void EDSPNTokengame::ParserError(const charP message, charP string, int length)
{
  error= true;

  if (firsttime)
    {
      firsttime= false;

      Text DialogContense;

      if (type==md_exp_delay)
	DialogContense+= "an error occured in <md_exp_delay>\n";
      else if (type==md_det_delay)
	DialogContense+= "an error occured in <md_det_delay>\n";
      else if (type==md_weight)
	DialogContense+= "an error occured in <md_weight>\n";
      else if (type==md_enable)
	DialogContense+= "an error occured in <md_enable>\n";
      else if (type==md_arc_mult)
	DialogContense+= "an error occured in <md_arc_mult>\n";
      else if (type==reward_def)
	DialogContense+= "an error occured in <reward_def>\n";
      else if (type==param_def)
	DialogContense+= "an error occured in <param_def>\n";
      else if (type==pmf_def)
	DialogContense+= "an error occured in <pmf_def>\n";
      
      
      if (ParserObject)
	{
 	  DialogContense+= Text("while parsing:\n");
 	  DialogContense+= (ParserObject->Class()->GroupName()).to_charPtr();
 	  DialogContense+= Text("(");
 	  DialogContense+= (ParserObject->Class()->Name()).to_charPtr();
 	  DialogContense+= Text(") ");
 	  DialogContense+= (ParserObject->Name()).to_charPtr();
 	  DialogContense+= Text("\n");

	  net.GetPage(this->ed)->Deselect();
	  ParserObject->Select(true);
	}

      if (ParserText)
	{
 	  DialogContense+= *ParserText;
	  DialogContense+= "\n";
	}
      
      DialogContense+= message;
      DialogContense+= "\n";
      if (strncmp((*ParserText).to_charPtr(), string, length))
	{
	  for (int i=0; i< length; i++)
	    DialogContense+= string[i];
	  DialogContense+= "\n";
	}
      // und nun noch die Meldungen des Parsers

      
      OpenMsgDialog(*this->ed, "EDSPNTokengame_Error",
        DialogContense.to_charPtr(),true,"Ok");

      DeInitTokengame(true);
    }
}

// -----------------------------------------------------------------

long EDSPNTokengame::ParseMarking(charP string, int length)
{
  string++;length--;
  // abschneiden des '#'-Zeichens vor dem Stellennamen

  for (int i = 0; ListeStellen[i].Name != NULL; i++)
    // fuer alle Knoten true

    if (!strncmp(ListeStellen[i].Name, string, length))
      // Stelle mit gewuenschtem Namen gefunden?
	return ListeStellen[i].Marken;
        // Markeninhalt

  ParserError("Place does not exist:",
	      string, length);

  return 0;
}

// -----------------------------------------------------------------

double EDSPNTokengame::ParseParameter(charP string, int length)
{
  return (ParseRealParameter(string, length));
  // Parameter sind in dieser Netzklasse immer Integer
  // aber es wird mit double-Zahlen gerechnet
}

// -----------------------------------------------------------------

long EDSPNTokengame::ParseIntegerParameter(charP string, int length)
{
  return (long)(ParseRealParameter(string, length));
  // IntegerParameter sind casted RealParameter
}

// -----------------------------------------------------------------

double EDSPNTokengame::ParseRealParameter(charP string, int length)
{
  if (RecursionError)
    return 0.0;

  Iterator<NodeP> ListNodes= net.Prime()->Nodes();
  
  for (NodeP node=ListNodes; node; node=++ListNodes)
    // fuer alle Knoten tue
    
    if (IsParameter(node))
      // suche einen Parameter
      
      if ((length==(int)(strlen((node->Name()).to_charPtr())) &&
 	   !strncmp((node->Name()).to_charPtr(), string, length)))
	// Parameter mit gewuenschtem Namen gefunden?
	
	if (IsMarkPar(node))
	  {// Stelle ist MarkingParameter?
	    
	    IsMDDelay= true;
	    
	    return (double)
	      (GetMarkPar(node));
	  }
	else if (IsDelayPar(node))
	  {// Stelle ist DelayParameter?
	    
	    if (Recursion.IsIn(node))
	      {
		RecursionError= true;
		ParserError("illegal recursion:",
			    string, length);
		return 0.0;
	      }
	    Recursion.Append(node);
	    
	    ParserObject= node;
	    ParserText= GetDelayPar(node);
	    
	    enum parser_type type_save= type;
	    bool error_save= error;
	    bool IsMDDelay_save= IsMDDelay;
	    bool IsMDArcMult_save= IsMDArcMult;
	    bool IsMDDelayPar_save= IsMDDelayPar;
	    
 	    double value= Parse_param_def((*GetDelayPar(node)).to_charPtr());
	    
	    type= type_save;
	    error|= error_save;
	    IsMDDelay= IsMDDelay_save;
	    IsMDArcMult= IsMDArcMult_save;
	    IsMDDelayPar= IsMDDelayPar_save;
	    
	    Recursion.Remove(node);
	    
	    return value;
	  }
	else 
	  {
	    ParserError("unknown Parameter type:",
			string, length);
	    return 0.0;
	  }
  ParserError("Parameter does not exist:",
	      string, length);
  return 0.0;
}

// -----------------------------------------------------------------
// Tokengame-Hilfsfunktionen
// -----------------------------------------------------------------

bool EDSPNTokengame::IsPlace(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Places") ? true : false);
}


// -----------------------------------------------------------------

bool EDSPNTokengame::IsTransition(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Transition") ? true : false);
}

// -----------------------------------------------------------------

bool EDSPNTokengame::IsImmediate(NodeP node)
{// vorher IsTransition() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"ImmTrans") ? true : false);
}

// -----------------------------------------------------------------

bool EDSPNTokengame::IsInhibitor(ConnectorP conn)
{
  return (!strcmp((conn->Class()->Name()).to_charPtr(),"Inhibitor") ? true : false);
}

// -----------------------------------------------------------------

bool EDSPNTokengame::IsParameter(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Parameter") ? true : false);
}

// -----------------------------------------------------------------

bool EDSPNTokengame::IsMarkPar(NodeP node)
{// vorher IsParameter() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"MarkPar") ? true : false);
}

// -----------------------------------------------------------------

bool EDSPNTokengame::IsDelayPar(NodeP node)
{// vorher IsParameter() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"DelayPar") ? true : false);
}

// -----------------------------------------------------------------

TextP EDSPNTokengame::GetMarking(NodeP node)
{
  return (TextP)node->Attr("marking");
}

// -----------------------------------------------------------------

int EDSPNTokengame::GetPriority(NodeP node)
{
  return ((*node->Attr("priority")).to_int());
}

// -----------------------------------------------------------------

TextP EDSPNTokengame::Get_md_enable(NodeP node)
{
  return (TextP)node->Attr("md_enable");
}

// -----------------------------------------------------------------

TextP EDSPNTokengame::GetMultiplicity(ConnectorP c)
{
  return (TextP)c->Attr("multi");
}

// -----------------------------------------------------------------

int EDSPNTokengame::GetMarkPar(NodeP node)
{
  return (*node->Attr("value")).to_int();
}

// -----------------------------------------------------------------

TextP EDSPNTokengame::GetDelayPar(NodeP node)
{
  return (TextP)node->Attr("delay");
}

// -----------------------------------------------------------------

TextP EDSPNTokengame::GetColor(NodeP node)
{
  return (TextP)node->Attr("selcol");
}

// -----------------------------------------------------------------
// Tokengame-Hauptfunktionen
// -----------------------------------------------------------------

void  EDSPNTokengame::StartTokengame() 
{
  firsttime= true;

  Text DialogContense;
  DialogContense+= Text("Instructions:\nto fire a transition,\n");
  DialogContense+= Text("double-click on the right mouse-button!");

  if (ParseAllMarkings()) {
    
    // Stellen zaehlen
    int i = 0;
    Iterator<NodeP> ListNodes= net.Prime()->Nodes();
    for (NodeP node=ListNodes; node; node=++ListNodes)
    // fuer alle Knoten true

      if (IsPlace(node))
          // Stelle gefunden?
        i++;

    ListeStellen = new Stellen[++i];

    // Stellen kopieren
    i = 0;
    for (NodeP node=ListNodes; node; node=++ListNodes)
      // fuer alle Knoten true

      if (IsPlace(node)) {
        // Stelle gefunden?
        ListeStellen[i].Name = (node->Name()).to_charPtr();
          // Liste der Stellen erstellen
        i++;
      }

    ListeStellen[i].Name = (char *)NULL;

    CopyMarkings();

    OpenMsgDialog(*this->ed, "EDSPNTokengame_Info",
		  DialogContense.to_charPtr(),false,"Ok");

    ConfigurationChange= true;

    RecursionError= false;

  }

}

// -----------------------------------------------------------------

void  EDSPNTokengame::EndTokengame() 
{
  StepsCnt= Steps;
  BackwardEnable= false;
  ForwardEnable= false;

  //AH Changed Start  => (ObjectP)(TextP)
  ParserObject= (ObjectP)NULL;
  ParserText= (TextP)NULL;
  //AH Changed End
  Recursion.Clear();

  Timed.Clear();
  Immediates.Clear();
}

// -----------------------------------------------------------------

bool  EDSPNTokengame::EventEnable() 
{
 
  return (!BackwardEnable && !ForwardEnable);
}

// -----------------------------------------------------------------

void EDSPNTokengame::OpenOptionsMenu()
{
  Text DialogContense;
  
  DialogContense+= Text("[enum ( \"1 step\" onestep, ");
  DialogContense+= Text("\"10 steps\" tensteps, ");
  DialogContense+= Text("\"50 steps\" fiftysteps ) ");
  DialogContense+= Text("\"Steps for Forward/Backward\"steps= ");
  DialogContense+= Int2Steps(Steps);
  DialogContense+= Text("]");
  CreateDialog(DialogContense.to_charPtr());

  OpenDialog(*this->ed, "EDSPNTokengame_Control", 
	     "Backward Forward Stop Close");
}

// -----------------------------------------------------------------

bool  EDSPNTokengame::SelectEnabledTrans(PageP) 
{
  if (!firsttime)
    return false;

  if (ConfigurationChange)
    {
      ConfigurationChange= false;

      Timed.Clear();
      Immediates.Clear();

      CollectEnabledTrans();
      // Alle schaltfaehigen Transitionen in Listen merken

      if (!firsttime)
	return false;

      if (Immediates.Length())
	{// zeitlose Transitionen haben Vorrang 
	  
	  Iterator<NodeP> ListImmTrans= Immediates;

	  for (NodeP n= ListImmTrans; n; n= ++ListImmTrans)

	    if (GetPriority(n) == HighestPriority)
	      MakeReadyToFire(n);
	  // nur zeitlose Transitionen hoechster Prioritaet
	}
      else
	{// nur zeitbehaftete Transitionen sind schaltfaehig

	  Iterator<NodeP> ListTimedTrans= Timed;

	  for (NodeP n= ListTimedTrans; n; n= ++ListTimedTrans)

	    MakeReadyToFire(n);
	  // alle zeitbehafteten Transitionen sind gleichberechtigt
	  
	 }
    }
  ShowEnabledTrans();

  return true;
}

// -----------------------------------------------------------------

bool  EDSPNTokengame::DeselectEnabledTrans(PageP) 
{
  DeselectAllTrans();
  
  return true;
}

// -----------------------------------------------------------------

void  EDSPNTokengame::OpenFireMenu(Node& node) 
{
  FireItemP item;
  Iterator<FireItemP> ListItems= ReadyToFire;

  for (item= ListItems; (item && (*item!=&node)); item= ++ListItems);

  if (item)
    item->Fire(*(item->Bindings[0]), this);

  // die Auswahl eines Uebergangs der Transition entfaellt,
  // da nur Uebergang Nummer 0 existiert, gemaess Netzklasse
}

// -----------------------------------------------------------------

void  EDSPNTokengame::CopyMarkings()
{

  // Markierungen kopieren
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();
  for (NodeP node=ListNodes; node; node=++ListNodes) {
    // fuer alle Knoten true

    if (IsPlace(node))
      // Stelle gefunden?

      for (int i = 0; ListeStellen[i].Name != NULL; i++) {
        if (!strcmp(ListeStellen[i].Name, (node->Name()).to_charPtr())) 
	  ListeStellen[i].Marken = (long)((*GetMarking(node)).to_double());
          // Markeninhalt ist ganzzahliger Wert
        else;
      }
  }  

}

// -----------------------------------------------------------------

bool  EDSPNTokengame::IsMarkAb(NodeP node) 
{

  ConnectorP c;
  char* Kante;

  Iterator<ConnectorP> OutputConns= node->Outputs();
  for (c= OutputConns; c; c=++OutputConns)
    {
      Kante = (*GetMultiplicity(c)).to_charPtr();

      for (unsigned int i=0; i<strlen(Kante); i++) {
        if (Kante[i] == '#') return true;
      }
    }
  Iterator<ConnectorP> InputConns= node->Inputs();
  for (c= InputConns; c && !IsInhibitor(c); c=++InputConns)
    {
      Kante = (*GetMultiplicity(c)).to_charPtr();

      for (unsigned int i=0; i<strlen(Kante); i++) {
        if (Kante[i] == '#') return true;
      }
    }

  return false;

}

// -----------------------------------------------------------------

void  EDSPNTokengame::FireTrans(NodeP node, int, bool undo) 
{
  ConnectorP c;

  CopyMarkings();

  if (undo)
    {// umgekehrtes Schalten entspricht undo  

      if (!IsMarkAb(node)) {
        Iterator<ConnectorP> OutputConns= node->Outputs();
        for (c= OutputConns; c; c=++OutputConns)
	  {
	    ParserObject= c;
	    ParserText= GetMultiplicity(c);
	    Recursion.Clear();

 	    *GetMarking(c->GetOutput())=(*GetMarking(c->GetOutput())).to_double()  	              - Parse_md_arc_mult((*GetMultiplicity(c)).to_charPtr());
	  }
        Iterator<ConnectorP> InputConns= node->Inputs();
        for (c= InputConns; c && !IsInhibitor(c); c=++InputConns)
	  {
	    ParserObject= c;
	    ParserText= GetMultiplicity(c);
	    Recursion.Clear();

 	    *GetMarking(c->GetInput())=  (*GetMarking(c->GetInput())).to_double()                    +    Parse_md_arc_mult((*GetMultiplicity(c)).to_charPtr());
	  }
      }
       else {
         OpenMsgDialog(*this->ed, "EDSPNTokengame_Info",
		       "marking depend firing: undo impossible !!!"
		       ,false,"Ok");
      }
    }
  else
    {
      Iterator<ConnectorP> InputConns= node->Inputs();
      for (c= InputConns; c && !IsInhibitor(c); c=++InputConns)
	{
	  ParserObject= c;
	  ParserText= GetMultiplicity(c);
	  Recursion.Clear();

 	  *GetMarking(c->GetInput())=  (*GetMarking(c->GetInput())).to_double()                  -      Parse_md_arc_mult((*GetMultiplicity(c)).to_charPtr());
	}
      Iterator<ConnectorP> OutputConns= node->Outputs();
      for (c= OutputConns; c; c=++OutputConns)
	{
	  ParserObject= c;
	  ParserText= GetMultiplicity(c);
	  Recursion.Clear();

 	  *GetMarking(c->GetOutput())=(*GetMarking(c->GetOutput())).to_double()                     + Parse_md_arc_mult((*GetMultiplicity(c)).to_charPtr());
	}
    }
  
  CopyMarkings();

  this->ed->Update();
  // Editor-Screen update

  ReadyToFire.Clear();

  ConfigurationChange= true;

  SetModified();
  // Das Netz wurde modifiziert
}

// -----------------------------------------------------------------

