// -----------------------------------------------------------------
// Importe
// -----------------------------------------------------------------

#include "ExtCtrl.h"

 //AH Changed Start replaced numerous charP(_bla_) by _bla_.to_charPtr()
 //AH Changed End 
 
// *********** Klassenimplementierung FTrans (Anfang) ******************

//FTrans::FTrans(unsigned int ID,const char *Name, unsigned int Bindingnr, NodeP Knoten)
FTrans::FTrans(const char *Auftrag,const char *Name, unsigned int Bindingnr, NodeP Knoten)
{
  // initial ist der Auftrag nicht aktiv
  aktiv=false;

  abbruch=false;

  auftrag=Auftrag;
  name=Name; 

  binding=Bindingnr;
  knoten=Knoten;
}

FTrans::~FTrans()
{}

bool FTrans::IstKnoten(NodeP Knoten)
{
  return (Knoten == knoten);
}

const char *FTrans::Auftrag()
{
  return auftrag.to_charPtr();
}

bool FTrans::Start(unsigned int bindingnr)
{
  if (aktiv && !abbruch)
    // Der Auftrag ist bereits in Arbeit
    return false;
  else
    {
      abbruch=false;

      schaltzeit=0.0;

#ifdef CONTROL_DEBUG
      cout << "!!!:"<<Auftrag().to_charPtr()<<endl;
#endif
      binding=bindingnr;
      aktiv=true;
      return true;
    }
}

void FTrans::Abbruch()
{
  abbruch=true;
}

bool FTrans::Abgebrochen()
{
  return abbruch;
}

unsigned int FTrans::Ende()
{
  // Der Auftrage ist wieder ausfuehrbar
  aktiv=false;
  abbruch=false;
  return binding;
}

bool FTrans::Aktiv()
{
  return aktiv;
}

const char *FTrans::Name()
{
  return name.to_charPtr();
}

// *********** Klassenimplementierung FTrans (Ende) ******************




// *********** Klassenimplementierung FAnlage (Anfang) ******************

// -----------------------------------------------------------------
// FAnlage-Klassendefinition Hilfsfunktionen
// -----------------------------------------------------------------

bool FAnlage::IsImmediateTrans(NodeP node)
{// vorher IsTransition() aufrufen

  return (!strcmp( (node->Class()->Name()).to_charPtr()  , "ImmTrans"))? true: false;
}

// -----------------------------------------------------------------

bool FAnlage::IsTimedTrans(NodeP node)
{// vorher IsTransition() aufrufen

  return (!strcmp(   (node->Class()->Name()).to_charPtr()   , "TimedTrans"))? true: false;
}

// -----------------------------------------------------------------

void FAnlage::Fire(FireItemP item, intP binding)
{

  // Pruefen ob zu feuernde Transition extern oder intern
  Iterator<FTrans *> TransZusatzIter = TransZusatz;
  //AH Changed Start   FTrans *zusatz=NULL;
  FTrans *zusatz;
  //AH Changed End  
  

  for (FTrans *k=TransZusatzIter; k; k=++TransZusatzIter)
    if (k->IstKnoten(item->node))
      {zusatz=k;break;}

  if (zusatz)
    // Die Transition ist extern
    {
      if (!AniEnable && !FeuerListe && zusatz->Start(*binding))
        // Es gibt keinen anderen Auftrag der bearbeitet werden kann. &&
	// Der Auftrag konnte aktiviert werden.
	{
	  // Auftrag an den Steuerungsprozess senden
	  char a[20];
 	  sprintf(a,"Auftrag=%s",(zusatz->Auftrag()));
	  Kom->Nachricht(a);

	  // Transition in aktiver Farbe anzeigen.
	  SelectTrans(zusatz->Knoten());
#ifdef CONTROL_DEBUG
	  cout << "feuer ext:" << zusatz->Knoten()->Name() << endl;
#endif
	}
    }
  else
    // Die Transition ist intern
    {
      if (IsImmediateTrans(item->node))
        // Zeitlose Transition vorne an Feuerliste anfuegen
	FeuerListe.Insert(new Uebergang(item->node, *binding), 0);
      else if (!FeuerListe)
        // Zeitbehaftete Transition hinten an Feuerliste anhaengen
	FeuerListe.Append(new Uebergang(item->node, *binding));
    }
}

// -----------------------------------------------------------------

// Meldungen vom Prozess fuer externe Transitionen lesen
bool FAnlage::FAuftragLesen()
{
  bool s;
  // Pruefen ob gerade zeitbehaftete Transitionen schaltfaehig sind.
  // (Es koennen immer nur entweder zeitbehaftete oder zeitlose
  // Transitionen schaltfaehig)
  if (ReadyToFire)
    {
      Iterator<FireItemP> RTFIter = ReadyToFire;
      FireItemP item;
      for (item=RTFIter; item->node->SubPage(); item=++RTFIter);
      s=IsTimedTrans(item->node);
    }
  else
    s=false;
  
  if (Kom && kommaktiv && s)
    // Die Kommunikationsschnittstelle Kom existiert &&
    // die Verbindung zum Steuerungsprozess ist hergestellt &&
    // es sind zeitbehaftete Transitionen schaltfaehig
    {
      char *nachr;
      
      // Nachrichten des Steuerungsprozesse aus der Kommunikationsdatei
      // lesen
      Kom->Nachrichten_Lesen(); 
      
      // Alle neu empfangenen Nachrichten durchgehen
      for(nachr=Kom->Nachricht(); nachr && *nachr; nachr=Kom->Nachricht())
        {
#ifdef CONTROL_DEBUG
	  cout << "Ext.Meldung: <"<<nachr<<">"<<endl;
#endif
	  char auftr[80];
	  char fehler[80];
	  if (sscanf(nachr, "Erledigt=%s", auftr))
            // Steuerungsprozess melde Erledigung vom Auftrag auftr
	    {
              // Uebergangsattribute des Auftrags suchen
	      Iterator<FTrans *> FKnotenIter = TransZusatz;
	      FTrans *n=FKnotenIter;
 	      while (n && (strcmp(n->Auftrag(),auftr) || (!n->Aktiv())))
		n=++FKnotenIter;
	     
cout << "Rueckmeldung empfangen: " << auftr<< endl; 
	      if (n)
                // Uebergangsattribute gefunden
		{
		  // Item des Uebergangs aus ReadyToFire Liste suchen
                  // (Feststellen ob der Uebergang noch schaltfaehig ist
		  Iterator<FireItemP> RTFIter = ReadyToFire;
		  FireItemP item;
		  for (item=RTFIter; (item && (!n->IstKnoten(item->node))); item=++RTFIter);


		  if (item)	
                    // Der Uebergang ist schaltfaehig und wird
                    // hinten an die Feuerliste angehangen
		    FeuerListe.Append(new Uebergang(item->node, n->Binding()));
		  else
                    // Der Uebergang ist nicht mehr schaltfaehig
		    {
cout << "1" << endl;
		      Text meldung="Extern Transition is not enabled, now:\n";
		      meldung=meldung+n->Name();

		      CreateDialog();
 		      OpenMsgDialog(*this->ed,"Control-Error", meldung.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");
		      return false;
		    }
		}
	      else
                // Die Uebergangsattibute zu dem Auftrag wurden nicht gefunden.
		{
		  Text meldung="Unexpected extern Mission_ID:\n";
		  meldung=meldung+nachr;
		  
		  CreateDialog();
 		  OpenMsgDialog(*this->ed,"Control-Error", meldung.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");
		  return false;
		}
	    }
	  else if (sscanf(nachr, "FEHLER:%s \"%[a-z,A-Z,0-9,' ','!']\"", auftr, fehler))
            // Der Steuerungsprozess gibt eine Meldung aus.
	    {
	      // Steuerungsprozess in manuellen Modus versetzen
	      Kom->Nachricht("MANUELL");
	      Kom->Nachrichten_Senden();
      
              // Uebergangsattribute des Auftrags suchen
	      Iterator<FTrans *> FKnotenIter = TransZusatz;
	      FTrans *n=FKnotenIter;
 	      while (n && (strcmp(n->Auftrag(),auftr) || (!n->Aktiv())))
		n=++FKnotenIter;
	      
	      if (n)
		{
		  Text meldung;
 		  meldung=meldung+"Transition: "+n->Name()+"\n";
		  meldung=meldung+"Mission   : "+auftr+"\n";
		  meldung=meldung+"Message   : "+fehler+"\n";

		  
		  CreateDialog();
                  if (einstellungs_modus)
 		    OpenMsgDialog(*this->ed,"Mission Error", meldung.to_charPtr(), true, "\"Ok\"");
		  else
		    {
 		      OpenMsgDialog(*this->ed,"Mission Error", meldung.to_charPtr(), true, "\"continue\" \"reset marking\" \"keep current marking\"");

		      // Modul in den Einstellungsmodus versetzen.
		      einstellungs_modus=true;
		    }

		  // Abbruch des Auftrags der externen Transition registrieren 
		  n->Abbruch();

		  return true;
		  
		}
	      else
                // Die Uebergangsattibute zu dem Auftrag wurden nicht gefunden.
		{
		  Text meldung="Unexpected Mission Message:\n";
		  meldung=meldung+nachr+fehler;
		  
		  CreateDialog();
 		  OpenMsgDialog(*this->ed,"Control-Error", meldung.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");

		  // Modul in den Einstellungsmodus versetzen.
		  einstellungs_modus=true;

		  return false;
		}

	    }
	  else
            // Der Steuerungsprozess gibt eine Meldung aus.
	    {
	      Text meldung="Unknown extern Message: ";
	      meldung=meldung+nachr;

	      CreateDialog();
 	      OpenMsgDialog(*this->ed,"Control-Error", meldung.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");

	      // Modul in den Einstellungsmodus versetzen.
	      einstellungs_modus=true;
	      
	      return false;
	    }
	}
    }
return true;
}

// -----------------------------------------------------------------
//AH NEW: called when a new editor is opened
//toggles if Control Menu Button is displayed
bool FAnlage::Init()
{
#ifdef CONTROL_DEBUG
  cout << "Init" << endl;
#endif
  if(net.Prime()->Class()->Name() != "HCPN")
    return false;
  
  Text zusatz_pfad(FileName());           // Pfadname Zusatzdatei fuer externe Steuerung
  zusatz_pfad = zusatz_pfad - NETFILENAME;
  zusatz_pfad = zusatz_pfad + ".ext";
  
  // Datei mit Zusatzattributen fuer externe Transitionen oeffnen.
  ifstream zusatz(zusatz_pfad.to_charPtr(), ios::nocreate);
  
  if (!zusatz)
    // Die Datei mit Zusatzattributen fuer externe Transitionen exisiert nicht.
    return false;
  else
    {
      zusatz.close();
      return true;
    }
}

// -----------------------------------------------------------------

void FAnlage::StartTokengame()
{
#ifdef CONTROL_DEBUG
  cout << "StartTokengame" << endl;
#endif

  // Modul in den Einstellungsmodus versetzen.
  einstellungs_modus=true;
  
  // Echtzeit einschalten
  RealTime=true;
  
  Text zusatz_pfad(FileName());           // Pfadname Zusatzdatei fuer externe Steuerung
  zusatz_pfad = zusatz_pfad - NETFILENAME;
  zusatz_pfad = zusatz_pfad + ".ext";
  
  // Datei mit Zusatzattributen fuer externe Transitionen oeffnen.
  ifstream zusatz(zusatz_pfad.to_charPtr(), ios::nocreate);
  
  if (zusatz)
    // Datei mit Zusatzattributen existiert.
    {  
      // Pfad auf ein lokal abgelegtes Verzeichnes holen
      char u[200];
      strcpy(u, tmpnam(0));
      *strrchr(u, '/')=0; // Dateinamen abschneiden
      Text lokal_pfad=u; 
      
      // Pfade fuer Kommunikationsdateien festlegen (lokaler Bereich)
      agn2fan_pfad = lokal_pfad + "/agn2fan.kom";
      fan2agn_pfad = lokal_pfad + "/fan2agn.kom";
      
      
      // Programm fuer externe Steuerung in lokalen Bereich kopieren
      Text kopier = "cp ";
      kopier = kopier + getenv("TNETHOME") + "/MSControl/bin/control " + lokal_pfad;
      
      system(kopier.to_charPtr()); 
      
      // Dateipfad fuer Lockdatei festlegen, mit der erreicht wird,
      // dass immer nur eine Steuerung laeuft.
      flock_pfad = getenv("TNETHOME");
      flock_pfad = flock_pfad + "/MSControl/flock";
      
      
      // Lockdatei versuchen zu oeffnen
      ofstream lf(flock_pfad.to_charPtr(), ios::nocreate);
      
      if (lf)
	// Lockdatei existiert bereits => keine weitere Steuerung moeglich. 
	{
	  aktiv=false;
	  kommaktiv=false;
	  
	  CreateDialog();
	  OpenMsgDialog(*this->ed,"Control-Error", "Lockfile already exists!", true, 
			"\"reset marking\" \"keep current marking\"");
	}
      else
	// Lockdatei existiert noch nicht.
	{
	  // Zusatzdaten fuer externe Steuerung lesen
 	  ifstream zusatz(zusatz_pfad.to_charPtr());
	  if (zusatz)
	    {
	      // Transitionsverknuepfungen lesen (Auftraege)
	      Lade_ExtZusatz(zusatz);	      
	      
	      // Pfad der Datei in die eine Tabelle aller verwendeten 
	      // Auftraege geschrieben wird.
	      Text auftr_tab_pfad(FileName());
	      auftr_tab_pfad = auftr_tab_pfad - NETFILENAME;
	      auftr_tab_pfad = auftr_tab_pfad + ".auftr";
	      
	      // Verwendete Auftraege in eine Tabelle schreiben
	      Erzeuge_AuftrTab(auftr_tab_pfad);
	      /*
		 // Auftragstabelle ueberpruefen
		 Kom->Nachricht("PRUEFE ");
		 Kom->Nachrichten_Senden();
		 */
	      
	      
	      // Pfad der Netzdatei
	      if (strrchr(FileName(), '/')==NULL)
		{// no pathname?
		  
		  netname= model_dir;
		  netname+= '/';
		  netname+= FileName();
		}
	      else
		netname= FileName();
	      
	      // Slave der Simulation starten.
	      Text rname= netname-NETFILENAME;
	      ConnectionWithSlave(rname);
	      
	      // Pfad von <net>.fire ermitteln.
	      Text firefile= netname - NETFILENAME + FIREFILENAME;
	      
	      // firefile loeschen
 	      ofstream FireFile(firefile.to_charPtr(), ios::trunc); FireFile.close();
	      
	      
	      
	      // Prozess fuer externe Steuerung erzeugen
	      //		  Text params = lokal_pfad + "/fanlage " + agn2fan_pfad + " " + fan2agn_pfad;
	      Text params = lokal_pfad + "/control " + agn2fan_pfad + " " + fan2agn_pfad;
 	      //AH Changed Start   pid2= Exec(params, NULL, NULL);
 	      pid2= Exec(params.to_charPtr(), (char *)NULL, (char *)NULL);//outfile, infile);
 	      //AH Changed End
	      
	      if (pid2 != -1)
		// Prozess erfolgreich gestartet.
		{
		  // Kommunikationsschnittstelle zum Steuerungsprozess
		  // erzeugen.
 		  Kom=new T_FKommunikation(fan2agn_pfad.to_charPtr(), agn2fan_pfad.to_charPtr());
		  
		  // Steuerung ist moeglich.
		  aktiv=true;
		  
		  // Kommunikation zu Steuerungsprozess moeglich.
		  kommaktiv=true;
		  
		  // Steuerungsprozess in manuellen Modus versetzen
		  Kom->Nachricht("MANUELL");
		  
		  // Im Fenster zur manuellen Initialisierung auffordern.
		  Text DialogContense;
		  DialogContense+= "Instructions:\nto fire a transition,\n";
		  DialogContense+= "double-click on the right mouse-button!\n\n\n"
		    "Set the initial positions, now!";
		  
		  OpenMsgDialog(*this->ed, "Control_Info",
                                DialogContense.to_charPtr(),false,"\"Settings complete\"");
		}
	      else
		// Der Steuerungsprozess konnte nicht gestartet werden.
		{
		  aktiv=false;
		  kommaktiv=false;
		  
		  CreateDialog();
		  OpenMsgDialog(*this->ed,"FAnlage-Error", "The prozess control could\nnot be started!",
				true, "\"reset marking\" \"keep current marking\"");
		  
		  DeInitTokengame(false);
		}
	      
	    }
	  else
	    {
	      aktiv=false;
	      kommaktiv=false;
	      
	      CreateDialog();
	      OpenMsgDialog(*this->ed,"Control-Error", "In file (.ext) syntaxerror!", true, 
			    "\"reset marking\" \"keep current marking\"");
	      
	      DeInitTokengame(false);
	    }
	  
	}
      lf.close();
    }
  else
    // Die Datei mit Zusatzattributen fuer externe Transitionen exisiert nicht.
    {
      aktiv=false;
      kommaktiv=false;
      
      Text DialogContense;
      DialogContense+= "Control: file '<model>.ext' does not exist!";
      CreateDialog();
      OpenMsgDialog(*this->ed,"Control-Error",DialogContense.to_charPtr(),true,	                      "\"reset marking\" \"keep current marking\"");
      
      DeInitTokengame(false);
    }

  // Referenzwert fuer Differenzzeitbildung setzen.
  if (gettimeofday(&zeit_alt, 0)==-1)
    cout << "Zeit kann nicht gelesen werden!!!" << endl;      
}


void FAnlage::Lade_ExtZusatz(ifstream& zusatz)	      
{
  char zeile[ZUSATZ_MAX+1];
  char Name[ZUSATZ_MAX+1];
  char *merke1, *merke2;
  char auftr[80];
  NodeP knoten;
  PageP seite = net.Prime();
  Iterator<NodeP> ListNodes= seite->Nodes();
  NodeP n;
  

  // Zusatzdaten fuer externe Steuerung einlesen
  while (!zusatz.eof())
    {
      // Transitionszuordnung einlesen
      zusatz.getline(zeile, ZUSATZ_MAX, '\n');
      Name[0]=0;


      if (zeile && *zeile && sscanf(zeile, "%s %s", Name, auftr) && Name[0])
        // Syntax von Transitionszuordnung ist korrekt.
	{
	  // Knotenreferenz suchen
	  seite = net.Prime();
	  ListNodes = seite->Nodes();
	  n=ListNodes;
	  knoten=0;
      
	  merke1=Name;
	  merke2=strchr(merke1, '/');

          // Knoten zur Transitionsbeschreibung suchen.
	  while (n && !knoten)
	    {
	      if (IsTransition(n))
                // Knoten ist eine Transition
		{
		  seite=n->SubPage();
		  
 		  if (merke2 && !strncmp((n->Name()).to_charPtr(), merke1, merke2-merke1))
                    // Transitionsbeschreibung verlangt eine Vertretertransition &&
                    // Transition in Transitionpfad enthalten.
		    {
		      if (seite)
                        // Knoten ist ein Vertretertransition
			{
			  ListNodes = seite->Nodes();
			  n=ListNodes; 
			  merke1=merke2+1;
			  merke2=strchr(merke1, '/');
			}
		      else
                        // Knoten ist keine Vertretertransition 
			{
			  CreateDialog();
			  OpenMsgDialog(*this->ed,"Control-Error",
					"Externe Zuordnung verlangt Vertreter", true, 
				        "\"reset marking\" \"keep current marking\"");
			}
		    }
 		  else if (!merke2 && !strcmp((n->Name()).to_charPtr(),merke1))
                    // Transitionsbeschreibung verlangt eine externe Transition &&
                    // Transition in Transitionpfad enthalten.
		    {
		      if (seite)
			{
			  CreateDialog();
			  OpenMsgDialog(*this->ed,"Control-Error",
					"Externe VertreterZuordnung nicht moeglich", true, 
					"\"reset marking\" \"keep current marking\"");
			  return;
			}
		      else
			{
			  knoten=n;
			}
		    }
		  else
		    {		    
		      n=++ListNodes; 
		    }
		}
	      else
		{
		  n=++ListNodes; 
		}
	    }
	  
	  if (knoten)
            // Knoten zur Transitionsbeschreibung wurde gefunden.
	    {
              // Zusatzattribute der externen Transition in der Liste
              // vermerken.
	      TransZusatz.Append(new FTrans(auftr, Name, 0, knoten));
	    }
	  else
            // Knoten zur Transitionsbeschreibung wurde nicht gefunden.
	    {
	      Text x;
	      x="Not found: ";
	      x+=Name;
	      CreateDialog();
 	      OpenMsgDialog(*this->ed,"Control-Warning", x.to_charPtr(), false,			    "\"reset marking\" \"keep current marking\"");
	      return;
	    }
	}
    }

} 
// -----------------------------------------------------------------
 
void FAnlage::SetSpeed()
{
  if (RealTime)
    {
      Speed= (signed int)(LowestSpeed*FastestTimePercentage);

#ifdef CONTROL_DEBUG
      cout << "Speed1: " << Speed<<endl;
#endif
      if (ExtStrg)
	Speed=(signed int)(Speed/((double)(2*UPDATEINTERVALL)));
      // Hinweis: Bei der Steuerung ist FastestTimePercentage kein Quotient
      // aus der laengsten Schaltzeit (siehe Slave)
#ifdef CONTROL_DEBUG
      cout << "Speed2: " << Speed<<endl;
#endif
  }
  else
    Speed= 0;
 
  if (Speed<0)
    SpeedCnt = 0;
  else
    SpeedCnt = Speed;
}

// -----------------------------------------------------------------

void FAnlage::Erzeuge_AuftrTab(Text auftr_tab_pfad)
{
/*
  Text auftr_tab_pfad(FileName());           // Pfadname Auftragsdatei fuer externe Steuerung
       auftr_tab_pfad = auftr_tab_pfad - NETFILENAME;
       auftr_tab_pfad = auftr_tab_pfad + ".auftr";
*/
  ofstream auftr_tab(auftr_tab_pfad.to_charPtr());

  Iterator<FTrans *> TransZusatzIter = TransZusatz;

  // Die Auftraege aller externen Transitionen werden in die Datei auftr_tab
  // geschrieben.
  for (FTrans *k=TransZusatzIter; k; k=++TransZusatzIter)
    {
      auftr_tab << k->Auftrag() << "\n";
    }

  auftr_tab.close();
}


// -----------------------------------------------------------------

void FAnlage::FireTrans(NodeP node, int binding, bool Backward)
{
// --------------------------HCPNTokengame (Anfang)---------------------------------------
  Text nodename= ConstructName(node);

  Text firefile= netname - NETFILENAME + FIREFILENAME;
  
  ofstream FireFile(firefile.to_charPtr());
  // Oeffnen der Fire-Datei (open)

  if (Backward)
    FireFile << "Undo: ";
// --------------------------HCPNTokengame (Ende)---------------------------------------
  // In der Steuerung tritt Backward nicht auf

  if (ExtStrg && AniEnable && IsTimedTrans(node));
  {
/*
    // Pruefen ob die zu schaltende Transition extern oder intern ist.
    Iterator<FTrans *> TransZusatzIter = TransZusatz;
    FTrans *zusatz=NULL;
        
    for (FTrans *k=TransZusatzIter; k; k=++TransZusatzIter)
      if (k->IstKnoten(node))
	{zusatz=k;break;}

    if ()
   
    if (zusatz)
      // Die Transition ist extern.
      {


         // Reale Schaltzeit der externen Transition an den
         // Simulatorprozess senden.
	 FireFile << ".ExtTransTime= ";
	 FireFile << zusatz->schaltzeit;
#ifdef CONTROL_DEBUG
	 cout << "Schaltzeit: " << zusatz->schaltzeit << endl;
#endif
*/

	 FireFile << ".TimeDiff= ";
	 FireFile << diff_zeit;
#ifdef CONTROL_DEBUG
	 cout << "Zeitdifferenz: " << double(diff_zeit) << endl;
#endif

	 // Differenzzeit seit dem letzten schalten auf Null setzen.
	 diff_zeit=0;
//      }
  }
  


  
// --------------------------HCPNTokengame (Anfang)---------------------------------------
  FireFile << nodename.to_charPtr() << " " << binding << endl;

  FireFile << flush;

  FireFile.close();
  // Schliessen der Fire-Datei

  kill(pid, SIGUSR1);
  // Signal an den Slave
// --------------------------HCPNTokengame (Ende)---------------------------------------

}

// -----------------------------------------------------------------

void FAnlage::EndTokengame()
{
#ifdef CONTROL_DEBUG
  cout << "EndTokengame" << endl;
#endif
  
  // Externe Kommuniktion unterbinden, damit keine Stoerungen auftreten
  kommaktiv=false;
  
  if (aktiv)
    {
      // Alle Elemente der Liste TransZusatz loeschen.
      while (TransZusatz)
	{
	  FTrans *merke;
	  merke=*TransZusatz.First();
	  TransZusatz.Remove(merke);
	  delete merke;
	}
      
      // Alle Elemente der Liste FeuerListe loeschen.
      while (FeuerListe)
	{
	  Uebergang *merke;
	  merke=*FeuerListe.First();
	  FeuerListe.Remove(merke);
	  delete merke;
	}
      
      
      AniEnable=  false;
      StepsCnt= Steps;
      BackwardEnable= false;
      ForwardEnable= false;
      
      if (pid)
        // Simulationsprozess laeuft noch. 
	{
	  // Simulationsprozess stoppen 
	  kill(pid, SIGINT);
	  pid= 0;
	  
	  Text infile=   netname - NETFILENAME + TABLEFILENAME;
	  Text outfile=  netname - NETFILENAME + OUTFILENAME;
	  Text firefile= netname - NETFILENAME + FIREFILENAME;
	  Text listfile= netname - NETFILENAME + LISTFILENAME;
 	  remove(infile.to_charPtr());
 	  remove(outfile.to_charPtr());
 	  remove(firefile.to_charPtr());
 	  remove(listfile.to_charPtr());
	}
      
      Received= false;
      
      
      // Steuerungsprozess leitet Ende ein
      Kom->Nachricht("ENDE");
      Kom->Nachrichten_Senden();
      
      delete Kom;
      Kom=0;
      
      aktiv=false;
    }
}

// -----------------------------------------------------------------

void FAnlage::OpenOptionsMenu()
{
  // Fenster erzeugen, um Steuerungsoptionen einzustellen.
  Text DialogContense;
  DialogContense+= Text("[").to_charPtr();
  DialogContense+= Text("]").to_charPtr();

  CreateDialog(DialogContense.to_charPtr());
  OpenDialog(*this->ed, "Control", 
	     "Animate Stop Close");//Backward Forward 
}

// -----------------------------------------------------------------

bool FAnlage::DoPeriodic()
{
  timeval zeit;
  
  if (gettimeofday(&zeit, 0)==-1)
    cout << "Zeit kann nicht gelesen werden!!!" << endl;      

  if (!einstellungs_modus)
    {
      diff_zeit+=( ( (zeit.tv_sec - zeit_alt.tv_sec)*1000 +
                     zeit.tv_usec/1000                      ) -
		   zeit_alt.tv_usec/1000                        );
      
#ifdef CONTROL_DEBUG
      cout << diff_zeit << " ms" << endl;
#endif
    }	
      
  zeit_alt=zeit;





  if (!einstellungs_modus)
    {
      // Die Schaltzeiten aller aktiven Transitionen erhoehen
      Iterator<FTrans *> TransZusatzIter = TransZusatz;
      for (FTrans *k=TransZusatzIter; k; k=++TransZusatzIter)
	if (k->Aktiv())
	  k->schaltzeit+=(double)UPDATEINTERVALL;
      
      if(Received && AniEnable)
	// Animation: starten aller externen Transitionen
	{
	  // Die Liste der feuerbaren Transition durchgehen
	  Iterator<FireItemP> FireList= ReadyToFire;
	  for (FireItemP item=FireList; item;item=++FireList)
	    {
	      //Pruefen ob externe Transition
	      Iterator<FTrans *> TransZusatzIter = TransZusatz;
	      for (FTrans *k=TransZusatzIter; k; k=++TransZusatzIter)
		if (k->IstKnoten(item->node))
		  {
		    // Erstes Binding starten
		    Iterator<int*> bindings=item->Bindings;
		    if (k->Start(*bindings))
		      {
			char a[20];
			sprintf(a,"Auftrag=%s",(charP)k->Auftrag());
			Kom->Nachricht(a);

			// Transition in aktiver Farbe anzeigen.
			SelectTrans(k->Knoten());
#ifdef CONTROL_DEBUG
			cout << "feuer ext:" << k->Knoten()->Name() << endl;
#endif
		      }
		  }
	    }
	}
      
      
      
      if (Received && FeuerListe)
	// Der aktuelle Netzzustand ist bekannt und 
	// die gefeuerte Transitionen ist vorhanden.    
	if (!ReadyToFire)
	  // Es ist keine Transition schaltfaehig.
	  {;
#ifdef CONTROL_DEBUG
	   cout << "KEINE TRANSITION SCHALTFAEHIG!!!" << endl;
#endif
	 }
	else 
	  // Es gibt schaltfaehige Transitionen.
	  {
	    NodeP t=(*ReadyToFire.First())->node;
	    
	    NodeP t2=(*FeuerListe.First())->Knoten();
	    
	    if (IsTimedTrans(t) && IsImmediateTrans(t2))
	      // Es sind nur zeitbehaftete Transitionen schaltfaehig, die
	      // Feuerliste gibt jedoch an, dass eine zeitlose Transition
	      // geschaltet werden soll.
	      // Zeitlose Transitionen haben eine hoehere Prioritaet als,
	      // Zeitbehaftete => Fehler.
	      {
#ifdef CONTROL_DEBUG
		cout << "ZEITLOSE TRANSITION KANN NICHT GESCHALTET WERDEN!" << endl;
#endif
	      }
	    else if (!(IsImmediateTrans(t) && IsTimedTrans(t2)))
	      // Es sind sind keine zeitlosen Transitionen schaltfaehig oder die
	      // Feuerliste gibt an jedoch, dass eine zeitlose Transition
	      // geschaltet werden soll.
	      {
		
#ifdef CONTROL_DEBUG
		{
		  Iterator<FireItem *> RTFIter = ReadyToFire;
		  for (FireItem *k=RTFIter; k; k=++RTFIter)
		    cout << "RTF:"<<k->node->Name()<<endl;
		  cout << endl;
		}
		{
		  Iterator<Uebergang *> FeuerIter = FeuerListe;
		  for (Uebergang *k=FeuerIter; k; k=++FeuerIter)
		    cout << "F:"<<k->Knoten()->Name()<<endl;
		  cout << endl;
		}
#endif
		
		Uebergang *ueber;
		ueber=*FeuerListe.First();
		
		// Item aus ReadyToFire Liste suchen
		Iterator<FireItemP> RTFIter = ReadyToFire;
		FireItemP item;
		for (item=RTFIter; (item && (ueber->Knoten()!=item->node)); item=++RTFIter);
		if (item)		
		  // Der zu schaltende Uebergang ist schaltfaehig 
		  {
		    // Pruefen ob es eine externe Transition ist.
		    Iterator<FTrans *> TransZusatzIter = TransZusatz;
		    FTrans *k;
		    for (k=TransZusatzIter; k && !k->IstKnoten(ueber->Knoten()); k=++TransZusatzIter);
		    
		    if (k)
		      // Die Transition ist extern,
		      // das Ende des zugehorigen Auftrag wird registriert.
		      k->Ende();
		    
		    // Das Schalten der des Uebergangs durch den Simulatorprozess
		    // wird veranlasst.
		    int b=ueber->Binding();
		    Received= false;
		    item->Fire(&b, this);
		    
#ifdef CONTROL_DEBUG
		    cout << "feuer int:" << ueber->Knoten()->Name() << endl;
#endif
		    // Der Uebergang wird aus der Feuerliste entfernt.
		    FeuerListe.Remove(ueber);
		    delete ueber;
		  }
		else
		  // Der zu feuernde Uebergang ist nicht schaltfaehig.
		  {
		    cout << "2" << endl;
		    Text meldung="Extern transition is not enabled:\n";
		    meldung=meldung+ueber->Knoten()->Name();
		    CreateDialog();
 		    OpenMsgDialog(*this->ed,"Control-Error", meldung.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");
		    return false;
		  }
	      }
#ifdef CONTROL_DEBUG
	    else
	      // Es sind nur zeitlose Transitionen schaltfaehig, die
	      // Feuerliste gibt jedoch an, dass eine zeitbahafte Transition
	      // geschaltet werden soll.
	      // Zeitlose Transitionen haben eine hoehere Prioritaet als,
	      // Zeitbehaftete => Erst die zeitlosen Transitionen
	      // abarbeiten.
	      {
		Iterator<Uebergang *> FeuerIter = FeuerListe;
		for (Uebergang *k=FeuerIter; k; k=++FeuerIter)
		  cout << "F:"<<k->Knoten()->Name()<<endl;
		cout << endl;
	      }
#endif
	  }
    }

  if (Kom)
    // Die Kommunikationsschnittstelle zum Steuerungsprozess existiert.
    {
      // Rueckmeldungen des Steuerungsprozesses pruefen.
      if (!FAuftragLesen())
	return false;
     
      // Kommandos bzw. Auftraege an den Steuerungsprozess senden.  
      Kom->Nachrichten_Senden();
    }

  return true;
}

// -----------------------------------------------------------------

void FAnlage::ExtendDialogButton(Ident& button)
{// Wird bei Mausklick auf die Dialog-Buttons aufgerufen

  if (button=="continue")
    {// "continue" angeklickt?

      CloseDialog();
      DestroyDialog();

      // Im Fenster zur manuellen Initialisierung auffordern.
      Text DialogContense;
      DialogContense+= "Correct the positions, now!";
      
      OpenMsgDialog(*this->ed, "Control_Info",
 		   DialogContense.to_charPtr(),false,"\"Settings complete\"");
    }
  else if (button=="Settings complete")
    {// "Settings complete" angeklickt?

      CloseDialog();
      DestroyDialog();
      
      // Steuerungsprozess in Slavemodus versetzen. 
      Kom->Nachricht("AGNES");
      Kom->Nachrichten_Senden();
      
      // Beenden aller Auftraege externer Transitionen
      // Die Liste der externen Transitionen durchgehen
      Iterator<FTrans *> TransZusatzIter = TransZusatz;
      for (FTrans *k=TransZusatzIter; k; k=++TransZusatzIter)
	k->Ende();

      einstellungs_modus=false;
    }
}

// *********** Klassenimplementierung FAnlage (Ende) ******************
