#ifndef HCPNUnfolder_H
#define HCPNUnfolder_H
// ----------------------------------------------------------------------------
// HCPNUnfolder -- Module to convert a HCPN to an EDSPN
// ----------------------------------------------------------------------------
// includes
// ----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
//for Motif
#include "xbefore.h"
#include <Xm/ToggleB.h>
#include <Xm/PushB.h>
#include "xafter.h"
//from Agnes/inc
#include "linked.h"
#include "commmod.h"
#include "module.h"
#include "main.h"
#include "editor.h"
#include "net.h"
#include "node.h"
#include "netcl.h"
#include "dialog.h"
#include "wrapper.h"
#include "list.h"
#include "position.h"
//for generation of .table-file
#include "interface.h"
#include "HCPN2EDSPN.h"
// ----------------------------------------------------------------------------
// class HCPN2Unfolder, module to convert a HCPN net to a EDSPN (unfold)
class HCPNUnfolder: virtual public CommModule, public Wrapper<HCPNUnfolder,bool>,
		    public HCPN2EDSPN
{
protected:

  Editor* ed;
  Page* p;
  FileSelector<HCPNUnfolder,EditorP> fsel;

  int         pid;
  bool CreateTableFile(Text& netname); //create .table-file that is used by uncolor
  bool CallUncolor(Text& netname); //call external program uncolor
  void SaveEDSPN(Editor* ed, char* filename, bool ok);  //write EDSPN to file
 
public:

  HCPNUnfolder(Net& n);
  ~HCPNUnfolder();
 
  bool  Init() { return net.Prime()->Class()->Name() == "HCPN";}; 
  bool  Open(Editor&,Page&);
  bool  Change(Editor&,Page&,Page&) {return false;};
  bool  Menu(Editor&,Page&,Ident&,bool);
  bool  Event(Editor&,Page&,EventInfo&,bool) {return false;};
  bool  CreateEntry(Editor*, char*, WidgetClass, Widget /*parent*/);
};

#endif
