// -----------------------------------------------------------------
// Importe
// -----------------------------------------------------------------

#include "HCPNtokengam.h"

 //AH Changed Start replaced numerous charP(_bla_) by _bla_.to_charPtr()
 // typecasts charP(_bla_) removed where they are unnecessary: Text += Text
 // inserted numerous .to_bool()
 //AH Changed End 

MODULE_NOTIFY(HCPNTokengame)

// -----------------------------------------------------------------
// HCPNTokengame-Klassendefinition Hilfsfunktionen
// -----------------------------------------------------------------

Text HCPNTokengame::Bool2Text(bool value)
{
  return (value ? Text("true") : Text("false"));
}

Text HCPNTokengame::Int2Text(int value)
{
  char buf[17];
  sprintf(buf,"%d",value);
  return Text(buf);
}

// -----------------------------------------------------------------

Text HCPNTokengame::Int2Steps(int value)
{
  if (value == 1)
    return Text("onestep");
  else if (value == 10)
    return Text("tensteps");
  else
    return Text("fiftysteps");
}

// -----------------------------------------------------------------

int HCPNTokengame::Steps2Int(StructP params)
{
  if (params->GetMember("steps"))
    {
      charP member= (*params->GetMember("steps")).to_charPtr();
      
      if (!strcmp(member,"onestep"))
	return (1);
      else if (!strcmp(member,"tensteps"))
	return (10);
      else if (!strcmp(member,"fiftysteps"))
	return (50);
      else return (1);
    }
  return 1;
}

// -----------------------------------------------------------------

void HCPNTokengame::SetSpeed()
{
  if (RealTime)
    Speed= (signed int)(LowestSpeed*FastestTimePercentage);
  else
    Speed= 0;
  SpeedCnt= Speed;
}

// -----------------------------------------------------------------

void HCPNTokengame::ConnectionWithSlave(Text& netname)
{
  Error error(*this->ed);
  Text sim_dir= tnet_dir + "/MSSimulation/bin/";
  Text infile=  netname - NETFILENAME + TABLEFILENAME;
  Text outfile= netname - NETFILENAME + OUTFILENAME;
  
  ofstream file(infile.to_charPtr());
  
  AnalyserInterface::DescribeSymbols(net.Prime(), file, false); 
  // Alle Definitionen des Netzes speichern
  AnalyserInterface::DescribePage(net.Prime(), file, false, error);
  // Die Beschreibumg aller Bestandteile aller Seiten des Netzes speichern
  
  file.close();
  if (!file) cout << "HCPNTokengame: i cannot create the table-file!" << endl;
  
  Text params = sim_dir + "slave" + " -g " + " -n " + netname - NETFILENAME;

  pid= Exec(params.to_charPtr(), outfile.to_charPtr(), infile.to_charPtr());
  // Simulator aufrufen mit Parametern Params
}

// -----------------------------------------------------------------
// HCPNTokengame-Klassendefinition Tokengamefunktionen
// -----------------------------------------------------------------

bool HCPNTokengame::IsPlace(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Place") ? true : false);
}

// -----------------------------------------------------------------

bool HCPNTokengame::IsTransition(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Transition") ? true : false);
}

// -----------------------------------------------------------------

TextP HCPNTokengame::GetMarking(NodeP node)
{
  return TextP(node->Attr("marking"));
}

// -----------------------------------------------------------------

TextP HCPNTokengame::GetColor(NodeP node)
{
  return (TextP(node->Attr("selcol")));
}

// -----------------------------------------------------------------

void HCPNTokengame::StartTokengame()
{
  if (strrchr(FileName(), '/')==NULL)
    {// no pathname?

      netname= model_dir;
      netname+= '/';
      netname+= FileName();
    }
  else
    netname= FileName();

  FILE* fpt;
  Text DialogContense;
  Text outfile=  netname - NETFILENAME + OUTFILENAME;
  Text firefile= netname - NETFILENAME + FIREFILENAME;
  
  if ((fpt= fopen(outfile.to_charPtr(), "r")))
    {
      fclose(fpt);

      DialogContense+= "file: '<model>.out' already exists,\n";
      DialogContense+= "maybe another tokengame is running,\n";
      DialogContense+= "you have to remove it from the $MODELDIR!";
      
      OpenMsgDialog(*this->ed, "HCPNTokengame_Error",
 		    DialogContense.to_charPtr(),true,"\"reset marking\" \"keep current marking\"");
      return;
    }
  DialogContense+= "Instructions:\nto fire a transition,\n";
  DialogContense+= "double-click on the right mouse-button!";
  
  OpenMsgDialog(*this->ed, "HCPNTokengame_Info",
 		DialogContense.to_charPtr(),false,"Ok");

  Text rname= netname-NETFILENAME;
  ConnectionWithSlave(rname);
  // Slave starten
  
  ofstream FireFile(firefile.to_charPtr(), ios::trunc); FireFile.close();
  // firefile loeschen
}

// -----------------------------------------------------------------

void HCPNTokengame::EndTokengame()
{
  AniEnable=  false;
  StepsCnt= Steps;
  BackwardEnable= false;
  ForwardEnable= false;

  if (pid) 
    {
      kill(pid, SIGINT);
      pid= 0;
      // Stoppen der Simulation
      
      Text infile=   netname - NETFILENAME + TABLEFILENAME;
      Text outfile=  netname - NETFILENAME + OUTFILENAME;
      Text firefile= netname - NETFILENAME + FIREFILENAME;
      Text listfile= netname - NETFILENAME + LISTFILENAME;
      remove(infile.to_charPtr());
      remove(outfile.to_charPtr());
      remove(firefile.to_charPtr());
      remove(listfile.to_charPtr());
    }
  
  Received= false;
}

// -----------------------------------------------------------------

void HCPNTokengame::OpenOptionsMenu()
{
  Text DialogContense;
  
  DialogContense+= Text("[enum ( \"1 step\" onestep, ");
  DialogContense+= Text("\"10 steps\" tensteps, ");
  DialogContense+= Text("\"50 steps\" fiftysteps ) ");
  DialogContense+= Text("\"Steps for Forward/Backward\"steps= ");
  DialogContense+= Int2Steps(Steps);
  DialogContense+= Text(";bool \"RealTime-Animation\" realtime= ");
  DialogContense+= Bool2Text(RealTime);
  DialogContense+= Text(";int[1,100] \"Duration to Display the Lowest Transition\" lowest= ");
  DialogContense+= Int2Text (LowestSpeed);
  DialogContense+= Text("]");
  CreateDialog(DialogContense.to_charPtr());

  OpenDialog(*this->ed, "HCPNTokengame_Control", 
	     "Animate Backward Forward Stop Close");
}

// -----------------------------------------------------------------

void HCPNTokengame::OpenFireMenu(Node& node)
{
  Text DialogContense;
  ValueP val;
  int max,tmp;

  this->node= &node;
  // Dieser Knoten soll schalten

  FireItemP item;
  Iterator<FireItemP> FireList= ReadyToFire;
  for (item= FireList; (item && *item!=&node); item=++FireList);
  // Such das FireItem, mit der Trans. die gefeuert werden soll!

  if (item)
    {
      if (item->Bindings.Length() > 1)
	{
	  max= tmp= 0;
	  DialogContense+=("(enum(");
	  
	  Iterator<int*> bindings=item->Bindings;
	  for (int* b=bindings; b; b=++bindings) 
	    {// Alle feuerbaren Bindings traversieren

	      val= ((ListP)(node.Attr("bindings")))->GetEntry(*b);
	      // Binding holen
 	      if ((tmp= strlen((*TextP(val)).to_charPtr())) > max)
		max= tmp;
	      // maximale Laenge aller Bindings merken

 	      DialogContense+= Text("\"");
 	      DialogContense+= (*TextP(val));
 	      DialogContense+= Text("\" binding");
	      DialogContense+= double(*b);
 	      DialogContense+= Text(" , ");
	    }
 	  DialogContense+= Text(")");
 	  DialogContense+= Text("\" \" binding= binding");
	  DialogContense+= double(**item->Bindings[0]);
 	  DialogContense+= Text(";)");
	  
 	  setup= new Struct((DialogContense).to_charPtr());
	  dialog.Create("HCPNTokengameFireDialog",
			"select binding to fire",
 			//AH Changed Start DialogCallback => &HCPNTokengame::DialogCallback
 			this->ed->Shell(),false,&HCPNTokengame::DialogCallback,"Ok Cancel");
                        //AH Changed End

	  Arg arg={"width",max*6+50};
	  XtSetValues(Widget(dialog),&arg,1);
	  // set width

	  setup->EnterDialog(dialog,false);
	  dialog.Manage();
	}
      else if (Received)
	{
	  Fire(item, *item->Bindings[0]);
	  // feuern des ersten schaltfaehigen bindings
	}
    }
}

// -----------------------------------------------------------------

Text ConstructName (NodeP node)
{
  NodeP h_node;
  if ((h_node= node->GetPage()->Parent()))
    return ConstructName(h_node) + Text("\\") + node->Name();
  else
    return (Text("\\__ROOT__\\") + node->Name());
}

// -----------------------------------------------------------------

void HCPNTokengame::Fire(FireItemP item, intP binding)
{
  Received= false;
  item->Fire(binding, this);
}

// -----------------------------------------------------------------

void HCPNTokengame::FireTrans(NodeP node, int binding, bool Backward)
{
  Text nodename= ConstructName(node);

  Text firefile= netname - NETFILENAME + FIREFILENAME;
  
  ofstream FireFile(firefile.to_charPtr());
  // Oeffnen der Fire-Datei (open)

  if (Backward)
    FireFile << "Undo: ";
  
  FireFile << nodename.to_charPtr() << " " << binding << endl;

  FireFile << flush;

  FireFile.close();
  // Schliessen der Fire-Datei

  kill(pid, SIGUSR1);
  // Signal an den Slave

}

// -----------------------------------------------------------------

NodeP HCPNTokengame::FindNode(PageP pg, charP PathName, bool SearchForTrans, 
			      bool SelectSubTrans)
{
  Iterator<NodeP> ListNodes = pg->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)
    {// gehe alle Knoten dieser Page durch

      if (strcmp((node->Name()).to_charPtr(), PathName))
	continue;
      // gesuchten Knoten noch nicht gefunden?

      if (!IsTransition(node))
	if (!SearchForTrans && IsPlace(node)) 
	  return (node);
        else 
	  continue;
      // Knoten ist keine Transition aber die gesuchte  Stelle, dann fertig
      // weder noch, dann wietermachen

      //AH Changed Start => (char *)
      charP NextPath= strtok((char *)NULL,"\\");
      //AH Changed End

      if ((!NextPath &&  node->SubPage()) || (NextPath &&  !node->SubPage()))
 	//AH Changed Start =>(NodeP)
 	return ((NodeP)NULL);
        //AH Changed End

      if (!node->SubPage())
	{
	  return (node);
	  // Elementartransition: dann fertig
	}
      else
	{
	  if (SelectSubTrans && SearchForTrans)
	    if (!node->Selected())
	      {
		node->Select(true);
		// Als eingetragen vermerken

		FireItemP item= new FireItem(node);
		ReadyToFire.Append(item);
		// SubTransition zum blinken eintragen
	      }
	  return (FindNode(node->SubPage(), NextPath, SearchForTrans, 
			   SelectSubTrans));
	  // Elementartransition in dem SubNetz heraussuchen
	}
    }
  //AH Changed Start =>(NodeP)
  return ((NodeP)NULL);
  //AH Changed End
}

// -----------------------------------------------------------------

bool HCPNTokengame::ReadInput(ifstream& infile)
{
  char buffer[MAX_LENGTH];

  infile >> buffer;

  if (!strcmp(buffer,"Place-List:"))
    {

#ifdef __OUTLIST__
      cout  << endl << buffer << endl << endl;
#endif

      infile >> buffer;
      while (!infile.eof() && strcmp(buffer,"Transition-List:"))
	{
#ifdef __OUTLIST__
	  cout << buffer << " ";
#endif

	  NodeP node= FindNode(net.Prime(), strtok(buffer,"\\"), false, 
			       !AniEnable);

	  if (!node)
	    return false;
	  
	  infile >> buffer;	
#ifdef __OUTLIST__
	  cout << buffer << endl;
#endif
	  
	  TextP marking= GetMarking(node);
	  if (!strcmp(buffer,"0"))
	    *marking= "";
	  else
	    *marking= buffer;

	  infile >> buffer;		  
	}
#ifdef __OUTLIST__
      cout << endl;
#endif
    }
  if (!strcmp(buffer,"Transition-List:"))
    {
#ifdef __OUTLIST__
      cout << buffer << endl << endl;
#endif
      infile >> buffer;
      // Namen einlesen

      while (!infile.eof() && strcmp(buffer,"Fastest:"))
	{// solange die Datei noch nicht zu Ende ist
	  // und die naechsten Meldungen noch nicht da sind
	  
#ifdef __OUTLIST__
	  cout << buffer << " ";
#endif
	  
	  NodeP node= FindNode(net.Prime(), strtok(buffer,"\\"), true, 
			       true);
	  // Finde den Zeiger auf die Transition
	  
	  if (!node)
	    return false;
	  
	  FireItemP item= new FireItem(node);
	  // neues FireItem

	  while (!infile.eof())
	    {// Solange noch bindings kommen tue
	      
	      int* index= new int;
	      infile >> *index;
	      // neuen Index fuer Binding-Index Liste erzeugen
	      
	      if (*index < 0) 
		{
		  delete(index);
		  break;
		}
#ifdef __OUTLIST__
	      cout << *index << ",";
#endif
	      
	      item->Bindings.Append(index);
	    }
#ifdef __OUTLIST__
	  cout << endl;      
#endif
	  ReadyToFire.Append(item);
	  
	  infile >> buffer;
	  // Namen einlesen
	}

      if (!infile.eof())
	{
	  int FastestT;
	  
	  infile >> FastestT;
#ifdef __OUTLIST__
	  cout << "fastest: " << FastestT << " ";      
#endif
	  FireItemP item;
	  for (int i= 0; i<ReadyToFire.Length(); i++)
	    {// Alle Transitionen und SubTransitionen,
	      // die feuern koennen
	      
	      item= *(ReadyToFire[i]);
	      NodeP node= item->node;
	      
	      if (!node->SubPage())
		if(!FastestT--)
		  break;
	    }
	  this->Fastest= item->node;
	  
	  if (this->FastestB)
	    delete(this->FastestB);
	  this->FastestB= new int;

	  infile >> *this->FastestB;
#ifdef __OUTLIST__
	  cout << *this->FastestB << " ";      
#endif
	  *this->FastestB= **item->Bindings[*this->FastestB];

	  infile >> this->FastestTimePercentage;

	  SetSpeed();

#ifdef __OUTLIST__
	  cout << Speed << endl;      
#endif
	}
    }
  else
    {
      Text DialogContense= "";
      DialogContense+= buffer;
      
      char c; 
      if (!infile.eof())
        c= (char)infile.get();

      while (!infile.eof())
	{// solange noch Meldungen da sind      
	  DialogContense+= c;
	  c= (char)infile.get();
	}
      CreateDialog();
      OpenMsgDialog(*this->ed,"HCPNTokengame-Error", DialogContense.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");

      infile.close();
      
      return (false);
      // Das Einlesen schlug fehl
    }
  return true;
  // Das Einlesen hat geklappt
}

// -----------------------------------------------------------------

bool HCPNTokengame::SelectEnabledTrans(PageP)
{// Wird zyklisch aufgerufen

  if (pid)
    {
      if (!Received)
	{
	  char buffer[MAX_LENGTH];
	  
	  Text infile= netname - NETFILENAME + LISTFILENAME;
	  Text outfile= netname - NETFILENAME + OUTFILENAME;
	  // richtiger Pfad!
	  
 	  ifstream OutFile((outfile).to_charPtr());
	  // Eingabestrom mit der Ausgabedatei
	  
	  if (OutFile)
	    {// Datei erfolgreich geoeffnet?
	      
	      OutFile.seekg(0, ios::end);
	      int FileEnd= OutFile.tellg();
	      // FilePointer am Ende der Datei ermitteln
	      
	      if (FileEnd)
		{// kamen Meldungen hinzu?
		  OutFile.seekg(0, ios::beg);
		  OutFile >> buffer;
cout << "<" << buffer << ">" << endl;
		  if (strcmp(buffer, "End_Tokengame"))
		    {
		      Text DialogContense= "";
		      DialogContense+= buffer;
		      
		      char c; 
		      if (!OutFile.eof())
			c= (char)OutFile.get();
		      
		      while (!OutFile.eof())
			{// solange noch Meldungen da sind      
			  DialogContense+= c;
			  c= (char)OutFile.get();
			}
		      CreateDialog();
		      OpenMsgDialog(*this->ed,"HCPNTokengame-Error", 
 				    DialogContense.to_charPtr(), true, "\"reset marking\" \"keep current marking\"");
		      
		      OutFile.close();
		      
		      return false;
		    }
		}
	      OutFile.close();
	    }
	  
 	  ifstream ListFile((infile).to_charPtr());
	  // Eingabestrom mit der Liste der
	  // schaltfaehigen bindings
	  
	  if (ListFile)
	    {// Datei erfolgreich geoeffnet?
	      
	      ListFile.seekg(0, ios::end);
	      int FileEnd= ListFile.tellg();
	      // FilePointer am Ende der Datei ermitteln
	      
	      ListFile.close();
	      
	      if (FileEnd)
		{// kamen neue Transitionen hinzu?
		  
		  DeselectAllTrans();
		  ReadyToFire.Clear();
		  
 		  ifstream ListFile((infile).to_charPtr());
		  // Eingabestrom mit der Liste der
		  // schaltfaehigen bindings
		  
		  if (!ReadInput(ListFile))
		    {
		      return false;
		    }
		  // ListFile nach Listen durchsuchen
		  
		  Received= true;
		  
		  SetModified();
		  // Das Netz wurde modifiziert
		  
		  ListFile.close();
		  
 		  ListFile.open(infile.to_charPtr(), ios::trunc); ListFile.close();
		  // infile loeschen
		}
	    }
	}
      if (ReadyToFire.Length())
	{
	  /*AH CHANGED START:
	    mark transitions as selected,
	    then update page only once for 
	    all transitions
	  */
	  for (int i= 0; i<ReadyToFire.Length(); ++i)
	    (*ReadyToFire[i])->node->MarkSelected(true);
	  // Alle Transitionen und SubTransitionen,
	  // die feuern koennen, selektieren         
	 
	  /*AH CHANGED update visible page*/
	  net.GetPage(this->ed)->Update();
	  
	  if (Received && BackwardEnable)
	    {
	      if (!--StepsCnt || !FiredCount)
		{
		  BackwardEnable= false;
		  StepsCnt= Steps;
		}
	      
	      if (FiredCount)
		{
		  FiredItemP item= *Fired[FiredCount-1];
		  
		  SelectTrans(item->node);
		  
		  if (FiredCount==FiredCount_save)
		    {
		      Text DialogContense;
 		      DialogContense+= Text("Warning: this command ").to_charPtr();
 		      DialogContense+= Text("may lead to an inconsistent  net-status, ").to_charPtr();
 		      DialogContense+= Text("if you changed the net!").to_charPtr();
		      
		      OpenMsgDialog(*this->ed, "HCPNTokengame_Warning",
 				    DialogContense.to_charPtr(),false,"Ok");
		    }
		  
		  Received= false;
		  
		  item->Do(BACKWARD, this);  
		}
	    }
	  else if (Received && ForwardEnable)
	    {
	      if (!--StepsCnt || FiredCount==Fired.Length())
		{
		  ForwardEnable= false;
		  StepsCnt= Steps;
		}
	      
	      if (FiredCount<Fired.Length())
		{
		  FiredItemP item= *Fired[FiredCount];
		  
		  SelectTrans(item->node);
		  
		  Received= false;
		  
		  item->Do(FORWARD, this);
		}
	    }
	  else if (Received && AniEnable)
	    {
	      SelectTrans(this->Fastest);
	      
	      if (--SpeedCnt == -1)
		{
		  SpeedCnt= Speed;
		  
		  FireItemP item;
		  Iterator<FireItemP> FireList= ReadyToFire;
		  for (item= FireList; (item && *item!=this->Fastest); 
		       item=++FireList);
		  // Such das FireItem, mit der schnellsten Transition
		  
		  if (item)
		    Fire(item, FastestB);
		  // feuern
		}
	      this->ed->Update();
	      // Editor-Screen update
	    }
	}
    }

  return true;
}

// -----------------------------------------------------------------

bool HCPNTokengame::DeselectEnabledTrans(PageP)
{// Wird zyklisch aufgerufen

  if (pid)
    {
      if (AniEnable || BackwardEnable || ForwardEnable)
	{
	  FireItemP item;
	  Iterator<FireItemP> FireList= ReadyToFire;
	  for (item= FireList; (item && *item!=this->Fastest); 
	       item=++FireList);
	  // Such das FireItem, mit der schnellsten Transition
	  
	  if (item)
	    DeselectTrans(item->node);
	  // Deselektieren
	}
      else 
	{
	  Iterator<FireItemP> FireList= ReadyToFire;
	  for (FireItemP item= FireList; item; item=++FireList)
	    if (!item->node->SubPage())
	      item->node->Select(false);
	  // alle schaltfaehigen Elementartransitionen deselektieren 
	}
    }

  return true;
}

// -----------------------------------------------------------------

void HCPNTokengame::OnDialogButton(Ident& button)
{// Wird bei Mausklick auf die Dialog-Buttons aufgerufen

  ExtendDialogButton(button);

  StructP params= GetParams();

  if ((button=="reset marking"))
    {// END angeklickt?

      DeInitTokengame(true);
      
      CloseDialog();
      DestroyDialog();
    }
  if ((button=="keep current marking"))
    {// END angeklickt?

      if (!EventEnable())
	{
	  Text DialogContense;
 	  DialogContense+= Text("you must first stop the animation").to_charPtr();
	  
	  CloseDialog();
	  DestroyDialog();

	  OpenMsgDialog(*this->ed, "HCPNTokengame_Warning",
 			DialogContense.to_charPtr(),false,"Ok");

	  TokenGameEnable= true;
	  XmToggleButtonSetState(this->ToggleWidget,true,true);
	  // ToggleButton selektieren
	}
      else
	{
	  DeInitTokengame(false);
	  
	  CloseDialog();
	  DestroyDialog();
	}
    }
  else if ((button=="Forward") && !AniEnable && !BackwardEnable && !ForwardEnable)
    {// Forward angeklickt?

      Steps= Steps2Int(params);
      StepsCnt= Steps;
      if (params->GetMember("realtime"))
 	RealTime= ((*params->GetMember("realtime")).to_bool());
      if (params->GetMember("lowest"))
 	LowestSpeed= ((*params->GetMember("lowest")).to_int());
      SetSpeed();

      ForwardEnable= true;
    }
  else if ((button=="Backward") && !AniEnable && !BackwardEnable && !ForwardEnable)
    {// Backward angeklickt?

      Steps= Steps2Int(params);
      StepsCnt= Steps;
      if (params->GetMember("realtime"))
 	RealTime= ((*params->GetMember("realtime")).to_bool());
      if (params->GetMember("lowest"))
 	LowestSpeed= ((*params->GetMember("lowest")).to_int());
      SetSpeed();

      BackwardEnable= true;
    }
  else if ((button=="Animate") && !AniEnable && !BackwardEnable && !ForwardEnable)
    {// Animate  angeklickt?

      Steps= Steps2Int(params);
      StepsCnt= Steps;
      if (params->GetMember("realtime"))
 	RealTime= ((*params->GetMember("realtime")).to_bool());
      if (params->GetMember("lowest"))
 	LowestSpeed= ((*params->GetMember("lowest")).to_int());
      SetSpeed();

      AniEnable= true;
    }
  else if ((button=="Stop"))
    {// Stop  angeklickt?

      Steps= Steps2Int(params);
      StepsCnt= Steps;
      if (params->GetMember("realtime"))
 	RealTime= ((*params->GetMember("realtime")).to_bool());
      if (params->GetMember("lowest"))
 	LowestSpeed= ((*params->GetMember("lowest")).to_int());
      SetSpeed();

      AniEnable=  false;
      BackwardEnable= false;
      ForwardEnable= false;
    }
  else if (button=="Close")
    {// Close angeklickt?

      Steps= Steps2Int(params);
      StepsCnt= Steps;
      if (params->GetMember("realtime"))
 	RealTime= ((*params->GetMember("realtime")).to_bool());
      if (params->GetMember("lowest"))
 	LowestSpeed= ((*params->GetMember("lowest")).to_int());
      SetSpeed();
	      
      CloseDialog();
      DestroyDialog();
    }
  else if (button=="Cancel")
    {// Cancel angeklickt?

      TokenGameEnable= true;
      XmToggleButtonSetState(this->ToggleWidget,true,true);
      // ToggleButton selektieren

      CloseDialog();
      DestroyDialog();
    }
  else if (button=="Ok")
    {// Ok angeklickt?

      CloseDialog();
      DestroyDialog();
    }
}

void HCPNTokengame::DialogCallback(Dialog<HCPNTokengame,bool>& dia,bool,Ident& btn)
{
  if(Received && TokenGameEnable && btn=="Ok")
    {// OK angeklickt waehrend das HCPNTokengame laeuft?
      setup->EvalWidget();

      FireItemP item;
      Iterator<FireItemP> FireList= ReadyToFire;
      for (item= FireList; (item && *item!=node); item=++FireList);
      // Such das FireItem, mit der Trans. die gefeuert werden soll!
      
      int* b;
      Iterator<int*> bindings=item->Bindings;
      for (b=bindings; b; b=++bindings) 
	{// Alle feuerbaren Binding-Indices traversieren
	  
	  Text member;
	  member+= "binding";
	  member+= double(*b);
 	  if (member==((*setup->GetMember("binding")).to_charPtr())) break;
	  // welches binding wurde ausgewaehlt?
	}
      
      if (b)
	Fire(item, b);

      dia.Close();
    }	
  else if (btn=="Cancel")
    dia.Close();

  delete(setup);
}

// -----------------------------------------------------------------
