#include <iostream.h>

#include "module.h"
#include "main.h"
#include "editor.h"
#include "net.h"
#include "object.h"
#include "netcl.h"
#include "dialog.h"

#ifndef NoExplicitInstanciation
#define NoExplicitInstanciation
#include "dialog.cc"
#include "wrapper.cc"
DIAINSTANCIATE(NetExaminer,bool)
#endif

class NetExaminer;
class NetExaminer: public Module
{
	Dialog<NetExaminer,bool> dialog;
	char buf[1024];

public:
	NetExaminer(Net& n): Module(n,"Net Examiner"),dialog(this) {}
	bool Init() { return true; } // unabhaengig von net immer zustaendig
	bool Open(Editor&,Page&) { return true; } // autom. Eintrag erzeugen
	bool Change(Editor&,Page&,Page&) { return true; }
	void Call(Editor& e,Page& pg) // bei Anwahl o.g. Eintrages aufgerufen
	{
		if (!dialog)
		{
			ostrstream os(buf,1024);
			
			// Objekte in der aktuellen Page untersuchen..
			int nodes=0,conns=0,ports=0,vconns=0;
			Iterator<Object*> iter=pg.Objects();
			for (Object* ob=iter; ob; ob=++iter)
				if (ob->IsNode())
				{
					nodes++;
					if (ob->Virtual()) ports++;
				}
				else
				{
					conns++;
					if (ob->Virtual()) vconns++;
				}
			
			// Message zusammenkleben
			os<<"Information about Net '"<<net.FileName()<<"'"<<endl<<endl;
			os<<"Net class is "<<net.Class()->Name()<<'.'<<endl;
			os<<"Current page contains "<<pg.NumObjects()<<" objects."<<endl;
			os<<"In detail "<<nodes<<" nodes ("<<ports<<" Portnode(s)) and"<<endl;
			os<<conns<<" connectors, "<<vconns<<" of them virtual."<<endl;
			os<<ends;
			
			// Und anzeigen
			dialog.OpenMsg("NetExaminer","Net Examiner",e.Shell(),
				XmDIALOG_INFORMATION,buf,false);
		}
	}
};

MODULE_NOTIFY(NetExaminer)
