#include "fkomm.h"

// *********** Klassenimplementierung T_FKommunikation (Anfang) ******************

  T_FKommunikation::T_FKommunikation(const char Empfang_name[],
		   const char Sende_name[])
    {
      sende_puf=0;
      empfang_name=new char[strlen(Empfang_name)+1];
      strcpy(empfang_name, Empfang_name);
      sende_name=new char[strlen(Sende_name)+1];
      strcpy(sende_name, Sende_name);
    }

  T_FKommunikation::~T_FKommunikation()
    {
      delete sende_puf;
      delete[] empfang_name;
      delete[] sende_name;
    }

  char *T_FKommunikation::Nachricht()
    {
      char *merke=Empf_Akt;
      
      if (Empf_Akt)
        // Es existiert eine aktuelle ungelesene Nachricht
	{
	  Empf_Akt=strchr(Empf_Akt, '\n');
	  if (Empf_Akt)
            // Es gibt noch noch eine weitere ungelesene Nachricht
	    {
	      *Empf_Akt=0; // !!! kann sicher rausgeschmissen werden
	      Empf_Akt++;
	    }
	}

      return merke;
    }

  int T_FKommunikation::Nachrichten_Lesen()
    {
      Empf_Akt=0;
      fstream empf;
      unsigned int laenge;
      
  
      empf.open(empfang_name, ios::in);
      if (empf)
        // Datei erfolgreich geoeffnet
	{
          // Nachrichten aus der Datei lesen und die Laenge
          // des Inhalts ermitteln
	  empf.read(empf_puf, kommando_max);
	  empf_puf[empf.gcount()]=0;
	  	  
	  laenge=strlen(empf_puf);
	  if (laenge != 0)
            // Aus der Datei wurden Nachrichten gelesen
	    {
	      // Etwas umstaendlich, aber hiermit wird der Dateiinhalt geloescht;
	      empf.close();
	      empf.open(empfang_name, ios::in | ios::out | ios::trunc);
	      empf.flush();
	      empf.close();
	      
	      Empf_Akt=empf_puf;
	      return laenge;
	    }
	  else
	    return 0;
	}
      else
	return 0;
    }

  bool T_FKommunikation::Nachrichten_Senden()
    {
      if (sende_puf)
        // Es gibt zu sendende Nachrichten.
	{
	  int anfang,ende;
	  
	  fstream send;
	  
	  send.open(sende_name, ios::in | ios::out);
	  if (send)
            // Datei wurde erfolgreich geoeffnet.
	    {
              // Laenge des Dateiinhalts ermitteln
	      send.seekg(0, ios::end);
	      ende=send.tellg();
	      if (ende == 0)
                // Die Datei ist leer.
		{
                  // Alle Nachrichten aus dem Sendepuffer
                  // sende_puf in die Datei schreiben.
		  send.seekg(0, ios::beg);
		  anfang=send.tellg();
		  send.write(sende_puf, strlen(sende_puf));
		  delete sende_puf;
		  sende_puf=0;

		  send.flush();
		  send.close();
		
		  return true;
		}
	      else
		return false;
	    }
	  else
	    return false;
	}
      return false;
    }

  void T_FKommunikation::Nachricht(const char s[])
    {
      if (s)
        // Die Nachricht s ist nicht leer.
	if (sende_puf)
          // Es gibt schon Nachrichten im Sendepuffer.
	  {
            // Die neue Nachricht s an den Sendepuffer anhaengen.
	    char *dummy;
	    dummy=new char[strlen(sende_puf)+strlen(s)+2];
	    strcpy(dummy, sende_puf);
	    strcat(dummy, "\n");
	    strcat(dummy, s);
	    delete sende_puf;
	    sende_puf=dummy;
	  }
	else
          // Es gibt noch keine Nachrichten im Sendepuffer.
	  {
            // Die neue Nachricht s in den Sendepuffer schreiben.
	    sende_puf=new char[strlen(s)+1];
	    strcpy(sende_puf, s);
	  }
    }

// *********** Klassenimplementierung T_FKommunikation (Ende) ******************
