/* lost Features:
Korrektes fig31 Format bei (reihenfolge/zahl der Options)
Label: filled=true Interpretieren => WriteBox mit eigenem/festen Kontext

*/

 //AH Changed Start replaced numerous (char *) by _bla_.to_charPtr()
 //AH Changed End 

#include "xbefore.h"
#include <X11/Intrinsic.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include "xafter.h"

extern "C" {
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <math.h>
}

#include <iostream.h>
#include <fstream.h>

#include "module.h"
#include "main.h"
#include "filesel.h"
#include "editor.h"
#include "net.h"
#include "netcl.h"
#include "object.h"
#include "linked.h"

#include "label.h"
#include "format.h"
#include "compo.h"
#include "ellarc.h"
#include "pline.h"

#include "struct.h"

struct RGBValue
{
	int red,green,blue;
	RGBValue(int r,int g,int b): red(r),green(g),blue(b) {}
  //AH Changed bool inserted 2x
	bool operator ==(const RGBValue& v) const { return red==v.red && green==v.green && blue==v.blue; }
	bool operator !=(const RGBValue& v) const { return !(*this==v); }
};

#ifndef NoExplicitInstanciation
#define NoExplicitInstanciation
#include "linked.cc"
#include "dialog.cc"
#include "filesel.cc"
#include "wrapper.cc"
OINSTANCIATE(RGBValue)
DIAINSTANCIATE(XfigExporter,bool)
FSELINSTANCIATE(XfigExporter,Editor*)
#endif

class XfigExporter: public Module
{
	static int format; // 0=fig2.1mono, 1=fig31mono, 2=fig31color
	static int font,old_font; // 0..5
	static bool special,zoom,old_zoom,scale,old_scale;
	static Struct setup;

        // RD deleted: void DialogCallback ... 
	Dialog<XfigExporter,bool> dialog;
	Display* dpy;
	LinkedList<RGBValue> colors;
	
	FileSelector<XfigExporter,Editor*> fsel;
	void FselCallback(Editor*,char* file,bool ok);
	
	int Round(double x) { return int(x+0.5); }
	int Conv(double x) { return int((format?x*15.0:x)+0.5); }
	double DConv(double x) { return format?x*15.0:x; }
	int ColorOf(char* name);
        //AH Changed Start function inserted
        int ColorOf(Text & t) { return ColorOf(t.to_charPtr());}
        //AH Changed End
	RGBValue GetRGBValue(char* name);
	bool RoundedEdge(double r, Position& a, Position& b, Position& c, Position& g, Position& e, Position& f, Position& h);
		
	void XfigToXfig(Editor& ed,Page& page);
	void XfigToFile(Editor& ed);
	ostream& WriteColors(ostream& os,ExprData& ed,Iterator<Shape*> siter);
	ostream& WriteArc(ostream& os, Position& center, Position& p1, Position& p2, Position& p3, bool clockwise, Context& ctx);
	ostream& WriteLine(ostream& os, OpaqueIterator<Position> iter, Context& ctx);
	ostream& WriteLine(ostream& os, Position& start, Position& end, Context& ctx);
	ostream& WriteWhiteBox(ostream& os, Position& xy, Position& wh);
	ostream& WriteSpline(ostream& os, OpaqueIterator<Position> iter, Context& ctx);
	ostream& WriteColor(ostream& os,int idx,RGBValue& rgb);
	ostream& WriteFile(ostream& os,Display* dpy,double zoom,Page& page);
	ostream& WriteShape(ostream& os,Shape& s, ShapeData& sd,ExprData& ed);

public:
	XfigExporter(Net& n): 
		Module(n,"Xfig-Exporter"),dialog(this),fsel(this) {}
	bool Init() { return true; } // unabhaengig von net immer zustaendig
	bool Open(Editor&,Page&);
	bool Menu(Editor&,Page&,Ident&,bool before);

        void SPNLPrep();
        void SPNLFinish();
};

int XfigExporter::format = 2;
int XfigExporter::font = 0;
int XfigExporter::old_font = 0;
bool XfigExporter::special = true;
bool XfigExporter::scale = false;
bool XfigExporter::old_scale = false;
bool XfigExporter::zoom = false;
bool XfigExporter::old_zoom = false;

// RD deleted: Struct XfigExporter::setup ... 

MODULE_NOTIFY(XfigExporter)

void XfigExporter::SPNLPrep()
{
  old_font = font;
  font = 12; 
  old_zoom = zoom;
  zoom = false;
  old_scale = scale;
  scale = false;
}

void XfigExporter::SPNLFinish()
{
  font = old_font;
  zoom = old_zoom;
  scale = old_scale;
}

// RD deleted: void XfigExporter::DialogCallback ...


bool XfigExporter::Menu(Editor& ed, Page& p, Ident& name, bool)
{
	if (name=="XfigToXfig")
	{
		XfigToXfig(ed,p);
		return true;
	}
	else if (name=="XfigToFile")
	{
		XfigToFile(ed);
		return true;
	}
	// RD deleted: else if (name=="XfigOptions") ... 
	return false;
}


bool XfigExporter::Open(Editor& e, Page&)
{
    WrapperID dummy;
    // RD deleted:  if (e.GetNet()->Class()->Name()=="SPNL") {
    Widget ent=e.CreateEntry(name,xmCascadeButtonWidgetClass,e.Mods(),NULL,dummy);
    e.CreateEntries(e.CreatePulldown("Xfig-Popup",ent),xmPushButtonWidgetClass,
		    NULL,"XfigToXfig XfigToFile");
 
    /* RD deleted:  }
    else {
    Widget ent=e.CreateEntry(name,xmCascadeButtonWidgetClass,e.Mods(),NULL,dummy);
    e.CreateEntries(e.CreatePulldown("Xfig-Popup",ent),xmPushButtonWidgetClass,
		    NULL,"XfigToXfig XfigToFile _ XfigOptions");
    } */
    return false;
}


void XfigExporter::XfigToFile(Editor& ed)
{
	char* path = net.FileName();
	
 	//AH Changed Start 	FselCallback => &XfigExporter::FselCallback   tnet_dir=>tnet_dir.to_charPtr()
 	fsel.Open(ed.Shell(),"File to export the Xfig in?",&XfigExporter::FselCallback,&ed,
 		path ? path : tnet_dir.to_charPtr(),"Agnes/*.fig");
 	//AH Changed End
}


void XfigExporter::FselCallback(Editor* ed,char* file,bool ok)
{
	if (ok && net.GetPage(ed))
	{
		ed->Mouse(true);
		ofstream os(file);
		if(os) {
		  if (ed->GetNet()->Class()->Name()=="SPNL")
		    SPNLPrep();
		  WriteFile(os,ed->Dpy(),ed->Zoom(),*net.GetPage(ed));
		  if (ed->GetNet()->Class()->Name()=="SPNL")
		    SPNLFinish();
		}
		ed->Mouse(false);
	}
}

void XfigExporter::XfigToXfig(Editor& ed,Page& page)
{
	ed.Mouse(true);
	char buf[256]="xfig ";
	ofstream os(tmpnam(buf+5));
	if (os) {
	  if (ed.GetNet()->Class()->Name()=="SPNL")
	    SPNLPrep();
	  WriteFile(os,ed.Dpy(),ed.Zoom(),page);
	  if (ed.GetNet()->Class()->Name()=="SPNL")
	    SPNLFinish();
	}
	ed.Mouse(false);
	if (!os) return;
	strcat(buf,"&");
	system(buf);
}


/* MONO returns total intensity of r,g,b triple (i = .33R + .5G + .17B) 
   #define MONO(rd,gn,bl) ( ((int)(rd)*11 + (int)(gn)*16 + (int)(bl)*5) >> 5)
   Formel geklaut aus xv-Sourcen, gif.h
*/
int XfigExporter::ColorOf(char* name)
{
	RGBValue rgb = GetRGBValue(name);
	if (format==2)
		return 32+colors.Index(rgb); 
	else
		return ((rgb.red*11+rgb.green*16+rgb.blue*5) >> 5)<128?0:7;
}


ostream& XfigExporter::WriteArc(ostream& os, Position& center, Position& p1, Position& p2, Position& p3, bool clockwise, Context& context)
{
	os<<"5 1 "<<(context.dashed?"1 ":"0 ")<<Round(context.thick);
	os<<' '<<ColorOf(context.color); // (pen_)color
	if (format) os<<' '<<ColorOf(context.color); // fill_color
	os<<" 0"; // depth
	os<<" 0 "<<(format?"-1 ":"0 "); // pen areafill
	if (context.dashed) os<<Round(context.thick); else os<<"0.000"; // style_val
	if (format) os<<" 0"; // cap_style
	os<<(clockwise?" 1":" 0"); // direction
	os<<" 0 0"; // no arrows
	os<<' '<<DConv(center.x)<<' '<<DConv(center.y);
	os<<' '<<Conv(p1.x)<<' '<<Conv(p1.y);
	os<<' '<<Conv(p2.x)<<' '<<Conv(p2.y);
	return os<<' '<<Conv(p3.x)<<' '<<Conv(p3.y)<<endl;
}

ostream& XfigExporter::WriteLine(ostream& os, OpaqueIterator<Position> iter, Context& context)
{
	os<<"2 "<<(context.filled?"3":"1");
	os<<' '<<(context.dashed?"1 ":"0 "); // line_style
	os<<Round(context.filled?0:context.thick); // thickness
	os<<' '<<ColorOf(context.color); // (pen_)color
	if (format) os<<' '<<ColorOf(context.color); // fill_color
	os<<" 0"; // depth
	os<<" 0 "; // pen style
	if (format)
		os<<(context.filled?"20 ":"-1 ");
	else
		os<<(context.filled?"21 ":"0 ");
	if (context.dashed) os<<Round(context.thick); else os<<"0.000"; // style_val
	if (format) os<<" 0 0"; // join_style cap_style
	os<<" -1 0 0";
	if (format) os<<' '<<int(iter)+(context.filled?1:0);
	os<<endl<<"      ";
	for (Position* px=iter; px; px=++iter)
		os<<' '<<Conv(px->x)<<' '<<Conv(px->y);
	if (context.filled)
		os<<' '<<Conv(iter.First()->x)<<' '<<Conv(iter.First()->y);
		
	return format?(os<<endl):(os<<" 9999 9999"<<endl);
}

ostream& XfigExporter::WriteLine(ostream& os, Position& start, Position& end, Context& ctx)
{
	LinkedList<Position> pos;
	pos.Append(start); pos.Append(end);
	return WriteLine(os,OpaqueIterator<Position>(pos),ctx);
}

ostream& XfigExporter::WriteWhiteBox(ostream& os, Position& xy, Position& wh)
{
	Context ctx;
	ctx.filled = true;
	ctx.color = "white";

	LinkedList<Position> pos;
	pos.Append(xy);
	pos.Append(xy+Position(wh.x-1.0,0.0));
	pos.Append(xy+wh-Position(1,1));
	pos.Append(xy+Position(0.0,wh.y-1));
	return WriteLine(os,OpaqueIterator<Position>(pos),ctx);
}

bool XfigExporter::RoundedEdge(double r, Position& a, Position& b, Position& c, Position& g, Position& e, Position& f, Position& h)
{
	Position ba = a-b, bc = c-b;
	double bal = ba.Length(), bcl = bc.Length();
	double alpha = ba.Angle()-bc.Angle();
	if (alpha<0) alpha = -alpha;
	if (alpha>M_PI) alpha = 2*M_PI-alpha;
	if (r>bal) r = bal;
	if (r>bcl) r = bcl;
	double x = r/tan(alpha/2), m = r/sin(alpha/2);
	if (x<r/3) return false;
	
	e = b+ba*x/bal;
	f = b+bc*x/bcl;
	Position d = (e+f)/2-b;
	d /= d.Length();
	g = b+d*m;
	h = b+d*(m-r);
	return true;
}


ostream& XfigExporter::WriteSpline(ostream& os, OpaqueIterator<Position> iter, Context& ctx)
{
	double r = ctx.spline;
	Position prev = *PositionP(iter), curr = *++iter, *next;
	while ((next = ++iter))
	{
		Position amid,aprev,anext,atop;
		if (RoundedEdge(r,prev,curr,*next,amid,aprev,anext,atop))
		{
			if (prev!=aprev) WriteLine(os,prev,aprev,ctx);
			double dir = (curr-prev).Angle() - (*next-curr).Angle();
			if (dir<-M_PI) dir+= 2*M_PI; else if (dir>M_PI) dir -= 2*M_PI;
			WriteArc(os,amid,aprev,atop,anext,dir>0,ctx);
			curr = anext;
		}
		else
			WriteLine(os,prev,curr,ctx);	
		prev = curr;
		curr = *next;
	}
	return WriteLine(os,prev,curr,ctx);
}


ostream& XfigExporter::WriteShape(ostream& os, Shape& s, ShapeData& sd,ExprData& ed)
{
	Context& context=s.GetContext();
	context.Evaluate(ed);
	
	if (context.condition)
	{
		Ident name(s.Type());
		if (name=="compo")
		{
			Compo& c = (Compo&)s;
			Iterator<Shape*> iter = c.Shapes();
			Position oldpos = sd.pos;

			sd.pos += c.Offset();
			for (Shape* subs=iter; subs; subs=++iter)
				WriteShape(os,*subs,sd,ed);
			sd.pos = oldpos;
		}
		else if (name=="pline")
		{
			Pline& p = (Pline&)s;
			LinkedList<Position> pos(p.Positions(sd));
			OpaqueIterator<Position> iter(pos);
			if (context.spline)
				WriteSpline(os,iter,context);
			else
				WriteLine(os,iter,context);
			}
		else if (name=="ellarc")
		{
			Ellarc& e = (Ellarc&)s;
			Position pos = e.Pos(sd), rad = e.Radius(sd);
			
			os<<"1 1 "<<(context.dashed?"1 ":"0 ")
				<<Round(context.filled?0:context.thick);
			os<<' '<<ColorOf(context.color); // (pen_)color
			if (format) os<<' '<<ColorOf(context.color); // fill_color
			os<<" 0 0 "; // depth pen_style
			if (format)
				os<<(context.filled?"20 ":"-1 ");
			else
				os<<(context.filled?"21 ":"0 ");
			if (context.dashed) os<<Round(context.thick); else os<<"0.000"; // style_val
			os<<" 1 0.000"; // direction angle
			os<<' '<<Conv(pos.x)<<' '<<Conv(pos.y);
			os<<' '<<Conv(rad.x)<<' '<<Conv(rad.y);
			os<<' '<<Conv(pos.x+rad.x)<<' '<<Conv(pos.y);
			os<<' '<<Conv(pos.x+rad.x)<<' '<<Conv(pos.y);
			os<<endl;
		}
		else if (name=="label")
		{
		  XFontStruct* normal = XLoadQueryFont(dpy,"-*-courier-medium-r-*-*-13-*-*-*-*-*-*-*"); // fuer XTextExtents
		  XCharStruct xc; // fuer XTextExtents
		  int d; // fuer XTextExtents
		    
		  Format& l = (Format&)s; // bleibt konstant
		  Text text = l.LabelText(ed); // wird "uber akt_str ver"andert!
		  int akt_len = 0; // aktuelle Zeilenl"ange
 		  char* akt_str = text.to_charPtr(); // Beginn der aktuell zu schreibenden Zeile
		  bool end_reached = !akt_str; // Gibt an, ob Ende des Labels erreicht ist
		  int akt_line = 0; // Nummer der aktuellen Zeile
		  
		  while (!end_reached) {
		    ++akt_line;
		    // Ende der aktuellen Zeile suchen
		    for (akt_str+=akt_len,akt_len=0; *(akt_str+akt_len) &&
			   *(akt_str+akt_len)!='\n'; ++akt_len);
		    if (!*(akt_str+akt_len))
		      end_reached=true;
		    else {
		      *(akt_str+akt_len)='\0'; // newline durch Stringende ersetzen
		      ++akt_len; // Anzahl Zeichen bis n"achsten Zeilenanfang
		    }
 		    if ((Text(akt_str)).to_bool() && *((Text(akt_str)).to_charPtr()))
		    {
		      Position pos = l.Pos(sd);
		      int asc,desc,width;
		      if (font==12) { 
			XTextExtents(normal,akt_str,strlen(akt_str),&d,&asc,&desc,&xc);
			width = xc.width;
		      }
		      else
 			//AH Changed Start context.TextExtents(dpy,Text(akt_str),asc,desc,width);
 			context.TextExtents(dpy,Text(akt_str).to_charPtr(),asc,desc,width);
		        //AH Changed End
		      if (scale) {
			asc=Round(asc*sd.zoom);
			desc=Round(desc*sd.zoom);
			width=Round(width*sd.zoom);
		      }
		      if (context.filled)
		      {
			Position topleft(pos), wh(width,asc+desc);
			switch (l.Align())
			{
			  case 0: break;
			  case 1: topleft.x -= width/2; break;
			  case 2: topleft.x -= width; break;
			}
			// y-Position entsprechend der Zeilennummer angleichen
			topleft.y -= (asc+desc)/2+(akt_line-1)*(asc+desc); 
			WriteWhiteBox(os,topleft,wh);
		      }
		      os<<"4 "<<l.Align();
		      if (format) {
			os<<' '<<ColorOf(context.color); // color
			os<<" 0"; // depth
			os<<" 0"; // pen_style
			os<<' '<<font<<' '<<(asc+desc-2);  // font & font size (pt)
		      }
		      else {
			os<<' '<<font<<' '<<(asc+desc-2);  // font & font size (pt)
			os<<" 0"; // pen
			os<<' '<<ColorOf(context.color);
			os<<" 0"; // depth
		      }
		      os<<" 0.00000 "; // angle
		      if (font==12)
			os<<'4';
		      else
			os<<(special?'2':'0'); // use latex fonts/special-flag
		      os<<' '<<Conv(asc+desc); // height of text
		      os<<' '<<Conv(width); // width of text
		      os<<' '<<Conv(pos.x)<<' '<<Conv(pos.y+asc/2-desc/4+(akt_line-1)*(asc+desc)); // y-Position entsprechend der Zeilennummer angleichen
 		      os<<' '<<Text(akt_str).to_charPtr()<<(format?"\\001":"\001")<<endl;
		    }
		  }
		}
		else if (name=="format")
		{
		  int stored_font = font;  //font speichern
		  XFontStruct* normal = XLoadQueryFont(dpy,"-*-courier-medium-r-*-*-13-*-*-*-*-*-*-*"); // fuer XTextExtents
		  XCharStruct xc; // fuer XTextExtents
		  int d; // fuer XTextExtents

		  Label& l = (Label&)s; // bleibt konstant
		  Text text = l.LabelText(ed); // wird "uber akt_str ver"andert!
		  int akt_len = 0; // aktuelle Zeilenl"ange
 		  char* akt_str = text.to_charPtr(); // Beginn der aktuell zu schreibenden Zeile
		  bool end_reached = false; // Gibt an, ob das Ende des Labels erreicht ist
		  int akt_line = 0; // Nummer der aktuellen Zeile

		  while (!end_reached) {
		    ++akt_line;
		    // Ende der aktuellen Zeile suchen
		    for (akt_str+=akt_len,akt_len=0; (*(akt_str+akt_len)!='\0')&&
			   (*(akt_str+akt_len)!='\n'); ++akt_len);
		    if (*(akt_str+akt_len)=='\0')
		      end_reached=true;
		    else {
		      *(akt_str+akt_len)='\0'; // newline durch Stringende ersetzen
		      ++akt_len; // Anzahl Zeichen bis n"achsten Zeilenanfang
		    }
 		    if ((Text(akt_str)).to_bool() && *(Text(akt_str).to_charPtr()))
		    {
		      Position pos = l.Pos(sd);
		      int asc,desc,width;
		      XTextExtents(normal,akt_str,strlen(akt_str),&d,&asc,&desc,&xc); // Beide fonts haben die gleichen Masse
		      width = xc.width;                                        // deshalb immer mit "normal"
		      if (context.filled)
		      {
			Position topleft(pos), wh(width,asc+desc);
			switch (l.Align())
			{
			  case 0: break;
			  case 1: topleft.x -= width/2; break;
			  case 2: topleft.x -= width; break;
			}
			// y-Position entsprechend der Zeilennummer angleichen
			topleft.y -= (asc+desc)/2+(akt_line-1)*(asc+desc); // -2 sitzt perfekt
			WriteWhiteBox(os,topleft,wh);
		      }
		      // Zeilenstring in Fragmente unterteilen
		      Format::Frag_list frags(akt_str, (Font)14, (Font)12);
		      Format::Fragment* iter;
		      char* frag_string; // Zeiger auf Fragmentstring
		      bool  frag_set = false;
		        int frag_width; 

		      for (iter=frags.first; iter; iter=iter->next) {
			font = iter->font;

			if (!frag_set) {
			  frag_set = true;
			  frag_string = iter->chars;
			}
			if ((font==(Font)12)&&(iter->next?(iter->next->font==(Font)12):0))
			  continue;
			
			char stored_char = iter->next?*(iter->next->chars):'\0';
			if (iter->next)
			  *(iter->next->chars) = '\0';

			XTextExtents(normal,frag_string,strlen(frag_string),&d,&asc,&desc,&xc);
			frag_width = xc.width;

			os<<"4 "<<l.Align();
			if (format) {
			  os<<' '<<ColorOf(context.color); // color
			  os<<" 0"; // depth
			  os<<" 0"; // pen_style
			  os<<' '<<font<<' '<<(asc+desc-2);  // font & font size (pt)
			}
			else {
			  os<<' '<<font<<' '<<(asc+desc-2);  // font & font size (pt)
			  os<<" 0"; // pen
			  os<<' '<<ColorOf(context.color);
			  os<<" 0"; // depth
			}
			os<<" 0.00000 "; // angle
			os<<('4'); // use postscript fonts
			os<<' '<<Conv(asc+desc); // height of text
			os<<' '<<Conv(frag_width); // width of text
			os<<' '<<Conv(pos.x)<<' '<<Conv(pos.y+asc/2-desc/4+(akt_line-1)*(asc+desc)); // y-Position entsprechend der Zeilennummer angleichen, -2 sitzt perfekt
			os<<' '<<frag_string<<(format?"\\001":"\001")<<endl;

			pos.x += frag_width;
			if (iter->next)
			  *(iter->next->chars) = stored_char;
			frag_set = false;
		      }
		    }
		  }
		  font = stored_font; // font wiederherstellen!
		}
		else cerr<<"Xfig-Exporter: Unknown Shape Type "<<name<<"!"<<endl;
	}	
	
	return os;
}	
													
ostream& XfigExporter::WriteColor(ostream& os,int idx,RGBValue& rgb)
{
	return os<<"0 "<<32+idx<<" #"<<hex
	<<(rgb.red>>4)<<(rgb.red&0xf)
	<<(rgb.green>>4)<<(rgb.green&0xf)
	<<(rgb.blue>>4)<<(rgb.blue&0xf)<<dec<<endl;
}


RGBValue XfigExporter::GetRGBValue(char* name)
{
	XColor exact,screen;
	XLookupColor(dpy,DefaultColormap(dpy,DefaultScreen(dpy)),
		name,&exact,&screen);
	return RGBValue(exact.red&0xff,exact.green&0xff,exact.blue&0xff);
}
											
													
ostream& XfigExporter::WriteColors(ostream& os,ExprData& ed,Iterator<Shape*> siter)
{
	for (Shape* s=siter; s; s=++siter)
	{
		Context& context = s->GetContext();
		context.Evaluate(ed);
		Ident name(s->Type());
		if (name=="compo")
			WriteColors(os,ed,((Compo*)s)->Shapes());
		else
		{
 			RGBValue col = GetRGBValue((context.color).to_charPtr());
			if (!colors.IsIn(col))
			{
				colors.Append(col);
				WriteColor(os,colors.Length()-1,col);
			}
		}
	}
	return os;
}

ostream& XfigExporter::WriteFile(ostream& os,Display* d,double zoom_val,Page& page)
{
	colors.Clear();
	dpy = d;
	if (format!=0)
		os<<"#FIG 3.1"<<endl<<"Landscape"<<endl<<"Center"<<endl<<"Metric"<<endl<<"1200 2"<<endl;
	else
		os<<"#FIG 2.1"<<endl<<"80 2"<<endl;
	
	bool nosel = true;
	Iterator<Object*> iter = page.Objects();
	Object* ob;
	for (ob=iter; ob; ob=++iter)
		if (ob->Selected()) { nosel = false; break; }
	
	if (format==2) // User-Farbliste rausschreiben
		for (ob=iter; ob; ob=++iter)
			if (nosel || ob->Selected())
			{
				ObjectClass* objcl = ob->Class();
				ExprData ed = ob->GetExprData(format<2,false);	
				ed.sel = false;
				WriteColors(os,ed,objcl->Shapes());
			}

	for (ob=iter; ob; ob=++iter)
		if (nosel || ob->Selected())
		{
			ObjectClass* objcl = ob->Class();
			ShapeData sd = ob->GetShapeData(zoom?zoom_val:1.0,false);	
			ExprData ed = ob->GetExprData(format<2,false);	
			ed.sel = false;
			Iterator<Shape*> siter = objcl->Shapes();
			for (Shape* s=siter; s; s=++siter)
				WriteShape(os,*s,sd,ed);
		}
	
	return os;
}
