#include "xbefore.h"
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/PanedW.h>
#include "xafter.h"

#include "attrib.h"
#include "tool.h"


Attrib::Attrib(Attrib& a): 
	netcl(a.netcl),
	form(0),label(0),
	name(a.name)
{
	if (a.val) val = a.val->Copy();
}


istream& Attrib::Input(istream& is)
{
	if ((val = Value::GetType(is, netcl)))
	{
		if (!(is>>name))
			cerr<<"attribute-identifier expected!"<<endl;
		else
		{
			char c;
			if (is>>c)
				if (c=='=')
					is>>*val;
				else is.putback(c);
			return is;
		}
	}
	is.clear(ios::badbit);
	return is;
}


ostream& Attrib::Output(ostream& os) const
{
	return os<<name<<" = "<<*val<<';';
}


void Attrib::LimitPaneSize()
{
	if (form)
	{
		Dimension height = 0;
		XtVaGetValues(form,XmNheight,&height,NULL);
		if (val && !val->Resizable())
			XtVaSetValues(form,XmNpaneMinimum,height,XmNpaneMaximum,height,NULL);
	}
}


Widget Attrib::CreateWidget(Widget parent)
{
	form = XtVaCreateWidget("Attrib",xmFormWidgetClass,parent,NULL);
	Widget label = XtVaCreateManagedWidget("Label",xmLabelGadgetClass,form,NULL);
 	//AH Changed Start .to_bool()
 	if (name.to_bool())
        //AH Changed End
	  //AH Changed : const_cast<char*>(
		SetStringValue(label,XmNlabelString,const_cast<char*>(name.Label()));

	val->CreateWidget(form);
	XtManageChild(form);
	return form;
}


bool Attrib::EvalWidget()
{
	return val->EvalWidget();
}
