#include "label.h"
#include "scope.h"
#include "compo.h"

SHAPE_NOTIFY("compo",Compo)


double Compo::Distance(ShapeData& sd, Position& ps, Position& nearest)
{
	return members?(*members.First())->Distance(sd,ps,nearest):1e300;
}


Position Compo::PointToMid(ShapeData& sd, Position& ps)
{
  return (*members.First())->PointToMid(sd,ps);
}


int Compo::Inside(Display* dpy, Position pos, ShapeData& sd, ExprData& ed)
{
	Iterator<Shape*> iter(members);
	
	sd.pos += offset;
	int rel = 0;

	for (Shape *s=iter; s; s=++iter)
	{
		int xrel = s->Inside(dpy,pos,sd,ed);
		if (xrel>0)
			return xrel;
		if (xrel) rel = xrel;
	}

	return rel;
}


Metrics Compo::GetMetrics(Display* dpy,ShapeData& sd,ExprData& ed)
{
  Iterator<Shape*> iter(members);
  Metrics akt_metrics;
  
  for (Shape* s=iter; s; s=++iter)
    akt_metrics.Compare(s->GetMetrics(dpy,sd,ed));
  
  return akt_metrics;
}


void Compo::DoDraw(Display* dpy, Drawable drw, GC, ShapeData& sd, ExprData& ed)
{
	Iterator<Shape*> iter(members);
	Position oldpos = sd.pos;

	sd.pos += offset;
	for (Shape* s=iter; s; s=++iter)
		s->Draw(dpy,drw,sd,ed,context.draw_xor);
	sd.pos = oldpos;
}


istream& Compo::Input(istream& is, int field)
{
	switch (field)
	{
		case 1:	is>>offset; break;
		default:
		{
			Shape *s = Shape::GetShape(is, &context);
			if (s) members.Append(s); 
		}
	}
	return is;
}

/*
ostream& Compo::Output(ostream& os)
{
	return os<<'('<<context<<','<<p<<", ("<<endl;
	Iterator<Shape*> iter(members);
	
	for (Shape* s=iter; s; )
	{
		os<<*s;
		if (s = ++iter) os<<','<<endl;
	}
}
*/
