#include "xbefore.h"
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MessageB.h>
#include <Xm/PushBG.h>
#include "xafter.h"

#include <iostream.h>
#include "dialog.h"

// g++ Workaround...
#define DCB(name) void (T::*name)(Dialog<T, U>&, U, Ident&)

template<class T, class U> void Dialog<T, U>::CreateBox(char* name, 
	Widget parent,DCB(callb),U ud,bool msg,char* buttons)
{
	cb = callb;
	udata = ud;
	Arg arg;
	XtSetArg(arg,XmNautoUnmanage,False);
	dialog = (msg?XmCreateMessageDialog:XmCreateTemplateDialog)
		(parent,name,&arg,1);
	
	CatchDestroy(&dialog);
	
 	//AH Changed Start => &Dialog<T, U>::Callback
 	unmap_id = AddCB(dialog,XmNunmapCallback,&Dialog<T, U>::Callback,false);
 	//AH Changed End

	if (msg) // Standardmaessig bei MessageDialog erzeugte Buttons entfernen
	{
		Widget b;
		if ((b = XmMessageBoxGetChild(dialog,XmDIALOG_OK_BUTTON)))
			XtDestroyWidget(b);
		if ((b = XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON)))
			XtDestroyWidget(b);
		if ((b = XmMessageBoxGetChild(dialog,XmDIALOG_HELP_BUTTON)))
			XtDestroyWidget(b);
	}
	
	Ident id;
  Text t;
  char c;
	istrstream is(buttons);
	
  while (is>>c)
	{
    is.putback(c);
    if (c=='"') { is>>t; id = t.to_charPtr(); }
    else is>>id;
    
         	//AH Changed Start => .to_charPtr()   &Dialog<T, U>::Callback
 		Widget b = XtVaCreateManagedWidget(id.to_charPtr(),xmPushButtonGadgetClass, dialog,NULL);
    
 		AddCB(b,XmNactivateCallback,&Dialog<T, U>::Callback,true);
 		//AH Changed End
		if (id=="Ok")
			XtVaSetValues(dialog,XmNdefaultButton,b,NULL);
	}
}


template<class T, class U> void Dialog<T, U>::Callback(Widget w, bool handle, XtPointer)
{
	if (cb && instance)
	{
		Ident name(handle?XtName(w):"");
		(instance->*cb)(*this,udata,name);
	}

	//AH CHANGED Start: Workaround against crash on dialog exit
	/*
	if (!handle || !cb || !instance)
	Close();*/
	else if (!cb)
	  Close();
	//AH CHANGED End
}


template<class T, class U> void Dialog<T, U>::Create(char* name, 
	char* title,Widget parent,U ud,DCB(callb),char* buttons)
{
	if (dialog) return;
	CreateBox(name,parent,callb,ud,false,buttons);
	XtVaSetValues(XtParent(dialog),XmNtitle,title,NULL);
//	SetStringValue(dialog,XmNdialogTitle,title); // does not work with sol2
}


template<class T, class U> void Dialog<T, U>::Manage()
{
	if (dialog)
		XtManageChild(dialog);
}


template<class T, class U> void Dialog<T, U>::OpenMsg(char* name, 
	Widget parent,U ud,DCB(callb),char* buttons)
{
	CreateBox(name,parent,callb,ud,true,buttons);
	Manage();
}


template<class T, class U> void Dialog<T, U>::OpenMsg(char* name, 
	char* title,Widget parent,
	unsigned char type,char* msg,U ud,DCB(callb),char* buttons)
{
	CreateBox(name,parent,callb,ud,true,buttons);
	SetStringValue(dialog,XmNmessageString,msg);
	XtVaSetValues(XtParent(dialog),XmNtitle,title,NULL);
//	SetStringValue(dialog,XmNdialogTitle,title); // does not work with sol2
	XtVaSetValues(dialog,XmNdialogType,type,NULL);
	Manage();
}


template<class T, class U> void Dialog<T, U>::Close()
{
	if (dialog)
	{
		UncatchDestroy(&dialog);
		if (unmap_id)
			RemoveCB(unmap_id);
		unmap_id = 0;
		XtDestroyWidget(dialog);
		dialog = 0;
	}
}


template<class T, class U> void Dialog<T, U>::Center(Position c)
{
	if (dialog)
	{
		Dimension height,width,
			screen_width = (Dimension)WidthOfScreen(XtScreen(dialog)),
			screen_height = (Dimension)HeightOfScreen(XtScreen(dialog));
	
		XtVaGetValues(dialog,XtNwidth,&width,XtNheight,&height,NULL);
		
		Position newp = c-Position(width,height)/2;
		newp = newp.XLimit(0,screen_width-width).YLimit(0,screen_height-height);

		XtVaSetValues(dialog,XmNx,int(newp.x),XmNy,int(newp.y),NULL);
	}
}

#define DIAINSTANCIATE(the_class,the_udata) \
class the_class;\
template class Dialog< the_class , the_udata >;\
template class Wrapper<Dialog< the_class , the_udata >,bool>;


// for g++
#ifndef NoExplicitInstanciation
#define NoExplicitInstanciation

#include "wrapper.cc"

class Object;
class HCPNTokengame;
class EDSPNTokengame;
class FAnlage;
class PathDecomp;
class MSIPDecomp;
class HCPNUnfolder;
DIAINSTANCIATE(Net,Object*)
DIAINSTANCIATE(Editor,bool)
DIAINSTANCIATE(Error,bool)
DIAINSTANCIATE(SPNLStructure,bool)
DIAINSTANCIATE(LogWindow,bool)
DIAINSTANCIATE(HCPNTokengame,bool)
DIAINSTANCIATE(EDSPNTokengame,bool)
DIAINSTANCIATE(FAnlage,bool)
DIAINSTANCIATE(PathDecomp,bool)
DIAINSTANCIATE(MSIPDecomp,bool)
#endif
