#include "format.h"

SHAPE_NOTIFY("format",Format)


Format::Format():
  Label()
{
}

Format::Format(istream& is,Context* super):
  Label(is,super)
{
}

bool Format::Frag_list::comment=false;

Format::Frag_list::Frag_list(char* string, Font bold, Font normal):
  no_entries(0),
  bold_font(bold),
  normal_font(normal),
  first(0),
  last(0)
{
//cout << "String:" << string << '\n';

  char vorher, nachher;
  char* f_b = string;  // fragment_begin
  char* f_e = string;  // fragment_end

  if (comment) {
    search:while (*f_e&&!(*f_e=='*'&&*(f_e+1)==')')) ++f_e;
    if (*f_e) {
      f_e += 2;
      Insert(f_b,f_e-f_b,false);
      comment=false;
    }
    else
      Insert(f_b,f_e-f_b,false);
  }
  while (*(f_b=f_e)) {
    if (isalpha(*f_b)) {
      for (;isalpha(*f_e)||(*f_e=='_')||(*f_e=='.');++f_e)
	if (*f_e=='p' || *f_e=='t') { // Muss leider sein bei nicht reinen Alpha-Keywords
	  if (!strncmp(f_e,"p->t",4)) f_e += 3;
	  else if (!strncmp(f_e,"p<-t",4)) f_e += 3;
	  else if (!strncmp(f_e,"p-ot",4)) f_e += 3;
	  else if (!strncmp(f_e,"t->p",4)) f_e += 3;
	  else if (!strncmp(f_e,"t<-p",4)) f_e += 3;
	  else if (!strncmp(f_e,"to-p",4)) f_e += 3;
	}
      if (f_b > string)
	vorher= *(f_b-1);
      else
	vorher= *f_b;
      nachher= *f_e;
      if (isdigit(vorher) || isdigit(nachher))
	Insert(f_b,f_e-f_b,true,true);
      else
	Insert(f_b,f_e-f_b,true);
    }
    else {
      for (;!isalpha(*f_e)&&*f_e&&!(*f_e=='('&&*(f_e+1)=='*');++f_e);
      if (!(*f_e=='('&&*(f_e+1)=='*'))
	Insert(f_b,f_e-f_b,false);
      else {
	comment=true;
	goto search;
      }
    }      
  }
  //Print();
}

void Format::Frag_list::Insert(char* frag, int len, bool test, bool before_or_after_a_digit)
    {
      Fragment* insert = new Fragment(frag,len,normal_font);
      
      if (!before_or_after_a_digit && (test?spnl.IsKey(frag,len):0))
	insert->font = bold_font;
      
      if (last)
	last->next = insert;
      else
	first = insert;
      
      last = insert;
      
      ++no_entries;
    }
  
void Format::Frag_list::Print()
{
  Fragment* iter;
  
  for (iter=first;iter;iter=iter->next)
    iter->Print();
}
  
Format::Frag_list::~Frag_list()
{
  Fragment* iter = first;
  Fragment* del;
  
  while (iter) {
    del = iter;
    iter = iter->next;
    delete del;
  }
}

void Format::DoDraw(Display* dpy,Drawable drw,GC gc,ShapeData& sd,ExprData& ed)
{
  XFontStruct* normal = XLoadQueryFont(dpy,"-*-courier-medium-r-*-*-13-*-*-*-*-*-*-*"); // fuer XTextExtents
  XFontStruct* bold = XLoadQueryFont(dpy,"-*-courier-bold-r-*-*-13-*-*-*-*-*-*-*"); // fuer XTextExtents
  Font normal_font = normal->fid; // fuer XTextItem
  Font bold_font = bold->fid; // fuer XTextItem
  XCharStruct xc; // fuer XTextExtents
  int d; // fuer XTextExtents

  ed.context = &context;
    
  Value* v = e.Evaluate(ed);
  //AH Changed Start  char* text = v?(char*)*v:0;
  char* text = v?(*v).to_charPtr():0;
  //AH Changed End

  int akt_len = 0; // aktuelle Zeilenl"ange
  bool end_reached = false; // Gibt an, ob das Ende des Labels erreicht ist
  int akt_line = 0; // Nummer der aktuellen Zeile;
  
  // Schleife zur Bestimmung des Zeilenstrings text
  while (!end_reached) {
    ++akt_line;
    // Ende der aktuellen Zeile suchen
    for (text+=akt_len,akt_len=0; (*(text+akt_len)!='\0')&&
	   (*(text+akt_len)!='\n'); ++akt_len);
    if (*(text+akt_len)=='\0')
      end_reached = true;
    else {
      *(text+akt_len)='\0'; // newline durch Stringende ersetzen
      ++akt_len; // Anzahl Zeichen bis zum n"achsten Zeilenanfang
    }
    
    // Zeilenstring in Fragmente zerlegen und anzeigen
    if (text) {
      Frag_list itemlist(text, bold_font, normal_font);
      //cout << "no:" << itemlist.no_entries << '\n';
      XTextItem* items = new XTextItem[itemlist.no_entries];
      Fragment* iter;
      int n;

      //itemlist.Print();
      for (iter=itemlist.first,n=0;iter;iter=iter->next,++n) {
	items[n].chars = iter->chars;
	items[n].nchars = iter->nchars;
	items[n].delta = 0;
	items[n].font = iter->font;
      }
      
      XPoint pnt = Absolute(sd,p);
      int asc,desc,width,shadow = context.shadow;
      XTextExtents(normal,text,strlen(text),&d,&asc,&desc,&xc); // Beide fonts haben die gleichen Masse
      width = xc.width;                                        // deshalb immer mit "normal"
      
      pnt.y += (asc-desc)/2+(akt_line-1)*(asc+desc); // y-Position entsprechend der Zeilennummer angleichen 
      if (align==Center)
	pnt.x -= width/2;
      else
	if (align==Right) pnt.x -= width;
      
      if (shadow)
	XDrawText(dpy,drw,gc,pnt.x+shadow,pnt.y+shadow,items,itemlist.no_entries);
      
      XDrawText(dpy,drw,gc,pnt.x,pnt.y,items,itemlist.no_entries);
    }
  }
}

Metrics Format::GetMetrics(Display* dpy, ShapeData& sd,ExprData& ed)
{
  Position pnt = Absolute(sd,p);
  Value* v = e.Evaluate(ed);
  //AH Changed Start  char* text = v?(char*)*v:0;
  char* text = v?(*v).to_charPtr():0;
  //AH Changed End
  Metrics met;

  if (text) {
    double y_beg;
    double y_end;
    int asc,desc,width;
    int no_lines = 0;
    int pre_lines = 0;
    char* sign = text;

    context.TextExtents(dpy,text,asc,desc,width);
    while((*sign=='\n')||(*sign==' ')) {
      if (*sign=='\n')
	++pre_lines;
      ++sign;
    }
    while(*sign) {
      if (*sign == '\n')
	++no_lines;
      ++sign;
    }
    if (*(sign-1)!='\n')
      ++no_lines;
    y_beg = pnt.y - (asc+desc)/2 + pre_lines*(asc+desc);
    y_end = y_beg + no_lines*(asc+desc);
    met = Metrics(y_beg,y_end);
    //met.Print();
    return met;
  }
  return met;
}

  
