#include "xbefore.h"
#include <X11/Intrinsic.h>
#include "xafter.h"

#include <strstream.h>
#include <iostream.h>

extern "C" {
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
}

#include "net.h"
#include "netcl.h"
#include "editor.h"
#include "expr.h"
#include "value.h"
#include "ident.h"
#include "logwin.h"
#include "text.h"

extern char* fallbacks[]; // from fbacks.cc

XtAppContext app;
char* app_class = "Agnes";
char* app_name = "agnes";
static char** app_argv;
int app_argc = 0;
Text home_dir, model_dir, tnet_dir, call_tmp;
char real_path[255];
bool found = false;
LogWindow* logwindow = 0;

char** Argv()
{
	char** new_argv = new char*[app_argc];
	memcpy(new_argv,app_argv,app_argc*sizeof(char*));
	return new_argv;
}

int main(int argc, char *argv[])
{	
//Ident x = "efg",*p = x;  Bug im g++: Missbrauchter char* Cast )o:
//AH Changed Start 3x .to_bool() 1x .to_charPtr() added 

 	if (!(home_dir = getenv("HOME")).to_bool())
	{   
            cout << "Warning: Environment variable HOME not set." << endl;
	    cout << "Using current directory instead." << endl;
	    home_dir = ".";
	}

 	if (!(tnet_dir = getenv("TNETHOME")).to_bool())
	{    
	    cout << "Error: Environment variable TNETHOME not set." << endl;
            exit(1);
	}

        // check TimeNET path
        if (strcmp(argv[0],"TimeNET") == 0)
        {   //search environment variable PATH for called TimeNET path
            char* path = strdup(getenv("PATH"));
            call_tmp = strtok(path,":");
            while (!found && call_tmp.to_bool())
            {
                  found = call_tmp.Contains("Agnes/bin");
                  if (found)
                     call_tmp = call_tmp.Left(call_tmp.Length()-10);
                  else
                     call_tmp = strtok((char*)NULL,":");
            }
            free(path); 
	}

        if (!found)
        {   // call - /Agnes/bin/TimeNET (18 chars)
            call_tmp = Text(realpath(argv[0],real_path));
            call_tmp = call_tmp.Left(call_tmp.Length()-18);
        } 

        // check if call path and TNETHOME match
	if (tnet_dir != call_tmp)
	{   
	    cout << "Warning: Called TimeNET path and value";
	    cout << " of TNETHOME do not match." << endl;
	    cout << call_tmp;
            cout << " ";
	    cout << tnet_dir << endl;
	}


	// check MODELDIR
 	if (!(model_dir = getenv("MODELDIR")).to_bool())
	{    
             cout << "Warning: Environment variable MODELDIR not set." << endl;
	     cout << "Using current directory instead." << endl;	
	     model_dir = ".";
	}

	// check XBMLANGPATH
	Text bitmap_dir = getenv("XBMLANGPATH");
 	if (!bitmap_dir.to_bool())
	{
	    bitmap_dir = Text("XBMLANGPATH=")+tnet_dir+"/Agnes/bitmaps/%B";
	    putenv(const_cast<char*>(bitmap_dir.to_charPtr()));
	 }
 	//AH Changed End	

        // check TimeNET configuration file
        if (access((home_dir+"/.TimeNET").to_charPtr(),F_OK) < 0)
	  {  
            cout << "Warning: TimeNET configuration file .TimeNET missing. ";
	    cout << "TimeNET might not work." << endl;
	  }

	// check Motif version	
	int xmuseversion = xmUseVersion; //constant compiled into Xm-library for Motif 2.x
	if (xmuseversion==0) xmuseversion = 1002; //set to 1.2 for Motif 1.x
	int xmrevision = xmuseversion - (xmuseversion/1000) * 1000;
	cout<<"Using Xm-library "<<(xmuseversion/1000)<<"."<<xmrevision<<endl;
	//if (xmuseversion>2000)
	//  cout<<"Warning: TimeNET is specified for Motif Version 1.2.x"<<endl;
#ifdef XmVERSION_STRING 
	cout<<"Motif-Version-String from Xm.h: ";
	cout<<XmVERSION_STRING<<endl; //from Xm.h
#ifdef XmVersion
	int xmincludeversion = XmVersion;
	int xmincluderevision = xmincludeversion - (xmincludeversion/1000) * 1000;
	if(xmincludeversion!=xmuseversion)
	  cout<<"Motif library version ("<< (xmuseversion/1000)<<"."<<xmrevision
	      <<") and include file version ("<< (xmincludeversion/1000)<<"."<<xmincluderevision
	      <<") do not match!"<<endl; 
#endif
#endif


	// initialize
	XtToolkitInitialize();
	app = XtCreateApplicationContext();
	XtAppSetFallbackResources(app,fallbacks);
	
	/*AH Changed: Workaround for a motif bug.
	  On Suse Linux 7.0, with Motif 2.1.30 and standard X-libraries (compiled without MotifBC option)
	  The internal variable _XmColorObjCacheDisplay is set to NULL when the first editor-window is 
	  closed. This leads to a crash when opening dialog boxes in other windows after the first window 
	  has been closed and no other window has been opened in the meantime.
	  To workaround this bug, we open a display and a shell without realizing it (invisible).
	 */
	
 	Display* display  = XtOpenDisplay(app,"",app_name,app_class,(XrmOptionDescRec*)NULL,0,&argc,argv);
	Widget app_shell = 0;
	if(display)
	  app_shell = XtVaAppCreateShell(app_name,app_class, applicationShellWidgetClass,display,NULL);
	
	/*AH Changed End*/

	if ((app_argc = argc))
		app_argv = argv;
	
	// Eingebaute Netzklassen instanziieren
	#include "builtins.h"
	
	// ggf. Externe Netzklassen laden
	NetClass::LoadExternals("./NetClasses");
	//AH Changed Start 2x .to_charPtr() added
	NetClass::LoadExternals((model_dir+"/NetClasses").to_charPtr());
	NetClass::LoadExternals((tnet_dir+"/Agnes/NetClasses").to_charPtr());
	//AH Changed End
    
	// Netze aus der Commandline (rekursiv) laden, ggf. leeres Fenster auf
	//AH Changed Start 	Editor::NewEditor(0,NULL,1);
 	Editor::NewEditor(0,(char *)NULL,1);
 	//AH Changed End

	// stderr ausgaben in globales Logwindow umlenken
	int err_pipe[2];
	pipe(err_pipe);
	dup2(err_pipe[1],2);
	close(err_pipe[1]);
	logwindow = new LogWindow(err_pipe[0]);

	// start main loop
	Editor::MainLoop();

	/*AH Changed: Workaround for a motif bug.*/
	
	if (app_shell)
	  XtDestroyWidget(app_shell);	
	if (display) 
	  XtCloseDisplay(display);
	
	/*AH Changed End*/

	return 0;
}






