#include "xbefore.h"
#include <Xm/Xm.h>
#include "xafter.h"

#include "repeater.h"
#include "main.h"
	
void Repeater::Unlink()
{
	if (w)
	{
		XtRemoveCallback(w,XmNarmCallback,_Arm,XtPointer(this));
		XtRemoveCallback(w,XmNdisarmCallback,_Disarm,XtPointer(this));
		XtRemoveCallback(w,XmNdestroyCallback,_Destroy,XtPointer(this));
	}
}

Widget Repeater::operator =(Widget wid)
{
	Unlink();
	XtAddCallback(w = wid,XmNarmCallback,_Arm,XtPointer(this));
	XtAddCallback(w,XmNdisarmCallback,_Disarm,XtPointer(this));
	XtAddCallback(w,XmNdestroyCallback,_Destroy,XtPointer(this));
	return w;
}

void Repeater::_Timer(XtPointer cldata, XtIntervalId*)
{
	Repeater* e = RepeaterP(cldata);
	XtCallCallbacks(e->w,XmNarmCallback,e->calldata);
	e->timer_id = XtAppAddTimeOut(app,e->delay,_Timer,cldata);
}

void Repeater::_Arm(Widget, XtPointer cldata, XtPointer calldata)
{
	Repeater* e = RepeaterP(cldata);
	if (!e->timer_id)
	{
		e->calldata = calldata;
		e->timer_id = XtAppAddTimeOut(app,e->initial,_Timer,e);
	}
}

void Repeater::_Disarm(Widget, XtPointer cldata, XtPointer)
{
	Repeater* e = RepeaterP(cldata);
	if (e->timer_id) XtRemoveTimeOut(e->timer_id);
	e->timer_id = 0;
}

void Repeater::_Destroy(Widget, XtPointer cldata, XtPointer)
{
	RepeaterP(cldata)->w = 0;
}




