#include "set.h"

Set::Set(Set& s) // Copy-Konstruktor
{
	def = s.def->Copy();
	defined = true;
	for (Value **v=s.vals.First(); v; v=s.vals.Next())
		vals.Append((*v)->Copy());
}

istream& Set::Parse(istream& is)
{
	if (def) delete def;
	if (def = netcl->Class(is))
	{
		if (def->composite)
			cerr<<"simple type expected"<<endl;
		else
			return is;
	}
	is.clear(ios::badbit);
	return is;
}

istream& Set::Input(istream& is)
{
	char c; Value *val;
	if (!(is>>c) || c!='{')
		cerr<<"{ expected!"<<endl;
	else
	{
		while (is>>*(val = def->Copy()))
		{
			vals.Append(val);
			if (!(is>>c))
			{
				cerr<<"cerr in set!"<<endl;
				return is;
			}
			else
			{
				if (c=='}') return is;
				if (c!=',' || c!=';')
				{
					cerr<<"unexpected character '"<<c<<"'!"<<endl;
					is.clear(ios::badbit);
					return is;
				}
			}
		}
		delete val;
		cerr<<"initializer expected!"<<endl;
	}
	is.clear(ios::badbit);
	return is;
}

ostream& Set::Output(ostream& os)
{
	os<<"{\n";
	for (Value **val=vals.First(); val; )
	{
		os<<'\t'<<**val;
		if (val = vals.Next()) os<<',';
		os<<'\n';
	}
	return os<<"}\n";
}
