#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <X11/Intrinsic.h>     /* Intrinsics Definitions*/
#include <X11/StringDefs.h>    /* Standard Name-String definitions*/
#include <X11/Xaw/SimpleMenu.h>   /*  XawSimpleMenuAddGlobalActions */     

#include "pmfEdit.h"

#define DSPNPACKAGE_ENV "TNETHOME"
#define INTERFACEHELP "Agnes/tnlink"

#define APP_CLASS_NAME "PMF-Editor"
#define XtNmacMode "macMode"
#define XtCmacMode "MacMode"

typedef struct
{       Boolean mac_mode;
} AppData, *AppDataPtr;

Pixmap toggle_pixmap;
XtAppContext app_context;
AppData app_data;

Widget 	
topLevel, 		/*Transient fuer windowmanager*/
app_root;		/*appl. topwindow (form)*/

static XtResource resources[]={
{       XtNmacMode,
        XtCmacMode,
        XtRBoolean,
        sizeof(Boolean),
        XtOffset(AppDataPtr,mac_mode),
        XtRImmediate,
        (XtPointer)False,
}};

static XrmOptionDescRec options[]={
        {"-mac",".macMode",XrmoptionNoArg, (XtPointer)"True"}};

/* Fallback Resources */
static String fallback_resources[]={
/*#include "TimeNET_fallbacks.h"*/

  NULL
};

typedef struct _EditState {
                int type;
                char pmffunc[256];
                char DataFile[256];
		} EditState;
static EditState edit_state;

#define toggle_width 13
#define toggle_height 9
static unsigned char toggle_bits[] = {
   0x00, 0x18, 0x00, 0x0e, 0x18, 0x07, 0x9c, 0x03, 0xdc, 0x01, 0xfc, 0x00,
   0x7c, 0x00, 0x3c, 0x00, 0x18, 0x00};
   /* strange if 0xfc ... works, because XCreateBitmapFromData (later use)
      needs char * and not unsigned */

/* Parameter: */
/* argv[1] ist die alte pmf-Funktion */
/* argv[2] ist der Transitionsname */
int main(argc, argv)
int argc;
char **argv;
{
  FILE* fp;
  char path[256];

  topLevel = XtVaAppInitialize(
        &app_context,       /* Application context */
        APP_CLASS_NAME,         /* Application class */
        options, XtNumber(options), /* command line option list */
        &argc, argv,        /* command line args */
        fallback_resources, /* for missing app-defaults file */
        NULL);              /* terminate varargs list */

  XtVaGetApplicationResources(topLevel,&app_data,resources,XtNumber(resources),NULL);
  XtVaSetValues(topLevel,XtNwidth,620,XtNheight,420,NULL);


  toggle_pixmap = XCreateBitmapFromData(XtDisplay(topLevel),
			RootWindowOfScreen(XtScreen(topLevel)),
			(char *)toggle_bits,toggle_width,toggle_height);
  pmfSetup(topLevel);

  XawSimpleMenuAddGlobalActions(app_context);
  
  XtSetMappedWhenManaged (topLevel,0);
  XtRealizeWidget(topLevel);

  edit_state.type= PMF_FUNC;

  if (edit_state.type==PMF_FUNC)
    {
      strcpy(edit_state.pmffunc,argv[1]);
      strcpy(edit_state.DataFile,"model_tname.DAT:RAND_UNI");
    }

  pmfEdit(argv[2],&(edit_state.type),edit_state.pmffunc,
	  edit_state.DataFile,0); /* 0 Means editable */
  
  XtAppMainLoop(app_context);

  strcpy(path, (char*)(getenv("TNETHOME")));
  strcat(path, "/Agnes/tnlink/pmf/bin/erg.out");
  fp= fopen(path, "w" );
  fprintf(fp, "\"%s\"", edit_state.pmffunc);
  fclose(fp);
  return 0;
}

void pmfDialogDone()
{
  XtAppSetExitFlag(app_context);
}

void helpDone()
{
}


void PopUpHelp()
{
  printf("PopUpHelp\n");
}

void CenterWidget()
{
}

