#ifndef __TNLINK_CC__
#define __TNLINK_CC__

//---------------------------------------------------------------------
// Importe
//---------------------------------------------------------------------

extern "C" {
#include <math.h>
#include <string.h>
#include <time.h>
}

#include <iostream.h>

#include "main.h"
#include "dialog.h"
#include "module.h"

#include "filesel.h"
#include "editor.h"
#include "net.h"
#include "netcl.h"
#include "node.h"
#include "connect.h"
#include "list.h"
#include "text.h"
#include "int.h"
#include "ident.h"

#include "tnlink.h"

#ifndef NoExplicitInstanciation
#define NoExplicitInstanciation
#include "dialog.cc"
#include "filesel.cc"
#include "wrapper.cc"
FSELINSTANCIATE(TimeNETLink,EditorP)
DIAINSTANCIATE(TimeNETLink,bool)
#endif

#include <signal.h>
// fuer kill()

#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
// fuer Execute() und pids

MODULE_NOTIFY(TimeNETLink)

// -----------------------------------------------------------------

bool TimeNETLink::Event(Editor&,Page& pg,EventInfo&,bool before)
{
  bool found_gentrans= false;
  bool found_placetrans= false;

  if (EDSPNen && before)
    {
      for (ObjectP obj= pg.NextSelected(); obj && obj->IsNode(); 
	   obj= pg.NextSelected(obj)) 
	{
	  NodeP node= (NodeP)obj;
	  
	  if (IsTransition(node))
	    {
	      found_placetrans= true;
	      if (IsGenTrans(node))
		  found_gentrans= true;
	    }
	  if (IsPlace(node))
	    found_placetrans= true;
	}
      if (found_gentrans)
	XtSetSensitive(pmfwidget,True);
      else
	XtSetSensitive(pmfwidget,False);
      if (found_placetrans)
	XtSetSensitive(distwidget,True);
      else
	XtSetSensitive(distwidget,False);
    }
  return false;
}

// -----------------------------------------------------------------

bool TimeNETLink::FlashTimer(bool)
{
  if (pidStationaryAnalysis)
    {
      int stat;
      int stat_loc;
      //AH Changed: call of waitpid changed for Linux compatibility
      //waitpid(pidStationaryAnalysis, &stat, WNOHANG);
      //
      stat = waitpid(pidStationaryAnalysis, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidStationaryAnalysis" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidStationaryAnalysis= 0;
	}
    }
  if (pidStationaryAnalysisDTSPN)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidStationaryAnalysisDTSPN, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidStationaryAnalysisDTSPN" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidStationaryAnalysisDTSPN= 0;
	}
    }
  if (pidStationaryApproximation)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidStationaryApproximation, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidStationaryApproximation" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidStationaryApproximation= 0;
	}
    }
  if (pidStationarySimulation)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidStationarySimulation, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidStationarySimulation" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidStationarySimulation= 0;
	}
    }
  if (pidRestartStSimulation)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidRestartStSimulation, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidRestartStSimulation" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidRestartStSimulation= 0;
	}
    }
  if (pidTransientAnalysis)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidTransientAnalysis, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidTransientAnalysis" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidTransientAnalysis= 0;
	}
    }
  if (pidTransientAnalysisDTSPN)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidTransientAnalysisDTSPN, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidTransientAnalysisDTSPN" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidTransientAnalysisDTSPN= 0;
	}
    }
  if (pidTransientSimulation)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidTransientSimulation, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidTransientSimulation" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidTransientSimulation= 0;
	}
    }
  if (pidExperiment)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidExperiment, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidExperiment" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidExperiment= 0;
	}
    }
  if (pidExperiment2)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidExperiment2, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidExperiment2" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidExperiment2= 0;
	}
    }
  if (pidExperiment3)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidExperiment3, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidExperiment3" << endl;
	}
      else if (stat)
	{// process-status changed

	  // WIFEXITED(stat) '>0': normal termination, '=0': exitcode#0

	  GetResults(*this->ed);
	  pidExperiment3= 0;
	}
    }
  if (pidEstimSE)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidEstimSE, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidEstimSE" << endl;
	}
      else if (stat)
	{
	  pidEstimSE= 0;
	}
    }
 if (pidTraps)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidTraps, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidTraps" << endl;
	}
      else if (stat)
	{
	  pidTraps= 0;
	}
    }
 if (pidSiphons)
    {
      int stat;
      int stat_loc;
      stat = waitpid(pidSiphons, &stat_loc, WNOHANG);
      if (stat==-1)
	{// error while waitpid

	  cout << "error: pidSiphons" << endl;
	}
      else if (stat)
	{
	  pidSiphons= 0;
	}
    }
  return true;
}

// -----------------------------------------------------------------
// TimeNETLink-Hilfsfunktionen
// -----------------------------------------------------------------

void TimeNETLink::SetNetName()
{
  charP pointer;
  if ((pointer=strrchr(net.FileName(), '/')))
    {
      int len= (int)strlen(model_dir.to_charPtr());
      if (!strncmp( net.FileName(), model_dir.to_charPtr(), len))
	netname= Text(net.FileName()+len+1);
      else
	netname= Text(pointer+1);
    }
  else
    netname= net.FileName();

  netname= netname - NET_ENDING - TN_ENDING;
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassPlace(NetClassP nc)
{  
  return nc->GetNodeClass("Place");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassExpTrans(NetClassP nc)
{  
  return nc->GetNodeClass("ExpTrans");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassDetTrans(NetClassP nc)
{  
  return nc->GetNodeClass("DetTrans");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassGenTrans(NetClassP nc)
{  
  return nc->GetNodeClass("GenTrans");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassImmTrans(NetClassP nc)
{  
  return nc->GetNodeClass("ImmTrans");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassMarkPar(NetClassP nc)
{  
  return nc->GetNodeClass("MarkPar");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassDelayPar(NetClassP nc)
{  
  return nc->GetNodeClass("DelayPar");
}

// -----------------------------------------------------------------

NodeClassP TimeNETLink::GetNodeClassRewItem(NetClassP nc)
{  
  return nc->GetNodeClass("rew_item");
}

// -----------------------------------------------------------------

ConnectorClassP TimeNETLink::GetConnectorClassArc(NetClassP nc)
{  
  return nc->GetConnectorClass("Arc");
}

// -----------------------------------------------------------------

ConnectorClassP TimeNETLink::GetConnectorClassInhibitor(NetClassP nc)
{  
  return nc->GetConnectorClass("Inhibitor");
}
// -----------------------------------------------------------------

bool TimeNETLink::IsPlace(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Places") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsTransition(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Transition") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsGenTrans(NodeP node)
{// vorher IsTransition() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"GenTrans") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsExpTrans(NodeP node)
{// vorher IsTransition() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"ExpTrans") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsDetTrans(NodeP node)
{// vorher IsTransition() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"DetTrans") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsImmediate(NodeP node)
{// vorher IsTransition() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"ImmTrans") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsArc(ConnectorP conn)
{
  return (!strcmp((conn->Class()->GroupName()).to_charPtr(),"Arcs") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsInhibitor(ConnectorP conn)
{
  return (!strcmp((conn->Class()->Name()).to_charPtr(),"Inhibitor") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsParameter(NodeP node)
{
  return (!strcmp((node->Class()->GroupName()).to_charPtr(),"Parameter") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsMarkPar(NodeP node)
{// vorher IsParameter() aufrufen
  return (!strcmp((node->Class()->Name()).to_charPtr(),"MarkPar") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsDelayPar(NodeP node)
{// vorher IsParameter() aufrufen
  return (!strcmp( (node->Class()->Name()).to_charPtr(),"DelayPar") ? true : false);
}

// -----------------------------------------------------------------

bool TimeNETLink::IsRewItem(NodeP node)
{// vorher IsParameter() aufrufen
  return (!strcmp( (node->Class()->Name()).to_charPtr(),"rew_item") ? true : false);
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetMarking(NodeP node)
{
  return (TextP)node->Attr("marking");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetDelay(NodeP node)
{
  return (TextP)node->Attr("delay");
}

// -----------------------------------------------------------------

ValueP TimeNETLink::GetIsMDDelay(NodeP node)
{
  return node->Attr("IsMD");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetPolicy(NodeP node)
{
  return (TextP)node->Attr("fire_pol");
}

// -----------------------------------------------------------------

ValueP TimeNETLink::GetServerType(NodeP node)
{
  return node->Attr("inf_serv");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetPMFunc(NodeP node)
{
  return (TextP)node->Attr("pmfunc");
}

// -----------------------------------------------------------------

ValueP TimeNETLink::GetPriority(NodeP node)
{
  return node->Attr("priority");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetWeight(NodeP node)
{
  return (TextP)node->Attr("weight");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetEnable(NodeP node)
{
  return (TextP)node->Attr("md_enable");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetMultiplicity(ConnectorP c)
{
  return (TextP)c->Attr("multi");
}

// -----------------------------------------------------------------

ValueP TimeNETLink::GetIsMDArcMult(ConnectorP c)
{
  return c->Attr("IsMD");
}

// -----------------------------------------------------------------

ValueP TimeNETLink::GetMarkPar(NodeP node)
{
  return node->Attr("value");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetDelayPar(NodeP node)
{
  return (TextP)node->Attr("delay");
}

// -----------------------------------------------------------------

ValueP TimeNETLink::GetIsMDDelayPar(NodeP node)
{
  return node->Attr("IsMD");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetRewItem(NodeP node)
{
  return (TextP)node->Attr("reward_def");
}

// -----------------------------------------------------------------

TextP TimeNETLink::GetResult(NodeP node)
{
  return (TextP)node->Attr("result");
}

// -----------------------------------------------------------------

void TimeNETLink::PMFEditor(NodeP node)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  char call[256];
  
  strcat(strcat(strcat(strcat(strcat(strcat(strcpy(call,tnet_dir.to_charPtr()), 
    "/Agnes/tnlink/pmf/bin/PMFEditor '"), (*GetPMFunc(node)).to_charPtr() ), "'"),
    " '"), (node->Name()).to_charPtr() ), "' 2>&1");

  system(call);
  
  ifstream ergstream(    (tnet_dir + "/Agnes/tnlink/pmf/bin/erg.out").to_charPtr()   );

  if ((*GetPMFunc(node)).to_bool())
    GetPMFunc(node)->Input(ergstream);
  ergstream.close();
}

// -----------------------------------------------------------------

void TimeNETLink::TokenDistribution(NodeP thenode)
{
  Text DialogContense;
  
  FILE *fp;
  struct stat;
  char d_string[500],format[25];
  int j,min_token,max_token;
  double d_buf,mean;

  Text path= net.FileName();
  path= path - ".net" - ".TN" + ".PROBTOK";

  if ((fp = fopen(path.to_charPtr(),"r")) == NULL)
    {
      Text DialogContense;
      DialogContense+= "there is no token distribution file available!";
      
      OpenMsgDialog(*this->ed, "TimeNET_Error",
		    DialogContense.to_charPtr(),true,"Close");
      return;
    }

  sprintf(format,"%%5d      : %%.%d%s\n",11,"g");

  DialogContense+= "# markings : probability \n";
  DialogContense+= "--------------------\n";

  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)
    {// fuer jede Stelle tue

      if (IsPlace(node))
	{
	  if (fread((char*)&d_buf,sizeof(double),1,fp) != 1)
	    {
	      fclose(fp);
	      return;
	    }
	  min_token = (int)d_buf;
	  if (fread((char*)&d_buf,sizeof(double),1,fp) != 1)
	    {
	      fclose(fp);
	      return;
	    }
	  max_token = (int)d_buf;
	  
	  mean = 0.0;
	  for (j=min_token;j<=max_token;j++)
	    {
	      if (fread((char*)&d_buf,sizeof(double),1,fp) != 1)
		{
		  fclose(fp);
		  return;
		}
	      mean += (double)j*d_buf;
	      sprintf(d_string,format,j,d_buf);
	      
	      if (!strcmp( (node->Name()).to_charPtr(),(thenode->Name()).to_charPtr() ))
		for (int z= 0; z<(int)strlen(d_string); z++)
		  DialogContense+= d_string[z];
	    }
	  if (!strcmp( (node->Name()).to_charPtr(),(thenode->Name()).to_charPtr()))
	    {
	      DialogContense+= "mean # markings: ";
	      DialogContense+= mean;
	      DialogContense+= "                    \n";
	    }
	}
    }
  fclose(fp);

  Text Title("Token Distribution of ");
  Title+= (thenode->Name()).to_charPtr();

  LogWindow *infolog = new LogWindow(0);
  infolog->Open("LogWindow", Title.to_charPtr(), ed->Shell(), "Close");
  infolog->SetContents(DialogContense.to_charPtr());

  //  OpenMsgDialog(*this->ed, Title.to_charPtr(),
  //		DialogContense.to_charPtr(),false,"Close");
}

// -----------------------------------------------------------------

void TimeNETLink::ThroughPut(NodeP thenode)
{
  Text DialogContense;
  
  FILE *results_fp;
  char s[256];
  double throughput;

  Text results_path= net.FileName();
  results_path= results_path - ".net" - ".TN" + ".RESULTS";

  if ((results_fp = fopen(results_path.to_charPtr(),"r")) == NULL)
    {
      Text DialogContense;
      DialogContense+= "there is no results file available!";
      
      OpenMsgDialog(*this->ed, "TimeNET_Error",
		    DialogContense.to_charPtr(),true,"Close");
      return;
    }

    do {
        if (fscanf(results_fp, "%[^\n]", s) == EOF) {
            return;
        }
        if (fscanf(results_fp, "%*[\n]") == EOF) {
            return;
        }
    } while (strcmp(s,"THROUGHPUT RESULTS OF TIMED TRANSITIONS"));
    if (fscanf(results_fp, "%*[^\n]%*[\n]") == EOF) {
        return;
    }

  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)
    {// fuer jede Transition tue

      if (IsTransition(node))
	{
	  if (fscanf(results_fp, "%lf", &throughput) != 1) {
            return;
	  }
	  if (!strcmp( (node->Name()).to_charPtr(), (thenode->Name()).to_charPtr() ))
	    {
	      if (throughput==0.0)
		{
		  Text DialogContense;
		  DialogContense+= "there is no throughput available!";
		  
		  OpenMsgDialog(*this->ed, "TimeNET_Error",
				DialogContense.to_charPtr(),true,"Close");
		  return;
		}
	      DialogContense+= "Throughput: ";
	      DialogContense+= throughput;
	      DialogContense+= "                    ";
	      DialogContense+= "\n";
	    }
	}
    }
  fclose(results_fp);
  
  Text Title("Throughput of ");
  Title+= (thenode->Name()).to_charPtr();

  OpenMsgDialog(*this->ed, Title.to_charPtr(),
  		DialogContense.to_charPtr(),false,"Close");

}

// -----------------------------------------------------------------
// Parser-Hilfsfunktionen
// -----------------------------------------------------------------

void TimeNETLink::ParserError(const charP message, charP string, int length)
{
  error= true;

  if (firsttime)
    {
      firsttime= false;

      Text DialogContense;

      if (type==md_exp_delay)
	DialogContense+= "an error occured in <md_exp_delay>\n";
      else if (type==md_det_delay)
	DialogContense+= "an error occured in <md_det_delay>\n";
      else if (type==md_weight)
	DialogContense+= "an error occured in <md_weight>\n";
      else if (type==md_enable)
	DialogContense+= "an error occured in <md_enable>\n";
      else if (type==md_arc_mult)
	DialogContense+= "an error occured in <md_arc_mult>\n";
      else if (type==reward_def)
	DialogContense+= "an error occured in <reward_def>\n";
      else if (type==param_def)
	DialogContense+= "an error occured in <param_def>\n";
      else if (type==pmf_def)
	DialogContense+= "an error occured in <pmf_def>\n";

      if (ParserObject)
	{
	  DialogContense+= "while parsing:\n";
	  DialogContense+= (ParserObject->Class()->GroupName()).to_charPtr();
	  DialogContense+= "(";
	  DialogContense+= (ParserObject->Class()->Name()).to_charPtr();
	  DialogContense+= ") ";
	  DialogContense+= (ParserObject->Name()).to_charPtr();
	  DialogContense+= "\n";

	  net.GetPage(this->ed)->Deselect();
	  ParserObject->Select(true);
	}

      if (ParserText)
	{
	  DialogContense+= *ParserText;
	  DialogContense+= "\n";
	}

      DialogContense+= message;
      DialogContense+= "\n";
      if (ParserText && strncmp((*ParserText).to_charPtr(), string, length))
	{
	  for (int i=0; i< length; i++)
	    DialogContense+= string[i];
	  DialogContense+= "\n";
	}
      // und nun noch die Meldungen des Parsers

      DialogContense+= "please remove errors first!";
      DialogContense+= "\n";
      OpenMsgDialog(*this->ed, "TimeNET_Error",
		    DialogContense.to_charPtr(),true,"Close");
    }
}

// -----------------------------------------------------------------

long TimeNETLink::ParseMarking(charP string, int length)
{
  string++;length--;
  // abschneiden des '#'-Zeichens vor dem Stellennamen

  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)
    // fuer alle Knoten tue

    if (IsPlace(node) && (length==(int)strlen( (node->Name()).to_charPtr()  ) ) &&
	!strncmp( (node->Name()).to_charPtr() , string, length))
      // Stelle mit gewuenschtem Namen gefunden?

      if (((*GetMarking(node)).to_charPtr()  )[0])
	// kein Leerstring?
	return (long)
	  ((*GetMarking(node)).to_double() );
  // Markeninhalt ist ganzzahliger Wert

      else
	
	return 0;
  // kein Markeninhalt

  ParserError("Place does not exist:",
	      string, length);

  return 0;
}

// -----------------------------------------------------------------

double TimeNETLink::ParseParameter(charP string, int length)
{
  return (ParseRealParameter(string, length));
  // Parameter sind in dieser Netzklasse immer Integer
  // aber es wird mit double-Zahlen gerechnet
}

// -----------------------------------------------------------------

long TimeNETLink::ParseIntegerParameter(charP string, int length)
{
  return (long)(ParseRealParameter(string, length));
  // IntegerParameter sind casted RealParameter
}

// -----------------------------------------------------------------

double TimeNETLink::ParseRealParameter(charP string, int length)
{
  if (RecursionError)
    return 0.0;

  Iterator<NodeP> ListNodes= net.Prime()->Nodes();

  for (NodeP node=ListNodes; node; node=++ListNodes)
    // fuer alle Knoten tue

    if (IsParameter(node))
      // suche einen Parameter
      
      if ((length==(int)strlen((node->Name()).to_charPtr()  ) &&
	   !strncmp( (node->Name()).to_charPtr(), string, length)))
	// Parameter mit gewuenschtem Namen gefunden?
	
	if (IsMarkPar(node))
	  {// Stelle ist MarkingParameter?
	    
	    IsMDDelay= true;

	    return (double)
	      ((*GetMarkPar(node)).to_int());
	  }
	else if (IsDelayPar(node))
	  {// Stelle ist DelayParameter?
	    
	    if (Recursion.IsIn(node))
	      {
		RecursionError= true;
		ParserError("illegal recursion:",
			    string, length);
		return 0.0;
	      }
	    
	    Recursion.Append(node);
	    
	    ParserObject= node;
	    ParserText= GetDelayPar(node);
	    
	    enum parser_type type_save= type;
	    bool error_save= error;
	    bool IsMDDelay_save= IsMDDelay;
	    bool IsMDArcMult_save= IsMDArcMult;
	    bool IsMDDelayPar_save= IsMDDelayPar;
	    
	    double value= Parse_param_def( (*GetDelayPar(node)).to_charPtr() );
	    
	    type= type_save;
	    error|= error_save;
	    IsMDDelay= IsMDDelay_save;
	    IsMDArcMult= IsMDArcMult_save;
	    IsMDDelayPar= IsMDDelayPar_save;
	    
	    Recursion.Remove(node);
	    
	    return value;
	  }
	else
	  {
	    ParserError("unknown Parameter type:",
			string, length);
	    return 0.0;
	  }
  ParserError("Parameter does not exist:",
	      string, length);
  return 0.0;
}

//---------------------------------------------------------------------
// Analyse- und Simulations-komponenten
// --------------------------------------------------------------------

void TimeNETLink::SaveParams(StructP params)
{
  if (params->GetMember("pr_gdesc"))
    pr_gdesc= (!strcmp(       (*params->GetMember("pr_gdesc")).to_charPtr(), "ps")? 
	     aPS: aEPS);
  if (params->GetMember("pr_tdesc"))
    pr_tdesc= (!strcmp(      (*params->GetMember("pr_tdesc")).to_charPtr(), "ps")? 
	     aPS2: aLATEX);
  if (params->GetMember("pr_graph"))
    pr_graph= (*params->GetMember("pr_graph")).to_bool();
  if (params->GetMember("pr_text"))
    pr_text= (*params->GetMember("pr_text")).to_bool();
  if (params->GetMember("pr_dest"))
    pr_dest= (!strcmp((*params->GetMember("pr_dest")).to_charPtr(), "printer")? 
	    aPRINTER: aFILE);
  if (params->GetMember("pr_cmd"))
    pr_cmd= (*params->GetMember("pr_cmd")).to_charPtr();

  if (params->GetMember("exp_param"))
    exp_param= (*params->GetMember("exp_param")).to_charPtr();
  if (params->GetMember("exp_from"))
    exp_from= (*params->GetMember("exp_from")).to_double();
  if (params->GetMember("exp_to"))
    exp_to= (*params->GetMember("exp_to")).to_double();
  if (params->GetMember("exp_mode"))
    exp_mode= (!strcmp((*params->GetMember("exp_mode")).to_charPtr(), "aLIN")? 
	     aLIN: aLOG);
  if (params->GetMember("exp_step"))
    exp_step= (*params->GetMember("exp_step")).to_double();

  if (params->GetMember("exp2_param"))
    exp2_param= (*params->GetMember("exp2_param")).to_charPtr();
  if (params->GetMember("exp2_from"))
    exp2_from= (*params->GetMember("exp2_from")).to_double();
  if (params->GetMember("exp2_to"))
    exp2_to= (*params->GetMember("exp2_to")).to_double();
  if (params->GetMember("exp2_mode"))
    exp2_mode= (!strcmp((*params->GetMember("exp2_mode")).to_charPtr(), "aLIN")? 
	      aLIN: aLOG);
  if (params->GetMember("exp2_step"))
    exp2_step= (*params->GetMember("exp2_step")).to_double();

  if (params->GetMember("exp3_param"))
    exp3_param= (*params->GetMember("exp3_param")).to_charPtr();
  if (params->GetMember("exp3_from"))
    exp3_from= (*params->GetMember("exp3_from")).to_double();
  if (params->GetMember("exp3_to"))
    exp3_to= (*params->GetMember("exp3_to")).to_double();
  if (params->GetMember("exp3_mode"))
    exp3_mode= (!strcmp((*params->GetMember("exp3_mode")).to_charPtr(), "aLIN")? 
	     aLIN: aLOG);
  if (params->GetMember("exp3_step"))
    exp3_step= (*params->GetMember("exp3_step")).to_double();


  if (params->GetMember("sa_overall_solu"))
    sa_overall_solu= (!strcmp((*params->GetMember("sa_overall_solu")).to_charPtr(),
		      "EMC_EXPLICIT")?EMC_EXPLICIT:FILL_IN_AVOIDANCE);
  if (params->GetMember("sa_distributed"))
    sa_distributed= (!strcmp((*params->GetMember("sa_distributed")).to_charPtr(),
		     "SEQUENTIAL")?SEQUENTIAL:DISTRIBUTED);
  if (params->GetMember("sa_epsilon"))
    sa_epsilon= (*params->GetMember("sa_epsilon")).to_double();
  if (params->GetMember("sa_max_iter"))
    sa_max_iter= (*params->GetMember("sa_max_iter")).to_int();
  if (params->GetMember("sa_trunc_error"))
    sa_trunc_error= (*params->GetMember("sa_trunc_error")).to_double();
  if (params->GetMember("sa_arith"))
    sa_arith= (!strcmp((*params->GetMember("sa_arith")).to_charPtr(),
	       "ARBITRARY")?ARBITRARY:DOUBLE);
  if (params->GetMember("sa_arb_bits"))
    sa_arb_bits= (*params->GetMember("sa_arb_bits")).to_int();
  if (params->GetMember("sa_lin_solu"))
    sa_lin_solu= (!strcmp((*params->GetMember("sa_lin_solu")).to_charPtr(),
		  "DIRECT")?DIRECT:ITERATIVE);
  if (params->GetMember("sa_init_vec"))
  {
    if (!strcmp((*params->GetMember("sa_init_vec")).to_charPtr(), "UNIFORM")) sa_init_vec = UNIFORM;
    else if (!strcmp((*params->GetMember("sa_init_vec")).to_charPtr(), "RANDOM")) sa_init_vec = RANDOM;
    else sa_init_vec = LOAD_FILE;
  }
  if (params->GetMember("sa_save_vec"))
    sa_save_vec= (*params->GetMember("sa_save_vec")).to_bool();
  if (params->GetMember("sa_seed_val"))
    sa_seed_val= (*params->GetMember("sa_seed_val")).to_int();


  if (params->GetMember("dtsa_solu"))
    dtsa_solu= (!strcmp((*params->GetMember("dtsa_solu")).to_charPtr(),"DIRECT")?DIRECT:ITERATIVE);
  if (params->GetMember("dtsa_max_iter"))
    dtsa_max_iter= (*params->GetMember("dtsa_max_iter")).to_int();
  if (params->GetMember("dtsa_epsilon"))
    dtsa_epsilon= (*params->GetMember("dtsa_epsilon")).to_double();
  if (params->GetMember("dtsa_embed"))
    dtsa_embed= (!strcmp((*params->GetMember("dtsa_embed")).to_charPtr(),"aNO")?aNO:
		 (!strcmp((*params->GetMember("dtsa_embed")).to_charPtr(),"aTIME")?aTIME:
		  aMEMO));
  if (params->GetMember("dtsa_scale"))
    dtsa_scale= (*params->GetMember("dtsa_scale")).to_int();

  if (params->GetMember("sp_epsilon"))
    sp_epsilon= (*params->GetMember("sp_epsilon")).to_double();
  if (params->GetMember("sp_solu"))
    sp_solu= (!strcmp((*params->GetMember("sp_solu")).to_charPtr(),"DIRECT")?DIRECT:ITERATIVE);
  if (params->GetMember("sp_max_iter"))
    sp_max_iter= (*params->GetMember("sp_max_iter")).to_int();
  if (params->GetMember("sp_droptol"))
    sp_droptol= (*params->GetMember("sp_droptol")).to_double();
  if (params->GetMember("sp_phases"))
    sp_phases= (*params->GetMember("sp_phases")).to_int();
  if (params->GetMember("sp_vphases"))
    sp_vphases= (*params->GetMember("sp_vphases")).to_int();

  if (params->GetMember("ss_distr"))
    ss_distr= (!strcmp((*params->GetMember("ss_distr")).to_charPtr(),"S")?SERIELL:PARALLEL);
  if (params->GetMember("ss_method"))
    ss_method= (!strcmp((*params->GetMember("ss_method")).to_charPtr(),"S")?mS: mC);
  if (params->GetMember("ss_detect"))
    ss_detect= (*params->GetMember("ss_detect")).to_bool();
  if (params->GetMember("ss_conf_level"))
    ss_conf_level= (*params->GetMember("ss_conf_level")).to_int();
  if (params->GetMember("ss_error_percnt"))
    ss_error_percnt= (*params->GetMember("ss_error_percnt")).to_int();
  if (params->GetMember("ss_epsilon_max"))
    ss_epsilon_max= (*params->GetMember("ss_epsilon_max")).to_int();
  if (params->GetMember("ss_random_seed"))
    ss_random_seed= (*params->GetMember("ss_random_seed")).to_int();
  if (params->GetMember("ss_max_samples"))
    ss_max_samples= (*params->GetMember("ss_max_samples")).to_int();
  if (params->GetMember("ss_min_firings"))
    ss_min_firings= (*params->GetMember("ss_min_firings")).to_int();
  if (params->GetMember("ss_max_modeltime"))
    ss_max_modeltime= (*params->GetMember("ss_max_modeltime")).to_double();
  if (params->GetMember("ss_max_realtime"))
    ss_max_realtime= (*params->GetMember("ss_max_realtime")).to_double();
  if (params->GetMember("ss_visu"))
    ss_visu= (*params->GetMember("ss_visu")).to_bool();
  if (params->GetMember("ss_thresholds"))
    ss_thresholds= (*params->GetMember("ss_thresholds")).to_int();
  if (params->GetMember("ss_pilotrun"))
    ss_pilotrun= (*params->GetMember("ss_pilotrun")).to_int();

  
  if (params->GetMember("ta_variant"))
    ta_variant= (!strcmp((*params->GetMember("ta_variant")).to_charPtr(),"aA")?aA:aB);
  if (params->GetMember("ta_output"))
    ta_output= (!strcmp((*params->GetMember("ta_output")).to_charPtr(),"aCURVE")?aCURVE:aPOINT);
  if (params->GetMember("ta_transtime"))
    ta_transtime= (*params->GetMember("ta_transtime")).to_double();
  if (params->GetMember("ta_epsilon"))
    ta_epsilon= (*params->GetMember("ta_epsilon")).to_double();
  if (params->GetMember("ta_stepsize"))
    ta_stepsize= (*params->GetMember("ta_stepsize")).to_double();
  if (params->GetMember("ta_internal"))
    ta_internal= (*params->GetMember("ta_internal")).to_double();
  if (params->GetMember("ta_clustersize"))
    ta_clustersize= (*params->GetMember("ta_clustersize")).to_int();

  if (params->GetMember("dtta_solu"))
    dtta_solu= (!strcmp((*params->GetMember("dtta_solu")).to_charPtr(),"DIRECT")?DIRECT:ITERATIVE);
  if (params->GetMember("dtta_max_iter"))
    dtta_max_iter= (*params->GetMember("dtta_max_iter")).to_int();
  if (params->GetMember("dtta_output"))
    dtta_output= (!strcmp( (*params->GetMember("dtta_output")).to_charPtr(),"aCURVE")?aCURVE:aPOINT);
  if (params->GetMember("dtta_timesteps"))
    dtta_timesteps= (*params->GetMember("dtta_timesteps")).to_int();
  if (params->GetMember("dtta_stepsize"))
    dtta_stepsize= (*params->GetMember("dtta_stepsize")).to_int();
  if (params->GetMember("dtta_firststep"))
    dtta_firststep= (*params->GetMember("dtta_firststep")).to_int();
  if (params->GetMember("dtta_epsilon"))
    dtta_epsilon= (*params->GetMember("dtta_epsilon")).to_double();
  if (params->GetMember("dtta_embed"))
    dtta_embed= (!strcmp((*params->GetMember("dtta_embed")).to_charPtr(),"aNO")?aNO:
		 (!strcmp((*params->GetMember("dtta_embed")).to_charPtr(),"aTIME")?aTIME:
		  aMEMO));
  if (params->GetMember("dtta_scale"))
    dtta_scale= (*params->GetMember("dtta_scale")).to_int();

  if (params->GetMember("ts_distr"))
    ts_distr= (!strcmp((*params->GetMember("ts_distr")).to_charPtr(),"S")?SERIELL:PARALLEL);
  if (params->GetMember("ts_rule"))
    ts_rule= (*params->GetMember("ts_rule")).to_bool();
  if (params->GetMember("ts_transient_time"))
    ts_transient_time= (*params->GetMember("ts_transient_time")).to_double();
  if (params->GetMember("ts_no_sampling_points"))
    ts_no_sampling_points= (*params->GetMember("ts_no_sampling_points")).to_int();
  if (params->GetMember("ts_conf_level"))
    ts_conf_level= (*params->GetMember("ts_conf_level")).to_int();
  if (params->GetMember("ts_epsilon_max"))
    ts_epsilon_max= (*params->GetMember("ts_epsilon_max")).to_double();
  if (params->GetMember("ts_random_seed"))
    ts_random_seed= (*params->GetMember("ts_random_seed")).to_int();
  if (params->GetMember("ts_max_realtime"))
    ts_max_realtime= (*params->GetMember("ts_max_realtime")).to_double();
}

// -----------------------------------------------------------------

void TimeNETLink::DefaultParams(StructP params)
{
  if (params->GetMember("pr_gdesc"))
    *params->GetMember("pr_gdesc")= "ps";
  if (params->GetMember("pr_tdesc"))
    *params->GetMember("pr_tdesc")= "ps";
  if (params->GetMember("pr_graph"))
    *params->GetMember("pr_graph")= true;
  if (params->GetMember("pr_text"))
    *params->GetMember("pr_text")= false;
  if (params->GetMember("pr_dest"))
    *params->GetMember("pr_dest")= "printer";
  if (params->GetMember("pr_cmd"))
    *params->GetMember("pr_cmd")= "-Pfr2518";

  if (params->GetMember("exp_param"))
    *params->GetMember("exp_param")= "";
  if (params->GetMember("exp_from"))
    *params->GetMember("exp_from")= 0.0;
  if (params->GetMember("exp_to"))
    *params->GetMember("exp_to")= 1.0;
  if (params->GetMember("exp_mode"))
    *params->GetMember("exp_mode")= "aLIN";
  if (params->GetMember("exp_step"))
    *params->GetMember("exp_step")= 1.0;

  if (params->GetMember("exp2_param"))
    *params->GetMember("exp2_param")= "";
  if (params->GetMember("exp2_from"))
    *params->GetMember("exp2_from")= 0.0;
  if (params->GetMember("exp2_to"))
    *params->GetMember("exp2_to")= 1.0;
  if (params->GetMember("exp2_mode"))
    *params->GetMember("exp2_mode")= "aLIN";
  if (params->GetMember("exp2_step"))
    *params->GetMember("exp2_step")= 1.0;

  if (params->GetMember("exp3_param"))
    *params->GetMember("exp3_param")= "";
  if (params->GetMember("exp3_from"))
    *params->GetMember("exp3_from")= 0.0;
  if (params->GetMember("exp3_to"))
    *params->GetMember("exp3_to")= 1.0;
  if (params->GetMember("exp3_mode"))
    *params->GetMember("exp3_mode")= "aLIN";
  if (params->GetMember("exp3_step"))
    *params->GetMember("exp3_step")= 1.0;

  if (params->GetMember("sa_overall_solu"))
    *params->GetMember("sa_overall_solu")= "EMC_EXPLICIT";
  if (params->GetMember("sa_distributed"))
    *params->GetMember("sa_distributed")= "SEQUENTIAL";
  if (params->GetMember("sa_epsilon"))
    *params->GetMember("sa_epsilon")= 1e-07;
  if (params->GetMember("sa_max_iter"))
    *params->GetMember("sa_max_iter")= 10000;
  if (params->GetMember("sa_trunc_error"))
    *params->GetMember("sa_trunc_error")= 1e-07;
  if (params->GetMember("sa_arith"))
    *params->GetMember("sa_arith")= "ARBITRARY";
  if (params->GetMember("sa_arb_bits"))
    *params->GetMember("sa_arb_bits")= 512;
  if (params->GetMember("sa_lin_solu"))
    *params->GetMember("sa_lin_solu")= "DIRECT";
  if (params->GetMember("sa_init_vec"))
    *params->GetMember("sa_init_vec")= "UNIFORM";
  if (params->GetMember("sa_seed_val"))
    *params->GetMember("sa_seed_val")= 12345;
  if (params->GetMember("sa_save_vec"))
    *params->GetMember("sa_save_vec")= false;

  if (params->GetMember("dtsa_solu"))
    *params->GetMember("dtsa_solu")= "DIRECT";
  if (params->GetMember("dtsa_max_iter"))
    *params->GetMember("dtsa_max_iter")= 1000;
  if (params->GetMember("dtsa_epsilon"))
    *params->GetMember("dtsa_epsilon")= 1e-07;
  if (params->GetMember("dtsa_embed"))
    *params->GetMember("dtsa_embed")= "aNO";
  if (params->GetMember("dtsa_scale"))
    *params->GetMember("dtsa_scale")= 1;

  if (params->GetMember("sp_epsilon"))
    *params->GetMember("sp_epsilon")= 1e-07;
  if (params->GetMember("sp_solu"))
    *params->GetMember("sp_solu")= "DIRECT";
  if (params->GetMember("sp_max_iter"))
    *params->GetMember("sp_max_iter")= 10000;
  if (params->GetMember("sp_droptol"))
    *params->GetMember("sp_droptol")= 0;
  if (params->GetMember("sp_phases"))
    *params->GetMember("sp_phases")= 2;
  if (params->GetMember("sp_vphases"))
    *params->GetMember("sp_vphases")= 10;

  if (params->GetMember("ss_distr"))
    *params->GetMember("ss_distr")= "S";
  if (params->GetMember("ss_method"))
    *params->GetMember("ss_method")= "S";
  if (params->GetMember("ss_detect"))
    *params->GetMember("ss_detect")= true;
  if (params->GetMember("ss_conf_level"))
    *params->GetMember("ss_conf_level")= 95;
  if (params->GetMember("ss_error_percnt"))
    *params->GetMember("ss_error_percnt")= 50;
  if (params->GetMember("ss_epsilon_max"))
    *params->GetMember("ss_epsilon_max")= 10;
  if (params->GetMember("ss_random_seed"))
    *params->GetMember("ss_random_seed")= 12345;
  if (params->GetMember("ss_max_samples"))
    *params->GetMember("ss_max_samples")= 0;
  if (params->GetMember("ss_min_firings"))
    *params->GetMember("ss_min_firings")= 50;
  if (params->GetMember("ss_max_modeltime"))
    *params->GetMember("ss_max_modeltime")= 0.0;
  if (params->GetMember("ss_max_realtime"))
    *params->GetMember("ss_max_realtime")= 0.0;
  if (params->GetMember("ss_visu"))
    *params->GetMember("ss_visu")= false;
  if (params->GetMember("ss_thresholds"))
    *params->GetMember("ss_thresholds")= 6;
  if (params->GetMember("ss_pilotrun"))
    *params->GetMember("ss_pilotrun")= 600;

  if (params->GetMember("ta_variant"))
    *params->GetMember("ta_variant")= "aB";
  if (params->GetMember("ta_output"))
    *params->GetMember("ta_output")= "aCURVE";
  if (params->GetMember("ta_transtime"))
    *params->GetMember("ta_transtime")= 10;
  if (params->GetMember("ta_epsilon"))
    *params->GetMember("ta_epsilon")= 1e-07;
  if (params->GetMember("ta_stepsize"))
    *params->GetMember("ta_stepsize")= 0.1;
  if (params->GetMember("ta_internal"))
    *params->GetMember("ta_internal")= 0.1;
  if (params->GetMember("ta_clustersize"))
    *params->GetMember("ta_clustersize")= 10;

  if (params->GetMember("dtta_solu"))
    *params->GetMember("dtta_solu")= "DIRECT";
  if (params->GetMember("dtta_max_iter"))
    *params->GetMember("dtta_max_iter")= 1000;
  if (params->GetMember("dtta_output"))
    *params->GetMember("dtta_output")= "aCURVE";
  if (params->GetMember("dtta_timesteps"))
    *params->GetMember("dtta_timesteps")= 100;
  if (params->GetMember("dtta_stepsize"))
    *params->GetMember("dtta_stepsize")= 10;
  if (params->GetMember("dtta_firststep"))
    *params->GetMember("dtta_firststep")= 0;
  if (params->GetMember("dtta_epsilon"))
    *params->GetMember("dtta_epsilon")= 1e-07;
  if (params->GetMember("dtta_embed"))
    *params->GetMember("dtta_embed")= "aNO";
  if (params->GetMember("dtta_scale"))
    *params->GetMember("dtta_scale")= 1;

  if (params->GetMember("ts_distr"))
    *params->GetMember("ts_distr")= "S";
  if (params->GetMember("ts_rule"))
    *params->GetMember("ts_rule")= true;
  if (params->GetMember("ts_transient_time"))
    *params->GetMember("ts_transient_time")= 10;
  if (params->GetMember("ts_no_sampling_points"))
    *params->GetMember("ts_no_sampling_points")= 10;
  if (params->GetMember("ts_conf_level"))
    *params->GetMember("ts_conf_level")= 95;
  if (params->GetMember("ts_epsilon_max"))
    *params->GetMember("ts_epsilon_max")= 10;
  if (params->GetMember("ts_random_seed"))
    *params->GetMember("ts_random_seed")= 12345;
  if (params->GetMember("ts_max_realtime"))
    *params->GetMember("ts_max_realtime")= 0.0;
}

// -----------------------------------------------------------------

void TimeNETLink::CheckStructure(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  char call[256];
  
  SaveTN(&ed, ((Text(model_dir)+"/"+netname+TN_ENDING)).to_charPtr());
  
  strcat(strcat(strcat(strcpy(call,"csh -e -f "),tnet_dir.to_charPtr()), 
		"/StatAnalysis/scripts/structure "), netname.to_charPtr());

  Text ecsfile= Text(model_dir)+"/"+netname+".ECS";
  Text invfile= Text(model_dir)+"/"+netname+".INV";
  
  system(call);
  
  closereason= 1;
  CreateLogwin(ecsfile.to_charPtr());
  OpenLogwin(ed, "Conflicts", "Close");
  CreateLogwin(invfile.to_charPtr());
  OpenLogwin(ed, "Invariants", "Close");
}

// -----------------------------------------------------------------

bool TimeNETLink::NetTransform(Editor& ed)
{
    SetNetName();

  if (!CheckNet())
    return false;
  // Testet die Syntax des Netzes
   SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
   return true;
}

void TimeNETLink::EstimSE(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  strcat(strcat(strcpy(call,tnet_dir.to_charPtr()), 
		"/StatAnalysis/scripts/estimse "), netname.to_charPtr());

  Text invfile= model_dir+"/"+netname+".ese";
  
  ofstream outf(invfile.to_charPtr(), ios::trunc);outf.close();
  pidEstimSE= Exec(call, invfile.to_charPtr(), (char*)NULL);
  
  closereason= 2;
  killreason= 13;
  CreateLogwin(invfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Estimate Statespace", "Close");
}
// -----------------------------------------------------------------

void TimeNETLink::Traps(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  strcat(strcat(strcpy(call,tnet_dir.to_charPtr()), 
		"/StatAnalysis/scripts/traps "), netname.to_charPtr());

  Text invfile= model_dir+"/"+netname+".traps";
  
  ofstream outf(invfile.to_charPtr(), ios::trunc);outf.close();
  pidTraps= Exec(call, invfile.to_charPtr(), (char*)NULL);
  
  closereason= 2;
  killreason= 14;
  CreateLogwin(invfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Traps", "Close");
}
// -----------------------------------------------------------------

void TimeNETLink::Siphons(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  strcat(strcat(strcpy(call,tnet_dir.to_charPtr()), 
		"/StatAnalysis/scripts/siphons "), netname.to_charPtr());

  Text invfile= model_dir+"/"+netname+".siphons";
  
  ofstream outf(invfile.to_charPtr(), ios::trunc);outf.close();
  pidSiphons= Exec(call, invfile.to_charPtr(), (char*)NULL);
  
  closereason= 2;
  killreason= 15;
  CreateLogwin(invfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Siphons", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::StationaryAnalysis(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();
  for (NodeP node=ListNodes; node; node=++ListNodes)
    if (IsTransition(node) && !IsExpTrans(node) && 
	!strcmp((*GetPolicy(node)).to_charPtr(),"PRS"))
      {
	Text DialogContense;
	DialogContense+= "StationaryAnalysis is not possible for\n";
	DialogContense+= "non-exponential transitions with\n";
	DialogContense+= "preemption policy: PRS\n";
	DialogContense+= "while parsing:\n";
	DialogContense+= (node->Class()->GroupName()).to_charPtr();
	DialogContense+= "(";
	DialogContense+= (node->Class()->Name()).to_charPtr();
	DialogContense+= ") ";
	DialogContense+= (node->Name()).to_charPtr();
	
	OpenMsgDialog(*this->ed, "TimeNET_Error",
		      DialogContense.to_charPtr(),true,"Close");
	return;
      }

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/StatAnalysis/scripts/SOLVE";
  if (sa_overall_solu==EMC_EXPLICIT)
    {
      params+= " -E";
      params+= (sa_distributed==DISTRIBUTED?" -p":" -s");
      if (sa_lin_solu==ITERATIVE)
	{
	  params+= " -i ";
	  params+= double(sa_max_iter);
	}
      else
	params+= " -d";
    }
  else
    {
      params+= " -I ";
      params+= double(sa_max_iter); 
      params+= (sa_distributed==DISTRIBUTED?" -p":" -s");
      if (sa_init_vec==UNIFORM)
	params+= " -u";
      else if (sa_init_vec==RANDOM)
	{
	  params+= " -r ";
	  params+= double(sa_seed_val);
	}
      else
	params+= " -l";
      if (sa_save_vec) params+= " -v";
    }
  if (sa_arith==ARBITRARY)
    {
      params+= " -a ";
      params+= double(sa_arb_bits);
    }
  params+= " ";
  params+= netname;
  params+= " ";
  params+= sa_epsilon;
  params+= " ";
  params+= sa_trunc_error;
  
  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());
  
  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidStationaryAnalysis= Exec(call, outfile.to_charPtr(), (char*)NULL);
  
  closereason= 2;
  killreason= 1;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Stationary Analysis", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::StationaryAnalysisDTSPN(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes
  
  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/DTSPN/scripts/dtspn ";
  params+= netname;
  params+= " -s ";
  params+= (dtsa_embed==aNO?"-en ":(dtsa_embed==aTIME?"-et ":"-em "));
  if (dtsa_solu==ITERATIVE)
    params+= "-i ";
  else 
    params+= "-a ";
  params+= double(dtsa_max_iter);
  params+= " ";
  params+= double(dtsa_scale);
  params+= " ";
  params+= double(dtsa_epsilon);
  
  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());
  
  Text outfile= Text(model_dir)+"/"+netname+".log";
  
  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidStationaryAnalysisDTSPN= Exec(call, outfile.to_charPtr(), (char*)NULL);
  
  closereason= 2;
  killreason= 9;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Stationary Analysis DTSPN", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::StationaryApproximation(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/Approximation/scripts/APPROX ";
  params+= "-m ";
  if (sp_solu==ITERATIVE)
    params+= "iterate ";
  else
    params+= "direct ";
  params+= "-p ";
  params+= double(sp_epsilon);
  params+= " -i ";
  params+= double(sp_max_iter);
  params+= " -t ";
  params+= double(sp_droptol);
  params+= " -r ";
  params+= double(sp_phases);
  params+= " -c ";
  params+= double(sp_vphases);
  params+= " ";
  params+= netname;

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());
  
  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidStationaryApproximation= Exec(call, outfile.to_charPtr(), (char*)NULL);

  closereason= 2;
  killreason= 2;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Stationary Approximation", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::RestartStSimulation(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/Simulation/scripts/RESTART ";
  params+= netname;
  params+= " ";
  params+= (ss_distr==SERIELL?"-S ":"-D ");
  params+= double(ss_pilotrun);
  params+= " ";
  params+= double(ss_thresholds);
  params+= " ";
  params+= "-T";
  if (ss_detect)
    params+= "on ";
  else
    params+= "off ";
  params+= double(ss_conf_level);
  params+= " ";
  params+= double(ss_epsilon_max);
  params+= " ";
  params+= double(ss_random_seed);
  params+= " ";
  params+= double(ss_max_samples);
  params+= " ";
  params+= double(ss_min_firings);
  params+= " ";
  params+= ss_max_modeltime;
  params+= " ";
  params+= ss_max_realtime;

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidRestartStSimulation= Exec(call, outfile.to_charPtr(), (char*)NULL);
  // TimeNET starten mit der temporaeren Datei

  closereason= 2;
  killreason= 7;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Restart Stationary Simulation", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::StationarySimulation(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/Simulation/scripts/SIMULATE ";
  params+= netname;
  params+= " ";
  params+= (ss_distr==SERIELL?"-S ":"-D ");
  params+= (ss_method==mS?"-S ":"-C ");
  params+= "-T";
  if (ss_detect)
    params+= "on";
  else
    params+= "off";
  params+= " ";
  params+= double(ss_conf_level);
  params+= " ";
  params+= double(ss_error_percnt);
  params+= " ";
  params+= double(ss_epsilon_max);
  params+= " ";
  params+= double(ss_random_seed);
  params+= " ";
  params+= double(ss_max_samples);
  params+= " ";
  params+= double(ss_min_firings);
  params+= " ";
  params+= ss_max_modeltime;
  params+= " ";
  params+= ss_max_realtime;
  params+= " ";
  params+= (ss_visu?"-Von":"-Voff");

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidStationarySimulation= Exec(call, outfile.to_charPtr(), (char*)NULL);
  // TimeNET starten mit der temporaeren Datei

  closereason= 2;
  killreason= 3;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Stationary Simulation", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::TransientAnalysis(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/TransientSolution/scripts/TransSolve -t ";
  params+= double(ta_transtime);
  params+= " -s ";
  params+= double(ta_stepsize);
  params+= " -o ";
  params+= (ta_output==aCURVE?"curve":"point");
  params+= " -r ";
  params+= double(ta_internal);
  params+= " -c ";
  params+= double(ta_clustersize);
  params+= " -p ";
  params+= double(ta_epsilon);
  params+= " -x -k ";
  params+= netname;

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());






  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidTransientAnalysis= Exec(call, outfile.to_charPtr(), (char*)NULL);

  closereason= 2;
  killreason= 4;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Transient Analysis", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::TransientAnalysisDTSPN(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/DTSPN/scripts/dtspn ";
  params+= netname;
  params+= " -t ";
  params+= (dtta_embed==aNO?"-en ":(dtta_embed==aTIME?"-et ":"-em "));
  params+= "-a -1";
  params+= " ";
  params+= double(dtta_scale);
  params+= " ";
  params+= double(dtta_epsilon);
  params+= " ";
  if (dtta_stepsize!=0)
    {
      params+= "-c ";
      params+= double(dtta_firststep);
      params+= " ";
      params+= double(dtta_timesteps);
      params+= " ";
      params+= double(dtta_stepsize);
    }
  else
    {
      params+= "-p ";
      params+= double(dtta_timesteps);
    }

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidTransientAnalysisDTSPN= Exec(call, outfile.to_charPtr(), (char*)NULL);

  closereason= 2;
  killreason= 10;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Transient Analysis DTSPN", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::TransientSimulation(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());
  
  Text params;
  params+= "/Simulation/scripts/SIM_TRAN ";
  params+= netname;
  params+= " ";
  params+= (ts_distr==SERIELL?"-S ":"-D ");
  params+= (ts_rule?"-Pon ":"-Poff ");
  params+= ts_transient_time;
  params+= " ";
  params+= double(ts_no_sampling_points);
  params+= " ";
  params+= double(ts_conf_level);
  params+= " ";
  params+= ts_epsilon_max;
  params+= " ";
  params+= double(ts_random_seed);
  params+= " ";
  params+= ts_max_realtime;

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidTransientSimulation= Exec(call, outfile.to_charPtr(), (char*)NULL);

  closereason= 2;
  killreason= 5;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Transient Simulation", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::Experiment(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  Iterator<NodeP> ListNodes= net.Prime()->Nodes();
  for (NodeP node=ListNodes; node; node=++ListNodes)
    if (IsTransition(node) && !IsExpTrans(node) && 
	!strcmp((*GetPolicy(node)).to_charPtr(),"PRS"))
      {
	Text DialogContense;
	DialogContense+= "StationaryAnalysis is not possible for\n";
	DialogContense+= "non-exponential transitions with\n";
	DialogContense+= "preemption policy: PRS\n";
	DialogContense+= "while parsing:\n";
	DialogContense+= (node->Class()->GroupName()).to_charPtr();
	DialogContense+= "(";
	DialogContense+= (node->Class()->Name()).to_charPtr();
	DialogContense+= ") ";
	DialogContense+= (node->Name()).to_charPtr();
	
	OpenMsgDialog(*this->ed, "TimeNET_Error",
		      DialogContense.to_charPtr(),true,"Close");
	return;
      }

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());

  Text params;

  params+= "/StatAnalysis/scripts/MSOLVE";
  if (sa_overall_solu==EMC_EXPLICIT)
    {
      params+= " -E";
      params+= (sa_distributed==DISTRIBUTED?" -p":" -s");
      if (sa_lin_solu==ITERATIVE)
	{
	  params+= " -i ";
	  params+= double(sa_max_iter);
	}
      else
	params+= " -d";
    }
  else
    {
      params+= " -I ";
      params+= double(sa_max_iter); 
      params+= (sa_distributed==DISTRIBUTED?" -p":" -s");
      if (sa_init_vec==UNIFORM)
	params+= " -u";
      else if (sa_init_vec==RANDOM)
	{
	  params+= " -r ";
	  params+= double(sa_seed_val);
	}
      else
	params+= " -l";
    }
  if (sa_arith==ARBITRARY)
    {
      params+= " -a ";
      params+= double(sa_arb_bits);
    }
  if (exp_mode!=aLIN)
    {
      params+= " -B ";
      params+= double(10);
    }
  params+= " ";
  params+= (!FindMarkingParameter(exp_param.to_charPtr()))?"-D ":"-M ";
  params+= exp_param;
  params+= " ";
  params+= netname;
  params+= " ";
  params+= sa_epsilon;
  params+= " ";
  params+= sa_trunc_error;
  params+= " ";
  params+= double(exp_from);
  params+= " ";
  params+= double(exp_to);
  params+= " ";
  params+= double(exp_step);
  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidExperiment= Exec(call, outfile.to_charPtr(), (char*)NULL);

  closereason= 2;
  killreason= 6;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Experiment St.An.", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::Experiment2(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());

  Text params;
  params+= "/Simulation/scripts/MSIM ";
  params+= netname;
  params+= " ";
  params+= exp2_param;
  params+= (!FindMarkingParameter(exp2_param.to_charPtr()))?" r ":" m ";
  params+= double(exp2_from);
  params+= " ";
  params+= double(exp2_to);
  params+= " ";
  params+= double(exp2_step);
  params+= " ";
  params+= (ss_distr==SERIELL?"-S ":"-D ");
  params+= (ss_method==mS?"-S ":"-C ");
  params+= double(ss_conf_level);
  params+= " ";
  params+= double(ss_error_percnt);
  params+= " ";
  params+= double(ss_epsilon_max);
  params+= " ";
  params+= double(ss_random_seed);
  params+= " ";
  params+= double(ss_max_samples);
  params+= " ";
  params+= double(ss_min_firings);
  params+= " ";
  params+= ss_max_modeltime;
  params+= " ";
  params+= ss_max_realtime;
  if (exp2_mode!=aLIN)
    {
      params+= " ";
      params+= double(10);
    }
  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidExperiment2= Exec(call, outfile.to_charPtr(), (char*)NULL);

  closereason= 2;
  killreason= 8;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Experiment St.Si.", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::Experiment3(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  char call[256];
  
  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());

  Text params;
  params+= "/DTSPN/scripts/MSOLVE ";
  params+= netname;
  params+= " ";
  params+= exp3_param;
  params+= (!FindMarkingParameter(exp3_param.to_charPtr()))?" d ":" m ";
  params+= double(exp3_from);
  params+= " ";
  params+= double(exp3_to);
  params+= " ";
  params+= double(exp3_step);
  if (exp3_mode!=aLIN)
    {
      params+= " ";
      params+= double(10);
    }

  strcat(strcpy(call,tnet_dir.to_charPtr()),
	 params.to_charPtr());

  Text outfile= Text(model_dir)+"/"+netname+".log";

  ofstream outf(outfile.to_charPtr(), ios::trunc);outf.close();
  pidExperiment3= Exec(call, outfile.to_charPtr(), (char *)NULL);

  closereason= 2;
  killreason= 11;
  CreateLogwin(outfile.to_charPtr());
  SetAutoScrollDown(true);
  OpenLogwin(ed, "Experiment St.An. DTSPN", "Close");
}

// -----------------------------------------------------------------

void TimeNETLink::GnuPlot(Editor& ed)
{
  if (pidGnuPlot)
    {
      killpg(pidGnuPlot, SIGTERM);
      pidGnuPlot= 0;
    }
  SetNetName();

  Text tabfile = Text(ed.GetNet()->FileName()) - NET_ENDING - TN_ENDING + 
    ".val_tab";
  ifstream tabstream;
  tabstream.open(tabfile.to_charPtr());
 
  if (!tabstream)
    {
      tabfile= Text(model_dir)+"/"+netname+".val_tab";
      tabstream.open(tabfile.to_charPtr());
      if (!tabstream)
	{
	  Text DialogContense2;
	  DialogContense2+= "'<model>.val_tab' does not exist!";
	  OpenMsgDialog(ed, "TimeNET_Error",
			DialogContense2.to_charPtr(),true,"Close");
	  return;
	}
    }
      
  Text infile= Text(model_dir)+"/"+netname+".in";
  ofstream inputgnu(infile.to_charPtr());

  inputgnu << "set data style linespoints" << endl;

  if (gp_logx || gp_logy)
    {
      inputgnu << "set logscale ";
      if (gp_logx)
	inputgnu << "x";
      if (gp_logy)
	inputgnu << "y";
      inputgnu << endl;
      }
  if (*(gp_xdescr.to_charPtr()))
    inputgnu << "set xlabel " << gp_xdescr << endl;
  if (*(gp_ydescr.to_charPtr()))
    inputgnu << "set ylabel " << gp_ydescr << endl;

  inputgnu << "plot " << tabfile << " using " << gp_xvalue << ":" << gp_yvalue;

  if (*(gp_title.to_charPtr()))
    inputgnu << " t " << gp_title;

  inputgnu << endl << "pause 32767" << endl << flush;

  inputgnu.close();

  char call[1024];

  // RD changed: Call shell script gplot instead of gnuplot
  // to avoid definition of GPDIR.
  strcat(strcat(strcpy(call,tnet_dir.to_charPtr()), 
	       "/Shared/scripts/gplot "), infile.to_charPtr());

  pidGnuPlot= Exec(call, (char *)NULL, infile.to_charPtr());
}

// -----------------------------------------------------------------

void TimeNETLink::ClearResults(Editor&)
{

  Iterator<NodeP> niter= net.Prime()->Nodes();
  for (NodeP node=niter; node; node=++niter)
    
    if (IsParameter(node) && IsRewItem(node))
      {  
	TextP res;
	if ((res= GetResult(node)))
	  {
	    *res= NO_RESULT;
	  }
      }
  this->ed->Update();
}

// -----------------------------------------------------------------

void TimeNETLink::GetResults(Editor&)
{
  SetNetName();

  Text results_name= Text(model_dir)+"/"+netname+".RESULTS";

  char dummy;
  double value;
  char result[2048], readbuf[2048];
  
  FILE* fp;
  if ((fp= fopen(results_name.to_charPtr(),"r"))!=0)
    {
      fseek(fp, 0, SEEK_END);
      if (!ftell(fp))
	{
	  Text DialogContense;
	  DialogContense+= "there are no results available!";
	  
	  OpenMsgDialog(*this->ed, "TimeNET_Error",
			DialogContense.to_charPtr(),true,"Close");
	  return;
	}

      fseek(fp, 0, SEEK_SET);
      int anz;
      do
	{ 
          fgets(readbuf, 2048, fp); // read one full line
          // result format: <name> = <value>
	  anz= sscanf(readbuf, "%s %c %lf", result, &dummy, &value);
	  if (dummy == '=')
	    {
	      Iterator<NodeP> niter= net.Prime()->Nodes();
	      for (NodeP node=niter; node; node=++niter)
		
		if (IsParameter(node) && IsRewItem(node))
		  
		  if (!strcmp((node->Name()).to_charPtr(), result))
		    {
		      TextP res;
		      if ((res= GetResult(node)))
			{
			  sprintf(result, "%f", value);
			  *res= result;
			}
		    }
	    }
	} while (!feof(fp)); // Armin old: ((anz==3)&&(dummy=='='));
                             // changed to read different RESULT formats
      
      fclose(fp);
    }
  else
    {
      Text DialogContense;
      DialogContense+= "there are no results available!";
      
      OpenMsgDialog(*this->ed, "TimeNET_Error",
		    DialogContense.to_charPtr(),true,"Close");
    }
  this->ed->Update();
}

// -----------------------------------------------------------------

void TimeNETLink::Print(Editor& ed)
{
  SetNetName();

  if (!CheckNet())
    return;
  // Testet die Syntax des Netzes

  SaveTN(&ed, (Text(model_dir)+"/"+netname+TN_ENDING).to_charPtr());

  ValueP value;
  Text prgpath;

  prgpath+= "csh -e -f ";
  prgpath+= tnet_dir;
  prgpath+= "/Print/scripts/Paint ";
  
  if (pr_graph)
    {
      if (pr_dest==aPRINTER)
	{// PrinterPaint
	  
	  prgpath+= pr_cmd.to_charPtr();
	}
      else
	{
	  if (pr_gdesc==aPS)
	    {// PS Filepaint

	      prgpath+= "-ps";
	    }
	  else
	    {// EPS Filepaint
	      
	      prgpath+= "-e";
	    }
	}
      
      prgpath+= (((value= net.Class()->Attributes().GetMember("spline"))) && 
		 ((*value).to_bool()==true))?" -c ":" ";
      prgpath+= netname;
      // RD removed: prgpath+= TN_ENDING;
      
      system(prgpath.to_charPtr());
    }
  // else: none Paint

  Text prgpath2;

  prgpath2+= "csh -e -f ";
  prgpath2+= tnet_dir;
  prgpath2+= "/Print/scripts/Print ";
  
  if (pr_text)
    {
      if (pr_dest==aPRINTER)
	{// PrinterPrint
	  
	  prgpath2+= pr_cmd.to_charPtr();
	}
      else
	{
	  if (pr_tdesc==aPS2)
	    {// PS Fileprint

	      prgpath2+= "-ps";
	    }
	  else
	    {// LATEX Fileprint
	      
	      prgpath2+= "-t";
	    }
	}
      
      prgpath2+= " ";
      prgpath2+= netname;

      system(prgpath2.to_charPtr());
    }
  // else: none Print
}

// -----------------------------------------------------------------
// Syntax-Checker
// -----------------------------------------------------------------

NodeP TimeNETLink::FindMarkingParameter(charP Name)
{
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();
  for (NodeP node=ListNodes; node; node=++ListNodes)

    if (IsParameter(node) && IsMarkPar(node))
      if (!strcmp((node->Name()).to_charPtr(), Name))

	return (node);

  //AH Changed Start => (NodeP)
  return (NodeP)NULL;
  //AH Changed End
  // nicht gefunden
}

// -----------------------------------------------------------------

bool TimeNETLink::CheckNet(bool okwindow)
{
  Iterator<NodeP> ListNodes= net.Prime()->Nodes();
  for (NodeP node=ListNodes; node; node=++ListNodes)
    {
      if (IsParameter(node) && IsMarkPar(node))
	{
	  int markpar= (*GetMarkPar(node)).to_int();
	  if (markpar<0)
	    {
	      Text DialogContense;
	      DialogContense+= "Contense of MARKPAR must be positiv:";

	      firsttime= true;
	      ParserObject= node;
	  //AH Changed Start => (TextP)
	      ParserText= (TextP)NULL;
  //AH Changed End
	      type= param_def;

	      ParserError(DialogContense.to_charPtr(),
			  (node->Name()).to_charPtr(), (int)strlen((node->Name()).to_charPtr()));
	      return false;
	    }
	}
      // Check MARKPARs

      if (IsParameter(node) && IsDelayPar(node))
	{
	  charP delaypar= (*GetDelayPar(node)).to_charPtr();
	  if (!delaypar || !*delaypar)
	    {
	      Text DialogContense;
	      DialogContense+= "Missing DELAYPAR definition:";
	      
	      firsttime= true;
	      ParserObject= node;
	      ParserText= GetDelayPar(node);
	      type= param_def;
	      
	      ParserError(DialogContense.to_charPtr(),
			  delaypar, (int)strlen(delaypar));
	      return false;
	    }
	  else
	    {
	      firsttime= true;
	      ParserObject= node;
	      ParserText= GetDelayPar(node);
	      RecursionError= false;
	      Recursion.Clear();
	      
	      Parse_param_def(delaypar);
	      *GetIsMDDelayPar(node)= IsMDDelayPar;
	      if (error)
		return false;
	    }
	}
      // Check DELAYPARs

      if (IsParameter(node) && IsRewItem(node))
	{
	  charP rew_item= (*GetRewItem(node)).to_charPtr();
	  if (!rew_item || !*rew_item)
	    {
	      Text DialogContense;
	      DialogContense+= "Missing MEASURE definition:";
	      
	      firsttime= true;
	      ParserObject= node;
	  //AH Changed Start => (TextP)
	      ParserText=(TextP) NULL;
  //AH Changed End
	      type= reward_def;
	      
	      ParserError(DialogContense.to_charPtr(),
			  (node->Name()).to_charPtr(), (int)strlen( (node->Name()).to_charPtr() ));
	      return false;
	    }
	  else
	    {
	      firsttime= true;
	      ParserObject= node;
	      ParserText= GetRewItem(node);
	      Recursion.Clear();
	      RecursionError= false;
	      
	      Parse_reward_def(rew_item);
	      if (error)
		return false;
	    }
	}
      // Check MEASUREs

      if (IsPlace(node))
	{
	  charP marking= (*GetMarking(node)).to_charPtr();
	  if (!marking || !*marking)
	    {
	      Text DialogContense;
	      DialogContense+= "Missing PLACE definition:";
	      
	      firsttime= true;
	      ParserObject= node;
	  //AH Changed Start => (TextP)
	      ParserText= (TextP)NULL;
  //AH Changed End
	      type= none;
	      
	      ParserError(DialogContense.to_charPtr(),
			  (node->Name()).to_charPtr(), (int)strlen( (node->Name()).to_charPtr() ));
	      return false;
	    }
	  else if (isalpha(marking[0]))
	    {
	      NodeP markpar= FindMarkingParameter(marking);
	      if (!markpar)
		{
		  Text DialogContense;
		  DialogContense+= "MARKPAR does not exist:";
		  
		  firsttime= true;
		  ParserObject= node;
		  ParserText= GetMarking(node);
		  type= none;
		  
		  ParserError(DialogContense.to_charPtr(),
			      marking, (int)strlen(marking));
		  return false;
		}
	    }
	  else if (marking[0]=='-')
	    {
	      Text DialogContense;
	      DialogContense+= "Contense of PLACE must be positiv:";
	      
	      firsttime= true;
	      ParserObject= node;
	      ParserText= GetMarking(node);
	      type= none;
	      
	      ParserError(DialogContense.to_charPtr(),
			  marking, (int)strlen(marking));
	      return false;
	    }
	  if (!isalpha(marking[0]))
	    for (int i=0; i<(int)strlen(marking); i++)
	      if (!isdigit(marking[i]))
		{
		  Text DialogContense;
		  DialogContense+= "Contense of PLACE must be of type CARDINAL:";
		  
		  firsttime= true;
		  ParserObject= node;
		  ParserText= GetMarking(node);
		  type= none;
		  
		  ParserError(DialogContense.to_charPtr(),
			      marking, strlen(marking));
		  return false;
		}
	}
      // Check PLACEs

      if (IsTransition(node))
	{
	  if (IsGenTrans(node))
	    {
	      charP pmfunc= (*GetPMFunc(node)).to_charPtr();
	      if (!pmfunc || !*pmfunc)
		{
		  Text DialogContense;
		  DialogContense+= "Missing GEN_DELAY definition:";
		  
		  firsttime= true;
		  ParserObject= node;
	  //AH Changed Start => (TextP)
		  ParserText= (TextP)NULL;
  //AH Changed End
		  type= pmf_def;
		  
		  ParserError(DialogContense.to_charPtr(),
			      (node->Name()).to_charPtr(), (int)strlen((node->Name()).to_charPtr()));
		  return false;
		}
	      else
		{
		  firsttime= true;
		  ParserObject= node;
		  ParserText= GetPMFunc(node);
		  Recursion.Clear();
		  RecursionError= false;
		  
		  Parse_pmf_def(pmfunc);
		  if (error)
		    return false;
		}
	    }
	  else if (IsExpTrans(node))
	    {
	      charP delay= (*GetDelay(node)).to_charPtr();
	      if (!delay || !*delay)
		{
		  Text DialogContense;
		  DialogContense+= "Missing EXP_DELAY definition:";
		  
		  firsttime= true;
		  ParserObject= node;
	  //AH Changed Start => (TextP)
		  ParserText=(TextP)NULL;
  //AH Changed End
		  type= md_exp_delay;
		  
		  ParserError(DialogContense.to_charPtr(),
			      (node->Name()).to_charPtr(), (int)strlen((node->Name()).to_charPtr()) );
		  return false;
		}
	      else
		{
		  firsttime= true;
		  ParserObject= node;
		  ParserText= GetDelay(node);
		  Recursion.Clear();
		  RecursionError= false;
		  
		  Parse_md_exp_delay(delay);
		  *GetIsMDDelay(node)= IsMDDelay;
		  if (error)
		    return false;
		}
	    }
	  else if (IsDetTrans(node))
	    {
	      charP delay= (*GetDelay(node)).to_charPtr();
	      if (!delay || !*delay)
		{
		  Text DialogContense;
		  DialogContense+= "Missing DET_DELAY definition:";
		  
		  firsttime= true;
		  ParserObject= node;
	  //AH Changed Start => (TextP)
		  ParserText= (TextP)NULL;
  //AH Changed End
		  type= md_det_delay;
		  
		  ParserError(DialogContense.to_charPtr(),
			      (node->Name()).to_charPtr(), strlen((node->Name()).to_charPtr()));
		  return false;
		}
	      else
		{
		  firsttime= true;
		  ParserObject= node;
		  ParserText= GetDelay(node);
		  Recursion.Clear();
		  RecursionError= false;
		  
		  Parse_md_det_delay(delay);
		  *GetIsMDDelay(node)= IsMDDelay;
		  if (error)
		    return false;
		}
	    }
	  else if (IsImmediate(node))
	    {
	      charP enable= (*GetEnable(node)).to_charPtr();

	      firsttime= true;
	      ParserObject= node;
	      ParserText= GetEnable(node);
	      Recursion.Clear();
	      RecursionError= false;
	      
	      Parse_md_enable(enable);
	      if (error)
		return false;

	      charP weight= (*GetWeight(node)).to_charPtr();
	      if (!weight || !*weight)
		{
		  Text DialogContense;
		  DialogContense+= "Missing WEIGHT definition:";
		  
		  firsttime= true;
		  ParserObject= node;
		  //AH Changed Start => (TextP)
		  ParserText= (TextP)NULL;
		  //AH Changed End
		  type= md_weight;
		  
		  ParserError(DialogContense.to_charPtr(),
			      (node->Name()).to_charPtr(), (int)strlen((node->Name()).to_charPtr()));
		  return false;
		}
	      else
		{
		  firsttime= true;
		  ParserObject= node;
		  ParserText= GetWeight(node);
		  Recursion.Clear();
		  RecursionError= false;
		  
		  Parse_md_weight(weight);
		  *GetIsMDDelay(node)= IsMDDelay;
		  if (error)
		    return false;
		}
	    }
	  
	  Iterator<ConnectorP> InputConns= node->Inputs();
	  for (ConnectorP c= InputConns; c && IsArc(c); c=++InputConns)
	    {
	      charP multi= (*GetMultiplicity(c)).to_charPtr();
	      if (!multi || !*multi)
		{
		  Text DialogContense;
		  DialogContense+= "Missing MULTIPLICITY definition:";
		  
		  firsttime= true;
		  ParserObject= c;
		  //AH Changed Start => (TextP)
		  ParserText= (TextP)NULL;
		  //AH Changed End
		  type= md_arc_mult;
		  
		  ParserError(DialogContense.to_charPtr(),
			      (node->Name()).to_charPtr(), (int)strlen((node->Name()).to_charPtr()));
		  return false;
		}
	      else
		{
		  firsttime= true;
		  ParserObject= c;
		  ParserText= GetMultiplicity(c);
		  Recursion.Clear();
		  RecursionError= false;
		  
		  Parse_md_arc_mult(multi);
		  *GetIsMDArcMult(c)= IsMDArcMult;
		  if (error)
		    return false;
		}
	    }
	  
	  Iterator<ConnectorP> OutputConns= node->Outputs();
	  for (ConnectorP c= OutputConns; c && IsArc(c); c=++OutputConns)
	    {
	      charP multi= (*GetMultiplicity(c)).to_charPtr();
	      if (!multi || !*multi)
		{
		  Text DialogContense;
		  DialogContense+= "Missing MULTIPLICITY definition:";
		  
		  firsttime= true;
		  ParserObject= c;
		  //AH Changed Start => (TextP)
		  ParserText= (TextP)NULL;
		  //AH Changed End
		  type= md_arc_mult;
		  
		  ParserError(DialogContense.to_charPtr(),
			      (node->Name()).to_charPtr(), (int)strlen((node->Name()).to_charPtr()));
		  return false;
		}
	      else
		{
		  firsttime= true;
		  ParserObject= c;
		  ParserText= GetMultiplicity(c);
		  Recursion.Clear();
		  RecursionError= false;
		  
		  Parse_md_arc_mult(multi);
		  *GetIsMDArcMult(c)= IsMDArcMult;
		  if (error)
		    return false;
		}
	    }
	}
    }
  // Check Transitions

  this->ed->Update();

  if (okwindow)
    {
      Text DialogContense;
      DialogContense+= "the net is error-free!";

      OpenMsgDialog(*this->ed, "TimeNET_Info",
		    DialogContense.to_charPtr(),false,"Close");
      
    }
  return true;
  // no errors
}

//---------------------------------------------------------------------	

bool TimeNETLink::Menu(Editor& ed, Page& pg, Ident& name, bool before)
{
  if (EDSPNen && name=="stop all solutions" && before)
    {
      if (pidStationaryAnalysis) 
	{
	  killpg(pidStationaryAnalysis, SIGTERM);
	  pidStationaryAnalysis= 0;
	}
      if (pidStationaryAnalysisDTSPN) 
	{
	  killpg(pidStationaryAnalysisDTSPN, SIGTERM);
	  pidStationaryAnalysisDTSPN= 0;
	}
      if (pidStationaryApproximation) 
	{
	  killpg(pidStationaryApproximation, SIGTERM);
	  pidStationaryApproximation= 0;
	}
      if (pidStationarySimulation) 
	{
	  killpg(pidStationarySimulation, SIGTERM);
	  pidStationarySimulation= 0;
	}
      if (pidRestartStSimulation) 
	{
	  killpg(pidRestartStSimulation, SIGTERM);
	  pidRestartStSimulation= 0;
	}
      if (pidTransientAnalysis) 
	{
	  killpg(pidTransientAnalysis, SIGTERM);
	  pidTransientAnalysis= 0;
	}
      if (pidTransientAnalysis) 
	{
	  killpg(pidTransientAnalysis, SIGTERM);
	  pidTransientAnalysis= 0;
	}
      if (pidTransientSimulation) 
	{
	  killpg(pidTransientSimulation, SIGTERM);
	  pidTransientSimulation= 0;
	}
      if (pidExperiment) 
	{
	  killpg(pidExperiment, SIGTERM);
	  pidExperiment= 0;
	}
      if (pidExperiment2) 
	{
	  killpg(pidExperiment2, SIGTERM);
	  pidExperiment2= 0;
	}
      if (pidEstimSE) 
	{
	  killpg(pidEstimSE, SIGTERM);
	  pidEstimSE= 0;
	}
      if (pidTraps) 
	{
	  killpg(pidTraps, SIGTERM);
	  pidTraps= 0;
	}
      if (pidSiphons) 
	{
	  killpg(pidSiphons, SIGTERM);
	  pidSiphons= 0;
	}
      return true;
    }
  if (EDSPNen && name=="Result Info" && before)
    {
      for (ObjectP obj= pg.NextSelected(); obj; obj= pg.NextSelected(obj)) 
	if (obj->IsNode())
	  if (IsPlace((NodeP)obj))
	    TokenDistribution((NodeP)obj);
	  else if (IsTransition((NodeP)obj))
	    ThroughPut((NodeP)obj);
      return true;
    }
  else if (EDSPNen && name=="PMF Editor" && before)
    {
      for (ObjectP obj= pg.NextSelected(); obj; obj= pg.NextSelected(obj)) 
	if (obj->IsNode() && IsTransition((NodeP)obj) && 
	    IsGenTrans((NodeP)obj))
	  PMFEditor((NodeP)obj);
      return true;
    }
  else if (EDSPNen && name=="Check Net" && before)
    {
      CheckNet(true);

      return true;
    }
  else if (EDSPNen && name=="Check Structure" && before)
    {
      CheckStructure(ed);

      return true;
    }
 else if (EDSPNen && name==(const char *)"Estimate Statespace" && before)
    {
      EstimSE(ed);

      return true;
    }
 else if (EDSPNen && name==(const char *)"Traps" && before)
    {
      Traps(ed);

      return true;
    }
else if (EDSPNen && name==(const char *)"Siphons" && before)
    {
      Siphons(ed);

      return true;
    }
  else if (EDSPNen && name=="Start St.An." && before)
    {

      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "enum(\"EMC explicit\" EMC_EXPLICIT, \"fill-in avoidance\" FILL_IN_AVOIDANCE)"
	" \"Overall solution method:\" sa_overall_solu= ";
      DialogContense+= (sa_overall_solu==EMC_EXPLICIT)?"EMC_EXPLICIT":"FILL_IN_AVOIDANCE";

      DialogContense+= ";enum(\"sequential\" SEQUENTIAL, \"distributed\" DISTRIBUTED)"
	" \"Computation of SMCs:\" sa_distributed= ";
      DialogContense+= (sa_distributed==SEQUENTIAL)?"SEQUENTIAL":"DISTRIBUTED";

      DialogContense+= ";float \"Precision:\" sa_epsilon= ";
      DialogContense+= sa_epsilon;

      DialogContense+= ";int [1,100000000] \"Maximum iterations:\" sa_max_iter= ";
      DialogContense+= double(sa_max_iter);

      DialogContense+= ";enum(\"arbitrary\" ARBITRARY, \"double\" DOUBLE)"
	" \"Precision of arithmetics (integr. of matrix exponentials):\" sa_arith= ";
      DialogContense+= (sa_arith==ARBITRARY)?"ARBITRARY":"DOUBLE";

      DialogContense+= ";int [128, 65536] \"Bits for arb. precision (integr. of matrix exponentials):\" sa_arb_bits= ";
      DialogContense+= double(sa_arb_bits);

      DialogContense+= ";float \"Truncation error (integr. of matrix exponential):\" sa_trunc_error= ";
      DialogContense+= sa_trunc_error;

      DialogContense+= ";enum(\"direct\" DIRECT, \"iterative\" ITERATIVE)"
	" \"In case of EMC explicit solution method ...\nLinear system solution:\" sa_lin_solu= ";
      DialogContense+= (sa_lin_solu==DIRECT)?"DIRECT":"ITERATIVE";

      DialogContense+= ";enum(\"uniform\" UNIFORM, \"random\" RANDOM, \"load from file\" LOAD_FILE)"
	" \"In case of fill-in avoidance solution method ...\nInitial iteration vector:\" sa_init_vec= ";
      if (sa_init_vec==UNIFORM) DialogContense+= "UNIFORM";
      else if (sa_init_vec==RANDOM) DialogContense+= "RANDOM";
      else DialogContense+= "LOAD_FILE";

      DialogContense+= ";int [0,100000000] \"Seed value for random initial vector:\" sa_seed_val= ";
      DialogContense+= double(sa_seed_val);

      DialogContense+= ";bool \"Save stationary iteration vector:\" sa_save_vec= ";
      DialogContense+= (sa_save_vec?"true":"false");

      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Stationary Analysis", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start St.An. DTSPN" && before)
    {

      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "float \"Precision:\" dtsa_epsilon= ";
      DialogContense+= dtsa_epsilon;
      DialogContense+= ";enum(\"direct\" DIRECT, \"iterative\" ITERATIVE)"
	" \"Linear system solution:\" dtsa_solu= ";
      DialogContense+= (dtsa_solu==DIRECT)?"DIRECT":"ITERATIVE";
      DialogContense+= ";int \"Maximum iterations:\" dtsa_max_iter= ";
      DialogContense+= double(dtsa_max_iter);
      DialogContense+= ";enum(\"no\" aNO, \"time\" aTIME, \"memo\" aMEMO)"
	" \"Embedding:\" dtsa_embed= ";
      DialogContense+= (dtsa_embed==aNO)? "aNO":((dtsa_embed==aTIME)?"aTIME":"aMEMO");
      DialogContense+= ";int \"underlying time-step:1/\" dtsa_scale= ";
      DialogContense+= double(dtsa_scale);
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Stationary Analysis DTSPN", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start St.Ap." && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "float \"Precision:\" sp_epsilon= ";
      DialogContense+= sp_epsilon;
      DialogContense+= ";enum(\"direct\" DIRECT, \"iterative\" ITERATIVE)"
	" \"Linear system solution:\" sp_solu= ";
      DialogContense+= (sp_solu==DIRECT)?"DIRECT":"ITERATIVE";
      DialogContense+= ";int \"Maximum iterations:\" sp_max_iter= ";
      DialogContense+= double(sp_max_iter);
      DialogContense+= ";float \"drop tolerance:\" sp_droptol= ";
      DialogContense+= sp_droptol;
      DialogContense+= ";int \"Number of phases:\" sp_phases= ";
      DialogContense+= double(sp_phases);
      DialogContense+= ";int \"Virtual number of phases:\" sp_vphases= ";
      DialogContense+= double(sp_vphases);

      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Stationary Approximation", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Standard St.Si." && before)
    {

      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "enum(\"sequential\" S, \"distributed\" P) \"Simulation:\" ss_distr= ";
      DialogContense+= (ss_distr==SERIELL)?"S":"P";
      DialogContense+= ";bool \"detect initial transient:\" ss_detect= ";
      DialogContense+= (ss_detect?"true":"false");
      DialogContense+= ";int[1,99] \"Confidence level [%]:\" ss_conf_level= ";
      DialogContense+= double(ss_conf_level);
      DialogContense+= ";int[1,99] \"permitted difference at the Confidence level\nfor probability-measures [%]:\" ss_error_percnt= ";
      DialogContense+= double(ss_error_percnt);
      DialogContense+= ";int[1,99] \"Maximum relative error [%]:\" ss_epsilon_max= ";
      DialogContense+= double(ss_epsilon_max);
      DialogContense+= ";int \"Seed value:\" ss_random_seed= ";
      DialogContense+= double(ss_random_seed);
      DialogContense+= ";int \"Max. # of samples:\" ss_max_samples= ";
      DialogContense+= double(ss_max_samples);
      DialogContense+= ";int \"Min. # of firings for each transition:\" ss_min_firings= ";
      DialogContense+= double(ss_min_firings);
      DialogContense+= ";float \"Max model time:\" ss_max_modeltime= ";
      DialogContense+= double(ss_max_modeltime);
      DialogContense+= ";float \"Max real time [sec.]:\" ss_max_realtime= ";
      DialogContense+= ss_max_realtime;
      DialogContense+= ";bool \"Visualisation:\" ss_visu= ";
      DialogContense+= (ss_visu?"true":"false");
      DialogContense+= ";enum("
	"\"spectral variance\" S,"
	  "\"control variables\" C)"
	    "\"Method for statistical analysis:\" ss_method= ";
      DialogContense+= (ss_method==mS)?"S":"C";

      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Stationary Simulation", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Fast St.Si." && before)
    {

      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "enum(\"sequential\" S, \"distributed\" P) \"Simulation:\" ss_distr= ";
      DialogContense+= (ss_distr==SERIELL)?"S":"P";
      DialogContense+= ";bool \"detect initial transient:\" ss_detect= ";
      DialogContense+= (ss_detect?"true":"false");
      DialogContense+= ";int[1,99] \"Confidence level [%]:\" ss_conf_level= ";
      DialogContense+= double(ss_conf_level);
      DialogContense+= ";int[1,99] \"Maximum relative error [%]:\" ss_epsilon_max= ";
      DialogContense+= double(ss_epsilon_max);
      DialogContense+= ";int \"Seed value:\" ss_random_seed= ";
      DialogContense+= double(ss_random_seed);
      DialogContense+= ";int \"Max. # of samples:\" ss_max_samples= ";
      DialogContense+= double(ss_max_samples);
      DialogContense+= ";int \"Min. # of firings for each transition:\" ss_min_firings= ";
      DialogContense+= double(ss_min_firings);
      DialogContense+= ";float \"Max model time:\" ss_max_modeltime= ";
      DialogContense+= double(ss_max_modeltime);
      DialogContense+= ";float \"Max real time [sec.]:\" ss_max_realtime= ";
      DialogContense+= ss_max_realtime;
      DialogContense+= ";int \"Initial # thresholds:\" ss_thresholds= ";
      DialogContense+= double(ss_thresholds);
      DialogContense+= ";int \"CPU - time pilot run [sec.]:\" ss_pilotrun= ";
      DialogContense+= double(ss_pilotrun);
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Restart Stationary Simulation", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Tr.An." && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "float \"transient instant of time:\" ta_transtime= ";
      DialogContense+= ta_transtime;
      DialogContense+= ";float \"Precision:\" ta_epsilon= ";
      DialogContense+= ta_epsilon;
      DialogContense+= ";enum(\"curve\" aCURVE, \"point\" aPOINT)"
	" \"output form:\" ta_output= ";
      DialogContense+= (ta_output==aCURVE)?"aCURVE":"aPOINT";
      DialogContense+= ";float \"stepsize for output:\" ta_stepsize= ";
      DialogContense+= ta_stepsize;
      DialogContense+= ";enum(\"compute matrix exponentials\" aA, \"repeat Jenson's method\" aB)"
	" \"algorithm variant:\" ta_variant= ";
      DialogContense+= (ta_variant==aA)?"aA":"aB";
      DialogContense+= ";float \"internal stepsize:\" ta_internal= ";
      DialogContense+= ta_internal;
      DialogContense+= ";int \"cluster size:\" ta_clustersize= ";
      DialogContense+= double(ta_clustersize);
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Transient Analysis", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Tr.An. DTSPN" && before)
    {

      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "float \"Precision:\" dtta_epsilon= ";
      DialogContense+= dtta_epsilon;
      DialogContense+= ";enum(\"direct\" DIRECT, \"iterative\" ITERATIVE)"
	" \"Linear system solution:\" dtta_solu= ";
      DialogContense+= (dtta_solu==DIRECT)?"DIRECT":"ITERATIVE";
      DialogContense+= ";int \"Maximum iterations:\" dtta_max_iter= ";
      DialogContense+= double(dtta_max_iter);
      DialogContense+= ";int \"time steps:\" dtta_timesteps= ";
      DialogContense+= double(dtta_timesteps);
      DialogContense+= ";enum(\"curve\" aCURVE, \"point\" aPOINT)"
	" \"output form:\" dtta_output= ";
      DialogContense+= (dtta_output==aCURVE)?"aCURVE":"aPOINT";
      DialogContense+= ";int \"step size for output:\" dtta_stepsize= ";
      DialogContense+= double(dtta_stepsize);
      DialogContense+= ";int \"first step for output:\" dtta_firststep= ";
      DialogContense+= double(dtta_firststep);
      DialogContense+= ";enum(\"no\" aNO, \"time\" aTIME, \"memo\" aMEMO)"
	" \"Embedding:\" dtta_embed= ";
      DialogContense+= (dtta_embed==aNO)? "aNO":((dtta_embed==aTIME)?"aTIME":"aMEMO");
      DialogContense+= ";int \"underlying time-step:1/\" dtta_scale= ";
      DialogContense+= double(dtta_scale);
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Transient Analysis DTSPN", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Tr.Si." && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "enum(\"sequential\" S, \"distributed\" P) \"Simulation:\" ts_distr= ";
      DialogContense+= (ts_distr==SERIELL)?"S":"P";
      DialogContense+= ";float \"Transient instant of time:\" ts_transient_time= ";
      DialogContense+= ts_transient_time;
      DialogContense+= ";int \"Number of sampling points:\" ts_no_sampling_points= ";
      DialogContense+= double(ts_no_sampling_points);
      DialogContense+= ";bool \"Percentage Rule:\" ts_rule= ";
      DialogContense+= ts_rule?"true":"false";
      DialogContense+= ";int[1,99] \"Confidence level [%]:\" ts_conf_level= ";
      DialogContense+= double(ts_conf_level);
      DialogContense+= ";float \"Maximum relative error [%]:\" ts_epsilon_max= ";
      DialogContense+= ts_epsilon_max;
      DialogContense+= ";int \"Seed value:\" ts_random_seed= ";
      DialogContense+= double(ts_random_seed);
      DialogContense+= ";float \"Max real time:\" ts_max_realtime= ";
      DialogContense+= ts_max_realtime;
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Transient Simulation", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Experiment St.An." && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "Text \"Varying parameter:\" exp_param=\"";
      DialogContense+= exp_param;
      DialogContense+= "\"";
      DialogContense+= ";float[-4e9,4e9] \"from value:\" exp_from=";
      DialogContense+= double(exp_from);
      DialogContense+= ";float[-4e9,4e9] \"to value:\" exp_to=";
      DialogContense+= double(exp_to);
      DialogContense+= ";enum(\"linear\" aLIN, \"logarithmic (base=10)\" aLOG)"
	" \"step size:\" exp_mode= ";
      DialogContense+= (exp_mode==aLIN)? "aLIN":"aLOG";
      DialogContense+= ";float[-4e9,4e9] \"addend (linear)\nor exponent (logarithmic):\" exp_step=";
      DialogContense+= double(exp_step);

      DialogContense+= ";enum(\"sequential\" SEQUENTIAL, \"distributed\" DISTRIBUTED)"
	" \"Execution mode:\" sa_distributed= ";
      DialogContense+= (sa_distributed==SEQUENTIAL)?"SEQUENTIAL":"DISTRIBUTED";

      DialogContense+= ";enum(\"EMC explicit\" EMC_EXPLICIT, \"fill-in avoidance\" FILL_IN_AVOIDANCE)"
	" \"Overall solution method:\" sa_overall_solu= ";
      DialogContense+= (sa_overall_solu==EMC_EXPLICIT)?"EMC_EXPLICIT":"FILL_IN_AVOIDANCE";
      DialogContense+= ";float \"Precision:\" sa_epsilon= ";
      DialogContense+= sa_epsilon;

      DialogContense+= ";int [1,100000000] \"Maximum iterations:\" sa_max_iter= ";
      DialogContense+= double(sa_max_iter);

      DialogContense+= ";enum(\"arbitrary\" ARBITRARY, \"double\" DOUBLE)"
	" \"Precision of arithmetics (integr. of matrix exponentials):\" sa_arith= ";
      DialogContense+= (sa_arith==ARBITRARY)?"ARBITRARY":"DOUBLE";

      DialogContense+= ";int [128, 65536] \"Bits for arb. precision (integr. of matrix exponentials):\" sa_arb_bits= ";
      DialogContense+= double(sa_arb_bits);

      DialogContense+= ";float \"Truncation error (integr. of matrix exponential):\" sa_trunc_error= ";
      DialogContense+= sa_trunc_error;

      DialogContense+= ";enum(\"direct\" DIRECT, \"iterative\" ITERATIVE)"
	" \"In case of EMC explicit solution method ...\nLinear system solution:\" sa_lin_solu= ";
      DialogContense+= (sa_lin_solu==DIRECT)?"DIRECT":"ITERATIVE";

      DialogContense+= ";enum(\"uniform\" UNIFORM, \"random\" RANDOM, \"load from file\" LOAD_FILE)"
	" \"In case of fill-in avoidance solution method ...\nInitial iteration vector:\" sa_init_vec= ";
      if (sa_init_vec==UNIFORM) DialogContense+= "UNIFORM";
      else if (sa_init_vec==RANDOM) DialogContense+= "RANDOM";
      else DialogContense+= "LOAD_FILE";

      DialogContense+= ";int [0,100000000] \"Seed value for random initial vector:\" sa_seed_val= ";
      DialogContense+= double(sa_seed_val);

      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Experiment Stationary Analysis", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Experiment St.An. DTSPN" && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "Text \"Varying parameter:\" exp3_param=\"";
      DialogContense+= exp3_param.to_charPtr();
      DialogContense+= "\"";
      DialogContense+= ";float[-4e9,4e9] \"from value:\" exp3_from=";
      DialogContense+= double(exp3_from);
      DialogContense+= ";float[-4e9,4e9] \"to value:\" exp3_to=";
      DialogContense+= double(exp3_to);
      DialogContense+= ";enum(\"linear\" aLIN, \"logarithmic (base=10)\" aLOG)"
	" \"step size:\" exp3_mode= ";
      DialogContense+= (exp3_mode==aLIN)? "aLIN":"aLOG";
      DialogContense+= ";float[-4e9,4e9] \"summand(linear)\nor exponent(logarithmic):\" exp3_step=";
      DialogContense+= double(exp3_step);
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Experiment St.An. DTSPN", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Start Experiment St.Si." && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "enum(\"sequential\" S, \"distributed\" P) \"Simulation:\" ss_distr= ";
      DialogContense+= (ss_distr==SERIELL)?"S":"P";
      DialogContense+= ";int[1,99] \"Confidence level [%]:\" ss_conf_level= ";
      DialogContense+= double(ss_conf_level);
      DialogContense+= ";int[1,99] \"permitted difference at the Confidence level\nfor probability-measures [%]:\" ss_error_percnt= ";
      DialogContense+= double(ss_error_percnt);
      DialogContense+= ";int[1,99] \"Maximum relative error [%]:\" ss_epsilon_max= ";
      DialogContense+= double(ss_epsilon_max);
      DialogContense+= ";int \"Seed value:\" ss_random_seed= ";
      DialogContense+= double(ss_random_seed);
      DialogContense+= ";int \"Max. # of samples:\" ss_max_samples= ";
      DialogContense+= double(ss_max_samples);
      DialogContense+= ";int \"Min. # of firings for each transition:\" ss_min_firings= ";
      DialogContense+= double(ss_min_firings);
      DialogContense+= ";float \"Max model time:\" ss_max_modeltime= ";
      DialogContense+= double(ss_max_modeltime);
      DialogContense+= ";float \"Max real time [sec.]:\" ss_max_realtime= ";
      DialogContense+= ss_max_realtime;
      DialogContense+= ";enum("
	"\"spectral variance\" S,"
	  "\"control variables\" C)"
	    "\"Method for statistical analysis:\" ss_method= ";
      DialogContense+= (ss_method==mS)?"S":"C";
      DialogContense+= ";Text \"Varying parameter:\" exp2_param=\"";
      DialogContense+= exp2_param;
      DialogContense+= "\"";
      DialogContense+= ";float[-4e9,4e9] \"from value:\" exp2_from=";
      DialogContense+= double(exp2_from);
      DialogContense+= ";float[-4e9,4e9] \"to value:\" exp2_to=";
      DialogContense+= double(exp2_to);
      DialogContense+= ";enum(\"linear\" aLIN, \"logarithmic (base=10)\" aLOG)"
	" \"step size:\" exp2_mode= ";
      DialogContense+= (exp2_mode==aLIN)? "aLIN":"aLOG";
      DialogContense+= ";float[-4e9,4e9] \"summand(linear)\nor exponent(logarithmic):\" exp2_step=";
      DialogContense+= double(exp2_step);
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Experiment St.Si.", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Stop St.An." && before)
    {
      if (pidStationaryAnalysis) 
	{
	  killpg(pidStationaryAnalysis, SIGTERM);
	  pidStationaryAnalysis= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop St.An. DTSPN" && before)
    {
      if (pidStationaryAnalysisDTSPN) 
	{
	  killpg(pidStationaryAnalysisDTSPN, SIGTERM);
	  pidStationaryAnalysisDTSPN= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop St.Ap." && before)
    {
      if (pidStationaryApproximation) 
	{
	  killpg(pidStationaryApproximation, SIGTERM);
	  pidStationaryApproximation= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Standard St.Si." && before)
    {
      if (pidStationarySimulation) 
	{
	  killpg(pidStationarySimulation, SIGTERM);
	  pidStationarySimulation= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Fast St.Si." && before)
    {
      if (pidRestartStSimulation) 
	{
	  killpg(pidRestartStSimulation, SIGTERM);
	  pidRestartStSimulation= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Tr.An." && before)
    {
      if (pidTransientAnalysis) 
	{
	  killpg(pidTransientAnalysis, SIGTERM);
	  pidTransientAnalysis= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Tr.An. DTSPN" && before)
    {
      if (pidTransientAnalysis) 
	{
	  killpg(pidTransientAnalysis, SIGTERM);
	  pidTransientAnalysis= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Tr.Si." && before)
    {
      if (pidTransientSimulation) 
	{
	  killpg(pidTransientSimulation, SIGTERM);
	  pidTransientSimulation= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Experiment St.An." && before)
    {
      if (pidExperiment) 
	{
	  killpg(pidExperiment, SIGTERM);
	  pidExperiment= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Stop Experiment St.Si." && before)
    {
      if (pidExperiment2) 
	{
	  killpg(pidExperiment2, SIGTERM);
	  pidExperiment2= 0;
	}
      return true;
    }
  else if (EDSPNen && name=="Clear" && before)
    {
      ClearResults(ed);
      
      return true;
    }
  else if (EDSPNen && name=="Get" && before)
    {
      GetResults(ed);

      return true;
    }
  else if ((EDSPNen && name=="GnuPlot Experiment-Results" && before) ||
	   (net.Prime()->Class()->Name() == "SPNL" && 
	    name=="gnuplot experimental results" && before))
    {

      Text DialogContense;
      int max,tmp;
      
      max= tmp= 0;
      DialogContense+= "enum(";
      
      SetNetName();
      
      Text tabfile = Text(ed.GetNet()->FileName()) - NET_ENDING - TN_ENDING + 
	".id_tab";
      ifstream tabstream;
      tabstream.open(tabfile.to_charPtr());
      
      if (!tabstream)
	{
	  tabfile= Text(model_dir)+"/"+netname+".id_tab";
	  tabstream.open(tabfile.to_charPtr());
	  if (!tabstream)
	    {
	      Text DialogContense2;
	      DialogContense2+= "'<model>.id_tab' does not exist!";
	      OpenMsgDialog(ed, "TimeNET_Error",
			    DialogContense2.to_charPtr(),true,"Close");
	      return true;
	    }
	}
      
      char buffer[1024];
      
      int number= 1;
      
      while (!tabstream.eof())
	{
	  tabstream.getline (buffer, 1024, '\n');

	  if ((tmp= strlen(buffer)) > max)
	    max= tmp;
	  // maximale Laenge aller Strings merken
	  
	  DialogContense+= Text("\"");
	  DialogContense+= buffer;
	  DialogContense+= Text("\" binding");
	  DialogContense+= double(number++);
	  DialogContense+= Text(" , ");
	} 
      tabstream.close();
        
      DialogContense+= Text(")");
	
      Text Contense;
      Contense+= "(";
      Contense+= "Text \"Title\" gp_title=\"";
      Contense+= gp_title;
      Contense+= "\";";
      Contense+= DialogContense;
      Contense+= "\"x_axis-value\" value= binding1;";
      Contense+= DialogContense;
      Contense+= "\"y_axis-value\" value2= binding2;";
      Contense+= "Text \"x_axis-label\" gp_xdescr=\"";
      Contense+= gp_xdescr;
      Contense+= "\"";
      Contense+= ";Text \"y_axis-label\" gp_ydescr=\"";
      Contense+= gp_ydescr;
      Contense+= "\"";
      Contense+= ";bool \"logarithmic scale for x_axis\" gp_logx= ";
      Contense+= gp_logx?"true":"false";
      Contense+= ";bool \"logarithmic scale for y_axis\" gp_logy= ";
      Contense+= gp_logy?"true":"false";
      Contense+= ";)";
      
      setup= new Struct(Contense.to_charPtr());
      dialog.Create("GnuPlotDialog",
      "GnuPlot",
      this->ed->Shell(),false,&TimeNETLink::DialogCallback,"Start Default Close Cancel");
     
      Arg arg={"width",max*6+50+84};
      XtSetValues(Widget(dialog),&arg,1);
      // set width
      
      setup->EnterDialog(dialog,false);
      dialog.Manage();

      return true;
    }
  else if (EDSPNen && name=="Print" && before)
    {
      Text DialogContense;
      DialogContense+= "[";
      DialogContense+= "bool \"graphical description\" pr_graph= ";
      DialogContense+= (pr_graph?"true":"false");
      DialogContense+= ";bool \"textual description\" pr_text= ";
      DialogContense+= (pr_text?"true":"false");
      DialogContense+= ";enum (\"Printer\" printer, \"File\" file) "
	"\"Destination\" pr_dest=";
      DialogContense+= (pr_dest==aPRINTER)? "printer":"file";
      DialogContense+= ";text \"Printer\" pr_cmd= \"";
      DialogContense+= pr_cmd;
      DialogContense+= "\"";
      DialogContense+= ";enum (\"PostScript\" ps, \"Encaps. PostScript\" eps) "
	"\"graphical Description\" pr_gdesc=";
      DialogContense+= (pr_gdesc==aPS)? "ps":"eps";
      DialogContense+= ";enum (\"PostScript\" ps, \"LaTex source\" latex) "
	"\"textual Description\" pr_tdesc=";
      DialogContense+= (pr_tdesc==aPS2)? "ps":"latex";
      DialogContense+= ";]";
      CreateDialog(DialogContense.to_charPtr());
      OpenDialog(ed, "Print", "Start Default Load Save Close Cancel");

      return true;
    }
  else if (EDSPNen && name=="Results" && before)
    {
      SetNetName();

      Text resfile= Text(model_dir)+"/"+netname+".RESULTS";
      remove (resfile.to_charPtr());
      
      return true;
    }
  else if (EDSPNen && name=="Lock-File" && before)
    {
      SetNetName();

      Text lockfile= Text(model_dir)+"/"+netname+".lock";
      remove (lockfile.to_charPtr());
      
      return true;
    }
  else if (EDSPNen && name=="Load" && before)
    {
      charP path= ed.CurrentPath();
      // aktuellen Pfad lesen

      fsel.Open(ed.Shell(),"select Net-file to load.",&TimeNETLink::FselCallback,&ed,
		path ? path : model_dir.to_charPtr(),"*" NET_ENDING);
      // Lademenue oeffnen mit Vorgabe: .net

      return true;
      // keine weitere Behandlung fuer Load
    }
  else if (EDSPNen && name=="Add" && before)
    {
      charP path= ed.CurrentPath();
      // aktuellen Pfad lesen

      fsel.Open(ed.Shell(),"select Net-file to add (.net or .TN).",&TimeNETLink::AddCB,&ed,
		path ? path : model_dir.to_charPtr(),"*" NET_ENDING);
      // Lademenue oeffnen mit Vorgabe: .net

      return true;
      // keine weitere Behandlung fuer Load
    }
  else if (name=="Import" && before)
    {
      charP path= ed.CurrentPath();
      // aktuellen Pfad lesen

      fsel.Open(ed.Shell(),"select TN-file to import",&TimeNETLink::FselCallback,&ed,
		path ? path : model_dir.to_charPtr(),"*" TN_ENDING);
      // Importmenue oeffnen mit Vorgabe: .TN
      return true;
      // keine weitere Behandlung fuer Load
    }
  else if (EDSPNen && name=="Save" && strcmp(net.FileName(), NoFilename) && before)
    {
      Text rname(net.FileName());
      charP name;
      charP end;
      
      name= strrchr(net.FileName(),'/');
      if (name)
	++name;
      else
	name= net.FileName();

      end= strrchr(name,'.');
      if (!end)
	{
	  rname+= NET_ENDING;
	}

      if (!strcmp(end, NET_ENDING))
	net.Save();
      else if (!strcmp(end, TN_ENDING))
	if (!CheckNet())
	  return true;
 	else SaveTN(&ed, rname.to_charPtr());

      net.modified= false;

      return true;
      // keine weitere Behandlung fuer Save
    }
  else if (EDSPNen && (name=="SaveAs" || name=="Save") && before)
    {
      Text title= Text("Save Net ")+net.FullName()+" as...";
      charP path= ed.CurrentPath();

      ExportCB= false;
      fsel.Open(ed.Shell(),title.to_charPtr(),&TimeNETLink::SaveAsCB,&ed,
		path ? path : model_dir.to_charPtr(),"*" NET_ENDING);

      return true;
      // keine weitere Behandlung fuer SaveAs
    }
  else if (EDSPNen && name=="Export" && before)
    {
      Text title= Text("Export Net ")+net.FullName()+" as...";
      charP path= ed.CurrentPath();
      ExportCB= true;
      fsel.Open(ed.Shell(),title.to_charPtr(),&TimeNETLink::SaveAsCB,&ed,
		path ? path : model_dir.to_charPtr(),"*" TN_ENDING);

      return true;
      // keine weitere Behandlung fuer Export
    }
  return false;
  // Der Menuepunkt geht dieses Modul nichts an!
}

//---------------------------------------------------------------------

static int NetioError(charP,int) {return 0;}

//---------------------------------------------------------------------

NetP TimeNETLink::LoadTN(charP file)
{
  NetDescr* netdesc= load_net(file,NetioError);

  if (netdesc)
    {
      int i;
      arccnt= 1;
      NetClassP nc= NetClass::GetNetClass("EDSPN");
      Text name= Text(file)-TN_ENDING;
      NetP net= new Net(nc,name.to_charPtr());
      PageP prime= net->Prime();

      NodeClassP ncplace=    GetNodeClassPlace(nc);
      NodeClassP ncexpt=     GetNodeClassExpTrans(nc);
      NodeClassP ncdett=     GetNodeClassDetTrans(nc);
      NodeClassP ncgent=     GetNodeClassGenTrans(nc);
      NodeClassP ncimmt=     GetNodeClassImmTrans(nc);
      NodeClassP ncmark=     GetNodeClassMarkPar(nc);
      NodeClassP ncdelay=    GetNodeClassDelayPar(nc);
      NodeClassP ncreward=   GetNodeClassRewItem(nc);
      ConnectorClassP ccarc= GetConnectorClassArc(nc);
      ConnectorClassP ccinh= GetConnectorClassInhibitor(nc);

      for (i=0; i<netdesc->num_markpars; i++)
	{
	  Markpar* m= &netdesc->markpar[i];			
	  NodeP mpar= new Node(ncmark,prime,m->name,InchToPix(m->pos));
	  *GetMarkPar(mpar)= m->value;
	}

      for (i=0; i<netdesc->num_delaypars; i++)
	{
	  Delaypar* d= &netdesc->delaypar[i];
	  NodeP dpar= new Node(ncdelay,prime,d->name,InchToPix(d->pos));
	  if (!d->is_value)
	    {
	      *GetDelayPar(dpar)= d->delay.md_delay;
	      *GetIsMDDelayPar(dpar)= true;
	    }	  
	  else
	    {
	      *GetDelayPar(dpar)= d->delay.value;
	      *GetIsMDDelayPar(dpar)= false;
	    }
	}

      Position pos;
      pos.x= 10.0;pos.y= 10.0;
      for (i=0; i<netdesc->num_rewards; i++)	
	{
	  NodeP rew_item= new Node(ncreward,prime,
				   netdesc->reward[i].name,
				   pos);
	  *GetRewItem(rew_item)= netdesc->reward[i].def;
	  *GetResult(rew_item)= "no";
	  pos.y= pos.y+10.0;
	}

      for (i=0; i<netdesc->num_places; i++)
	{
	  Place* p= &netdesc->place[i];
	  NodeP place= new Node(ncplace,prime,p->name,InchToPix(p->pos));
	  
	  *(Node**)&p->pos= place; // Iiiih...
	  
	  place->SetRelative(0,
			     (InchToPix(p->name_pos)-place->Mid()) /
			     place->Scale()*1.4);
	  
	  if (p->is_value)
	    *GetMarking(place)= p->marking.value;
	  else
	    *GetMarking(place)= p->marking.markpar->name;
	}

      for (i=0;i<netdesc->num_trans;i++)
	{
	  Transition* t= &netdesc->trans[i];
	  NodeP trans=0;
	  double angle= (t->orient==ORIENT_45?45.0:
			 t->orient==ORIENT_90?90.0:
			 t->orient==ORIENT_M45?-45.0:0.0)/180.0*M_PI;

	  switch (t->type)
	    {
	    case IMM:
	      trans= new Node(ncimmt,prime,t->name,InchToPix(t->pos),angle);
	      
	      switch (t->delay_type)
		{
		case DELAY:
		  {
		    *GetWeight(trans)= t->delay.value;
		    *GetIsMDDelay(trans)= false;
		    break;
		  }
		case DELAYPAR:
		  {
		    *GetWeight(trans)= t->delay.delay_par->name;
		    *GetIsMDDelay(trans)= false;
		    break;
		  }
		case MARKDEP:
		  {
		    *GetWeight(trans)= t->delay.md_delay;
		    *GetIsMDDelay(trans)= true;
		    break;
		  }
		default:
		  break;
		}
	      

	      switch (t->f_policy)
		{
		case RA:
		  *GetPolicy(trans)= "PRS";
		  break;
		case RE:
		  *GetPolicy(trans)= "PRD";
		  break;
		default:
		  break;
		}

	      if (t->md_enable)
		*GetEnable(trans)= t->md_enable;
	      break;
	      
	    case DET:
	      trans= new Node(ncdett,prime,t->name,InchToPix(t->pos),angle);
	      goto _exp_delay;
	      break;
	      
	    case EXP:
	      trans= new Node(ncexpt,prime,t->name,InchToPix(t->pos),angle);
	      
	      *GetServerType(trans)= t->inf_server?true:false;
	      _exp_delay:

	      switch (t->f_policy)
		{
		case RA:
		  *GetPolicy(trans)= "PRS";
		  break;
		case RE:
		  *GetPolicy(trans)= "PRD";
		  break;
		default:
		  break;
		}

	      switch (t->delay_type)
		{
		case DELAY:
		  {
		    *GetDelay(trans)= t->delay.value;
		    *GetIsMDDelay(trans)= false;
		    break;
		  }
		case DELAYPAR:
		  {
		    *GetDelay(trans)= t->delay.delay_par->name;
		    *GetIsMDDelay(trans)= false;
		    break;
		  }
		case MARKDEP:
		  {
		    *GetDelay(trans)= t->delay.md_delay;
		    *GetIsMDDelay(trans)= true;
		    break;
		  }
		default:
		  break;
		}
	      break;
	      
	    case GEN:
	      trans= new Node(ncgent,prime,t->name,InchToPix(t->pos),angle);
	      *GetPMFunc(trans)= t->delay.md_delay;

	      switch (t->f_policy)
		{
		case RA:
		  *GetPolicy(trans)= "PRS";
		  break;
		case RE:
		  *GetPolicy(trans)= "PRD";
		  break;
		default:
		  break;
		}

	      break;
	    }			
	  
	  *GetPriority(trans)= t->priority;
	  trans->SetRelative(0,
			     (InchToPix(t->name_pos)-trans->Mid()) /
			     trans->Scale()*1.4);
	  trans->SetRelative(1,PixToPix(t->delay_pos)/trans->Scale()*1.4);
	  CreateArcs(trans,prime,INPUTARC,t->in_arc,t->num_inarcs,ccarc);
	  CreateArcs(trans,prime,OUTPUTARC,t->out_arc,t->num_outarcs,ccarc);
	  CreateArcs(trans,prime,INHIBITOR,t->inh_arc,t->num_inharcs,ccinh);
	  
	}

      free_net(netdesc);
      return net;
    }

  return 0;
}


void TimeNETLink::CreateArcs(NodeP trans, PageP prime, int type,
			     Arc* arc, int num_arcs, ConnectorClassP cc)
{
  for (int j=0; j<num_arcs; j++)
    {
      Arc* a= &arc[j];
      NodeP place= *(Node**)&a->place->pos; // Iiiihhh...
      Ident name= cc->NamePrefix()+ ++arccnt;
      ConnectorP arc= new Connector(cc,prime,name.to_charPtr());

      if (type==OUTPUTARC)
	arc->SetConnections(trans,place);
      else
	arc->SetConnections(place,trans);

      if (a->is_value)
	{
	  *GetIsMDArcMult(arc)= false;
	  *GetMultiplicity(arc)= a->multipl.value;
	}
      else
	{
	  *GetIsMDArcMult(arc)= true;
	  *GetMultiplicity(arc)= a->multipl.md_mult;
	}
      for (int k=0; k<a->num_pts; k++)
	arc->InsertPos(type==OUTPUTARC?k+1:1,InchToPix(a->point[k]));

      arc->Rearrange();
    }
}

//---------------------------------------------------------------------

void TimeNETLink::SaveTN(EditorP ed, charP fname)
{
  ofstream os(fname);

  ed->Mouse(true);
  // Mauspfeil sperren

  if (os)
    {
      WriteTN(os);
      
      net.Update();
    }
  // .TN-File schreiben

  ed->Mouse(false);
  // Mauspfeil freigeben
}


#define NET_TYPE     "NET_TYPE:"
#define DESCRIPTION  "DESCRIPTION:"
#define PLACES       "PLACES:"
#define TRANSITIONS  "TRANSITIONS:"
#define DELAYS       "DELAY_PARAMETERS:"
#define MARKINGS     "MARKING_PARAMETERS:"
#define RESULTS      "REWARD_MEASURES:"

#define MARKPAR      "MARKPAR"
#define PLACE        "PLACE"
#define DELAYPARAM   "DELAYPAR"
#define TRANSITION   "TRANSITION"

#define DELAYPAR_DEF "DELAYPAR_DEF"
#define EXP_DELAY    "EXP_DELAY"
#define DET_DELAY    "DET_DELAY"
#define GEN_DELAY    "GEN_DELAY"
#define WEIGHT       "WEIGHT"
#define FUNCTION     "FUNCTION"
#define ARC          "CARDINALITY"
#define MEASURE      "MEASURE"



ostream& TimeNETLink::WriteInch(ostream& os,Position pos)
{
  double x= int(pos.x/1.35+.5)/100.0,y= int(pos.y/1.35+.5)/100.0;
  return os<<x<<' '<<y;
}

ostream& TimeNETLink::WriteDelay(ostream& os,Position pos)
{
  double x= int(pos.x*74.0+.5)/100.0,y= int(pos.y*74.0+.5)/100.0;
  return os<<x<<' '<<y;
}

ostream& TimeNETLink::OutNoSemicolon(ostream& os,charP string)
{
  for (int i=0; ((i<(int)strlen(string)) && (string[i]!=';')); i++)
    os << string[i];
  return os;
}

ostream& TimeNETLink::OutSpaces(ostream& os,charP string)
{
  for (int i=0; i<(int)strlen(string); i++)
    {
      if (!strncmp(string+i, "IF", 2))
	{
	  os << " IF ";
	  i+=1;
	  continue;
	}
      else if (!strncmp(string+i, "ELSE", 4))
	{
	  os << " ELSE ";
	  i+=3;
	  continue;
	}
      else
	os << string[i];
    }
  return os;
}

ostream& TimeNETLink::OutSpaces2(ostream& os,charP string)
{
  for (int i=0; i<(int)strlen(string); i++)
    {
      if (!strncmp(string+i, "OR", 2))
	{
	  os << " OR ";
	  i+=1;
	  continue;
	}
      else if (!strncmp(string+i, "AND", 3))
	{
	  os << " AND ";
	  i+=2;
	  continue;
	}
      else if (!strncmp(string+i, "NOT", 3))
	{
	  os << " NOT ";
	  i+=2;
	  continue;
	}
      else
	os << string[i];
    }
  return os;
}

ostream& TimeNETLink::WriteArc(ostream& os,ConnectorP conn,int type)
{
  charP multi= (*GetMultiplicity(conn)).to_charPtr();

  if ((*GetIsMDArcMult(conn)).to_bool()) multi= "<MD>";
  NodeP place= conn->GetInput();

  if (!IsPlace(place)) place= conn->GetOutput();
  Iterator<Position*> piter= conn->Positions();
  int cnt= int(piter)-2;
  Position* pos;

  OutNoSemicolon(os,multi);
  os<<' '<<place->Name()<<' '<<cnt<<endl;

  if (type==OUTPUTARC)
    for (pos=piter; cnt-- && (pos=++piter);)
      WriteInch(os,*pos)<<' '<<endl;
  else
    for (pos=-piter; cnt-- && (pos=--piter);)
      WriteInch(os,*pos)<<' '<<endl;

  return os;
}

ostream& TimeNETLink::WriteTN(ostream& os)
{
  charP arcstr[]= {"INPARCS","OUTPARCS","INHARCS"};
  charP ntstr[]= {"GSPN","DSPN","EDSPN","FSPN"};
  enum {NT_GSPN= 0,NT_DSPN,NT_EDSPN,NT_FSPN};
  int nettype= NT_GSPN;
  int nplaces= 0,ntrans= 0,nmarkings= 0,ndelays= 0,nrewards= 0;
  Iterator<NodeP> niter= net.Prime()->Nodes();
  NodeP node;
  bool flag;

  for (node=niter; node; node=++niter)
    {
      if (IsPlace(node)) nplaces++;
      else if (IsParameter(node))
	{
	  if      (IsMarkPar(node))  nmarkings++;
	  else if (IsDelayPar(node)) ndelays++;
	  else if (IsRewItem(node))  nrewards++;
	}
      else if (IsTransition(node))
	{
	  ntrans++;
	  if (IsDetTrans(node)) nettype= Maxi(nettype,NT_DSPN);
	  if (IsGenTrans(node)) nettype= Maxi(nettype,NT_EDSPN);
	}
    }

  os<<"-- FILE ";
  os<<(netname+TN_ENDING).to_charPtr();
  os<<" CONTAINING STRUCTURAL DESCRIPTION OF A NET"<<endl<<endl;
  os<<NET_TYPE<<"\t\t\t"<<ntstr[nettype]<<endl;
  os<<DESCRIPTION<<"\t\t\t?"<<endl;
  os<<PLACES<<"\t\t\t"<<nplaces<<endl;
  os<<TRANSITIONS<<"\t\t"<<ntrans<<endl;
  os<<DELAYS<<"\t"<<ndelays<<endl;
  os<<MARKINGS<<"\t"<<nmarkings<<endl;
  os<<RESULTS<<"\t"<<nrewards<<endl;

  os<<endl<<"-- LIST OF MARKING PARAMETERS (NAME, VALUE, (X,Y)-POSITION):"
    <<endl<<endl;
  for (node=niter; node; node=++niter)
    if (IsParameter(node) && IsMarkPar(node))
      {
	os<<MARKPAR<<' '<<node->Name()<<' '<<(*GetMarkPar(node)).to_int()<<' ';
	WriteInch(os,node->Mid())<<endl;
      }

  if (nmarkings) os<<endl;

  os<<"-- LIST OF PLACES (NAME, MARKING, (X,Y)-POSITION (PLACE & TAG)):"
    <<endl<<endl;

  for (node=niter; node; node=++niter)
    if (IsPlace(node))
      {
	os<<PLACE<<' '<<node->Name()<<' '<<(*GetMarking(node)).to_charPtr()<<' ';
	WriteInch(os,node->Mid())<<' ';
	WriteInch(os,node->Mid()+(node->GetRelative(0)/1.4*node->Scale()));
	os<<endl;
      }
  if (nplaces) os<<endl;

  os<<"-- LIST OF DELAY PARAMETERS (NAME, VALUE, (X,Y)-POSITION):"<<endl<<endl;

  for (node=niter; node; node=++niter)
    if (IsParameter(node) && IsDelayPar(node))
      {
	charP delay= (*GetDelayPar(node)).to_charPtr();
	
	if ((*GetIsMDDelayPar(node)).to_bool()) delay= "<MD>";
	os<<DELAYPARAM<<' '<<node->Name()<<' ';
	OutNoSemicolon(os,delay);
	os<<' ';
	WriteInch(os,node->Mid())<<endl;
      }
  if (ndelays) os<<endl;

  os<<"-- LIST OF TRANSITIONS"<<endl;
  os<<"-- \t(NAME, DELAY, ENABLING DEPENDENCE, KIND, FIRING POLICY, PRIORITY,"
    <<endl;
  os<<"-- \tORIENTATION, PHASE, GROUP, GROUP_WEIGHT,"
    <<endl;
  os<<"-- \t(X,Y)-POSITION (TRANSITION, TAG & DELAY), ARCS)"
    <<endl;

  for (node=niter; node; node=++niter)
    {
      if (IsTransition(node))
	{
	  ConnectorP conn;
	  charP ttype,* server= "SS";
	  int prior= 0;
	  double ang= node->Angle()*180.0/M_PI;
	  if (ang<0.0) ang += 180.0;
	  int orient=
	    ang<22.5?ORIENT_0:ang<67.5?ORIENT_45:ang<112.5?ORIENT_90:ORIENT_M45;
	  
	  os<<endl<<TRANSITION<<' '<<node->Name()<<' ';
	  
	  if (IsGenTrans(node))
	    {
	      os<<"<MD>";
	      ttype= "GEN";
	    }
	  else if (IsImmediate(node))
	    {
	      charP weight= (*GetWeight(node)).to_charPtr();

	      if ((*GetIsMDDelay(node)).to_bool()) weight= "<MD>";
	      OutNoSemicolon(os,weight);
	      prior= (*GetPriority(node)).to_int();
	      ttype= "IM";
	    }
	  else
	    {
	      charP delay= (*GetDelay(node)).to_charPtr();
	      
	      if ((*GetIsMDDelay(node)).to_bool()) delay= "<MD>";
	      OutNoSemicolon(os,delay);
	      prior= (*GetPriority(node)).to_int();
	      if (IsExpTrans(node))
		{
		  if ((*GetServerType(node)).to_bool()) server= "IS";
		  ttype= "EXP";
		}
	      else ttype= "DET";
	    }
	  
	  os<<' '<<server<<' '<<ttype<<' '<<(!strcmp((*GetPolicy(node)).to_charPtr(), "PRD")?"RE":"RA")
	    <<' '<<prior<<' '<<orient<<" 1 0 1.000000 ";
	  
	  WriteInch(os,node->Mid())<<' ';
	  WriteInch(os,node->Mid()+(node->GetRelative(0)/1.4*node->Scale()))<<' ';
	  WriteDelay(os,node->GetRelative(1)/1.4*node->Scale());
	  os<<endl;

	  Iterator<ConnectorP> iiter= node->Inputs();
	  Iterator<ConnectorP> oiter= node->Outputs();
	  int n[3]= {0,0,0};
	  
	  for (conn=iiter; (conn && IsArc(conn)); conn=++iiter)
	    n[IsInhibitor(conn)?INHIBITOR:INPUTARC]++;
	  
	  for (conn=oiter; conn; conn=++oiter)
	    n[OUTPUTARC]++;
	  
	  os<<arcstr[INPUTARC]<<' '<<n[INPUTARC]<<endl;
	  for (conn=iiter; (conn && IsArc(conn)); conn=++iiter)
	    if (!IsInhibitor(conn))
	      WriteArc(os,conn,INPUTARC);
	  
	  os<<arcstr[OUTPUTARC]<<' '<<n[OUTPUTARC]<<endl;
	  for (conn=oiter; (conn && IsArc(conn)); conn=++oiter)
	    WriteArc(os,conn,OUTPUTARC);
	  
	  os<<arcstr[INHIBITOR]<<' '<<n[INHIBITOR]<<endl;
	  for (conn=iiter; (conn && IsArc(conn)); conn=++iiter)
	    if (IsInhibitor(conn))
	      WriteArc(os,conn,INHIBITOR);
	}
    }
  if (ntrans) os<<endl;

  os<<"-- DEFINITION OF PARAMETERS:"<<endl<<endl;
  flag= false;
  for (node=niter; node; node=++niter)
    if (IsParameter(node) && IsDelayPar(node))
      {
	charP delay= (*GetDelayPar(node)).to_charPtr();
	
	if ((*GetIsMDDelayPar(node)).to_bool())
	  {
	    os<<DELAYPAR_DEF<<' '<<node->Name()<<' '<<delay;
	    if(delay[(int)strlen(delay)-1]!=';') 
	      os<<';';
	    os<<endl;
	    flag= true;
	  }
      }

  if (flag) os<<endl;

  os<<"-- MARKING DEPENDENT FIRING DELAYS FOR EXP. TRANSITIONS:"<<endl<<endl;
  flag= false;
  for (node=niter; node; node=++niter)
    if (IsTransition(node) && IsExpTrans(node))
      {
	charP delay= (*GetDelay(node)).to_charPtr();
	
	if ((*GetIsMDDelay(node)).to_bool())
	  {
	    os<<EXP_DELAY<<' '<<node->Name()<<' ';
	    OutSpaces(os, delay);
	    if (delay[(int)strlen(delay)-1]!=';')
	      os<<';';
	    os<<endl;
	    flag= true;
	  }
      }

  if (flag) os<<endl;

  os<<"-- MARKING DEPENDENT FIRING DELAYS FOR DET. TRANSITIONS:"<<endl<<endl;
  flag= false;
  for (node=niter; node; node=++niter)
    if (IsTransition(node) && IsDetTrans(node))
      {
	charP delay= (*GetDelay(node)).to_charPtr();
	
	if ((*GetIsMDDelay(node)).to_bool())
	  {
	    os<<DET_DELAY<<' '<<node->Name()<<' ';
	    OutSpaces(os, delay);
	    if (delay[(int)strlen(delay)-1]!=';')
	      os<<';';
	    os<<endl;
	    flag= true;
	  }
      }

  if (flag) os<<endl;

  os<<"-- PROBABILITY MASS FUNCTION DEFINITIONS FOR GEN. TRANSITIONS:"
    <<endl<<endl;
  for (flag=false,node=niter; node; node=++niter)
    if (IsGenTrans(node))
      {
	os<<GEN_DELAY<<' '<<node->Name()<<' '<<(*GetPMFunc(node)).to_charPtr();
	if ((    (*GetPMFunc(node)).to_charPtr() )
	    [(int)strlen((*GetPMFunc(node)).to_charPtr())-1]!=';')
	  os<<';';
	os<<endl;
	flag= true;
      }
  if (flag) os<<endl;

  os<<"-- MARKING DEPENDENT WEIGHTS FOR IMMEDIATE TRANSITIONS:"<<endl<<endl;
  flag= false;
  for (node=niter; node; node=++niter)
    if (IsTransition(node) && IsImmediate(node))
      {
	charP weight= (*GetWeight(node)).to_charPtr();

	if ((*GetIsMDDelay(node)).to_bool())
	  {
	    os<<WEIGHT<<' '<<node->Name()<<' ';
	    OutSpaces(os, weight);
	    if (weight[(int)strlen(weight)-1]!=';')
	      os<<';';
	    os<<endl;
	    flag= true;
	  }
      }

  if (flag) os<<endl;

  os<<"-- ENABLING FUNCTIONS FOR IMMEDIATE TRANSITIONS:"<<endl<<endl;
  for (flag=false,node=niter; node; node=++niter)
    if (IsImmediate(node))
      {
	charP func= (*GetEnable(node)).to_charPtr();
	if (func && *func)
	  {
	    os<<FUNCTION<<' '<<node->Name()<<' ';
	    OutSpaces2(os, func);
	    if (func[(int)strlen(func)-1]!=';')
	      os<<';';
	    os<<endl;
	  }
      }
  if (flag) os<<endl;

  os<<"-- MARKING DEPENDENT ARC CARDINALITIES:"<<endl<<endl;
  Iterator<ConnectorP> citer= net.Prime()->Connectors();
  ConnectorP conn;
  for (flag=false,conn=citer; conn && IsArc(conn); conn=++citer)
    {
      charP multi= (*GetMultiplicity(conn)).to_charPtr();

      if ((*GetIsMDArcMult(conn)).to_bool())
	{
	  Node *place= conn->GetInput(),* trans= conn->GetOutput();
	  bool inp= IsPlace(place);
	  
	  if (!inp)	{
	    NodeP tmp= place; place= trans; trans= tmp;
	  }
	  os<<ARC<<' '<<(!inp?"OUTPARC":(IsInhibitor(conn)?"INHARC":"INPARC"))
	    <<' '<<trans->Name()<<' '<<place->Name()<<endl;
	  OutSpaces(os, multi);
	  if (multi[(int)strlen(multi)-1]!=';')
	    os<<';';
	  os<<endl;
	  flag= true;
	}
    }
  if (flag) os<<endl;

  os<<"-- REWARD MEASURES:"<<endl<<endl;

  for (node=niter; node; node=++niter)
    if (IsRewItem(node))
      {
	charP reward= (*GetRewItem(node)).to_charPtr();
	os<<MEASURE<<" "<<node->Name()<<endl<<reward;
	if (reward[(int)strlen(reward)-1]!=';') os<<';';
	os<<endl<<endl;
      }
  if (nrewards) os<<endl;

  return os<<endl<<"-- END OF SPECIFICATION FILE"<<endl;
}
//---------------------------------------------------------------------	

void TimeNETLink::FselCallback(EditorP ed, charP file, bool ok)
{
  if (ok)
    {
      ed->Mouse(true);
      // Mauspfeil sperren

      NetP net= LoadTN(file);
      // versuche als .TN Datei zu laden

      if (!net) net= Net::Load(file);
      // geht nicht, dann als .net-Datei

      if (net)
	{
	  charP path;
	  path= strrchr(file,'/');
	  char rpath[1024];
	  if (path)
	    {
	      for (int i=0; i<(path-file); i++)
		rpath[i]= file[i];
	      rpath[path-file]= '\0';
	      
	      ed->SetCurrentPath(rpath);
	      // Pfad dauerhaft aendern
	    }
	  net->OpenEditor(0,ed->DpyName(),(path?(char*)rpath:(char*)NULL));
	  
	  //AH NEW: Netznamen immer auf .net setzen
	  Text filename = file;
	  filename = filename - TN_ENDING - NET_ENDING + NET_ENDING;
	  net->SetFileName(filename.to_charPtr());
	  // Filenamen sichern
	  ed->Update();
      	}
      else
	{
	  Text DialogContense;
	  DialogContense+= "unable to load the desired net.";
	  
	  OpenMsgDialog(*this->ed, "TimeNET_Error",
			DialogContense.to_charPtr(),true,"Close");
	}

      ed->Mouse(false);
      // Mauspfeil freigeben
    }	
}

//---------------------------------------------------------------------	

void TimeNETLink::AddCB(EditorP ed, charP file, bool ok)
{
  if (ok)
    {
      Page& curr_page= **(net.pages[ed]);

      NetP addnet= LoadTN(file);
      // versuche als .TN Datei zu laden

      if (!addnet) addnet=  Net::Load(file);
      // geht nicht, dann als .net-Datei

      if (!addnet) return;

      if (curr_page.Class()==addnet->Prime()->Class())
	{
	  net.UndoCopy();
	  curr_page.Deselect();
	  curr_page.PageCopy(*addnet->Prime());
	}
      
      delete addnet;
      
      charP path;
      path= strrchr(file,'/');
      if (path)
	{
	  char rpath[1024];
	  for (int i=0; i<(path-file); i++)
	    rpath[i]= file[i];
	  rpath[path-file]= '\0';
	  
	  ed->SetCurrentPath(rpath);
	  // Pfad dauerhaft aendern
	}
      ed->Update();

      net.RefreshModules();
    }
}

//---------------------------------------------------------------------	

void TimeNETLink::SaveAsCB(EditorP ed, charP filename, bool ok)
{
  if (ok)
    {
      Text rname(filename); //name of net as entered by user in dialog
      Text originalname = net.FileName(); //name of net as it is now
      charP name;
      charP end;
      
      name= strrchr(filename,'/');
      if (name)
	++name;
      else
	name= filename;

      end= strrchr(name,'.');
      if (!end)
	{
	  if (ExportCB)
	    {
	      end= TN_ENDING;
	      rname+= TN_ENDING;
	    }
	  else
	    {
	      end= NET_ENDING;
	      rname+= NET_ENDING;
	    }
	}

      net.SetFileName(rname.to_charPtr());
      // Filenamen aendern

      if (!strcmp(end, TN_ENDING))
	if (!CheckNet())
	  return;
 	else SaveTN(ed, rname.to_charPtr());
      else if (!strcmp(end, NET_ENDING))
	net.Save();
      else
	{
	  Text DialogContense;
	  DialogContense+= "Ending of the filename must be either "
	    TN_ENDING" or "NET_ENDING;
	  
	  OpenMsgDialog(*this->ed, "TimeNET_Error",
			DialogContense.to_charPtr(),true,"Close");
	  return;
	}
      // Netz speichern als .TN oder .net

      //AH NEW: don't change filename permanently when exporting
      if(ExportCB)
	{
	  net.SetFileName(originalname.to_charPtr());
	  ExportCB = false;
	}

      net.modified= false;

      charP path;
      path= strrchr(filename,'/');
      if (path)
	{
	  char rpath[1024];
	  for (int i=0; i<(path-filename); i++)
	    rpath[i]= filename[i];
	  rpath[path-filename]= '\0';

	  ed->SetCurrentPath(rpath);
	  // Pfad dauerhaft aendern
	}
      ed->Update();
    }
}

void TimeNETLink::OnLogwinButton(Ident& button)
{
  if (button=="Close")
    {
      if (closereason==1)
	{
	  CloseLogwin();
	  DestroyLogwin();
	}
      else if (closereason==2)
	{
	  Text DialogContense;
	  DialogContense+= "Continue or Stop with Solution?";
	  
	  if (killreason==1)
	    {
	      if (pidStationaryAnalysis) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==9)
	    {
	      if (pidStationaryAnalysisDTSPN) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==2)
	    {
	      if (pidStationaryApproximation) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==3)
	    {
	      if (pidStationarySimulation) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==7)
	    {
	      if (pidRestartStSimulation) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==4)
	    {
	      if (pidTransientAnalysis) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==10)
	    {
	      if (pidTransientAnalysisDTSPN) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==5)
	    {
	      if (pidTransientSimulation) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==6)
	    {
	      if (pidExperiment) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==8)
	    {
	      if (pidExperiment2) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==11)
	    {
	      if (pidExperiment3) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==13) /*EstimSE*/
	    {
	      if (pidEstimSE) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==14) /*Traps*/
	    {
	      if (pidTraps) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }
	  else if (killreason==15) /*Siphons*/
	    {
	      if (pidSiphons) 
		{
		  OpenMsgDialog(*this->ed, "TimeNET_Warning",
				DialogContense.to_charPtr(),false,"Stop Continue Cancel");
		}
	      else
		{
		  CloseLogwin();
		  DestroyLogwin();
		}
	    }

	}
    }
}

//-----------------------------------------------------------------------------

void TimeNETLink::OnFilesel(char* name, bool ok)
{
  if (!ok) return;

  Text filename = Text(name) - ".opt" + ".opt";

  Struct* params = GetParams(); 

  if (save_options) 
    {
      ofstream file(filename.to_charPtr());
      params->Output(file);
      file.close();
    }
  else 
    {
      ifstream file( filename.to_charPtr());
      params->Input(file);
      file.close();
  }
}

//-----------------------------------------------------------------------------
void TimeNETLink::DialogCallback(Dialog<TimeNETLink,bool>& dia,bool,Ident& button)
{
  setup->EvalWidget();

  if (button=="Default")
    {
      if (setup->GetMember("gp_logx"))
	*setup->GetMember("gp_logx")= false;
      if (setup->GetMember("gp_logy"))
	*setup->GetMember("gp_logy")= false;
      if ((*setup->GetMember("gp_title")).to_bool())
	*setup->GetMember("gp_title")= "";
      if ((*setup->GetMember("gp_xdescr")).to_bool())
	*setup->GetMember("gp_xdescr")= "";
      if ((*setup->GetMember("gp_ydescr")).to_bool())
	*setup->GetMember("gp_ydescr")= "";
    }
  if (button=="Cancel")
    {
      dia.Close();
      delete(setup);

      if (pidGnuPlot)
	{
	  killpg(pidGnuPlot, SIGTERM);
	  pidGnuPlot= 0;
	}
    }
  if (button=="Close")
    {
      if (setup->GetMember("gp_logx"))
	gp_logx= (*setup->GetMember("gp_logx")).to_bool();
      if (setup->GetMember("gp_logy"))
	gp_logy= (*setup->GetMember("gp_logy")).to_bool();
      if (setup->GetMember("gp_title"))
	gp_title= (*setup->GetMember("gp_title")).to_charPtr();
      if (setup->GetMember("gp_xdescr"))
	gp_xdescr= (*setup->GetMember("gp_xdescr")).to_charPtr();
      if (setup->GetMember("gp_ydescr"))
	gp_ydescr= (*setup->GetMember("gp_ydescr")).to_charPtr();

      if (pidGnuPlot)
	{
	  killpg(pidGnuPlot, SIGTERM);
	  pidGnuPlot= 0;
	}
      dia.Close();
      delete(setup);
    }
  if (button=="Start")
    {
      if (setup->GetMember("gp_logx"))
	gp_logx= (*setup->GetMember("gp_logx")).to_bool();
      if (setup->GetMember("gp_logy"))
	gp_logy= (*setup->GetMember("gp_logy")).to_bool();
      if (setup->GetMember("gp_title"))
	gp_title= (*setup->GetMember("gp_title")).to_charPtr();
      if (setup->GetMember("gp_xdescr"))
	gp_xdescr= (*setup->GetMember("gp_xdescr")).to_charPtr();
      if (setup->GetMember("gp_ydescr"))
	gp_ydescr= (*setup->GetMember("gp_ydescr")).to_charPtr();

      int b= 1;
      Text value;
      do
	{
	  Text member;
	  member+= "binding";
	  member+= double(b++);
	  value= (*setup->GetMember("value")).to_charPtr();
	  if (value.to_bool() &&
	      (member==value.to_charPtr())) {gp_xvalue= b-1; break;};
	} while (value.to_bool());
      b= 1;
      do
	{
	  Text member;
	  member+= "binding";
	  member+= double(b++);
	  value= *setup->GetMember("value2");
	  if (value.to_bool() &&
	      member==value.to_charPtr()) {gp_yvalue= b-1; break;};
	} while (value.to_bool());
     
      if (gp_xvalue == gp_yvalue) 
	{
	  Text DialogContense= "x- and y-values must not be the same";
	  
	  OpenMsgDialog(*this->ed, "TimeNET_Error",
			DialogContense.to_charPtr(),true,"Close");
	  return;
	}
    
      GnuPlot (*this->ed);
    }
}

//-----------------------------------------------------------------------------

void TimeNETLink::OnDialogButton(Ident& button)
{

  StructP params= GetParams();

  if (button=="Default")
    {
      DefaultParams(params);
    }
  if (button=="Load" || button=="Save") 
    {
      save_options = (button == "Save");

      OpenFilesel(*this->ed, "Select Option File", "*.opt");
    }
  if (button=="Start")
    {
      SaveParams(params);

      if (params->GetMember("exp3_param"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  Experiment3(*this->ed);
	}
      else if (params->GetMember("exp2_param"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  Experiment2(*this->ed);
	}
      else if (params->GetMember("ss_thresholds"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  RestartStSimulation(*this->ed);
	}
      else if (params->GetMember("ss_distr"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  StationarySimulation(*this->ed);
	}
      else if (params->GetMember("sp_epsilon"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  StationaryApproximation(*this->ed);
	}
      else if (params->GetMember("ta_epsilon"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  TransientAnalysis(*this->ed);
	}
      else if (params->GetMember("dtta_epsilon"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  TransientAnalysisDTSPN(*this->ed);
	}
      else if (params->GetMember("ts_distr"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  TransientSimulation(*this->ed);
	}
      else if (params->GetMember("exp_param"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  Experiment(*this->ed);
	}
      else if (params->GetMember("sa_distributed"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  StationaryAnalysis(*this->ed);
	}
      else if (params->GetMember("dtsa_epsilon"))
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  StationaryAnalysisDTSPN(*this->ed);
	}
      else if (params->GetMember("gp_logx"))
	{
	  GnuPlot(*this->ed);
	}
      else
	{
	  CloseDialog();
	  DestroyDialog();
	  
	  Print(*this->ed);
	}
    }
  if (button=="Cancel")
    {
      CloseDialog();
      DestroyDialog();

      if (pidGnuPlot)
	{
	  killpg(pidGnuPlot, SIGTERM);
	  pidGnuPlot= 0;
	}
    }
  if (button=="Close")
    {
      SaveParams(params);

      if (pidGnuPlot)
	{
	  killpg(pidGnuPlot, SIGTERM);
	  pidGnuPlot= 0;
	}
      CloseDialog();
      DestroyDialog();
    }
  if (button=="Stop")
    {
      if (killreason==1)
	{
	  if (pidStationaryAnalysis) 
	    {
	      killpg(pidStationaryAnalysis, SIGTERM);
	      pidStationaryAnalysis= 0;
	    }
	}
      else if (killreason==9)
	{
	  if (pidStationaryAnalysisDTSPN) 
	    {
	      killpg(pidStationaryAnalysisDTSPN, SIGTERM);
	      pidStationaryAnalysisDTSPN= 0;
	    }
	}
      else if (killreason==2)
	{
	  if (pidStationaryApproximation) 
	    {
	      killpg(pidStationaryApproximation, SIGTERM);
	      pidStationaryApproximation= 0;
	    }
	}
      else if (killreason==3)
	{
	  if (pidStationarySimulation) 
	    {
	      killpg(pidStationarySimulation, SIGTERM);
	      pidStationarySimulation= 0;
	    }
	}
      else if (killreason==7)
	{
	  if (pidRestartStSimulation) 
	    {
	      killpg(pidRestartStSimulation, SIGTERM);
	      pidRestartStSimulation= 0;
	    }
	}
      else if (killreason==4)
	{
	  if (pidTransientAnalysis) 
	    {
	      killpg(pidTransientAnalysis, SIGTERM);
	      pidTransientAnalysis= 0;
	    }
	}
      else if (killreason==10)
	{
	  if (pidTransientAnalysisDTSPN) 
	    {
	      killpg(pidTransientAnalysisDTSPN, SIGTERM);
	      pidTransientAnalysisDTSPN= 0;
	    }
	}
      else if (killreason==5)
	{
	  if (pidTransientSimulation) 
	    {
	      killpg(pidTransientSimulation, SIGTERM);
	      pidTransientSimulation= 0;
	    }
	}
      else if (killreason==6)
	{
	  if (pidExperiment) 
	    {
	      killpg(pidExperiment, SIGTERM);
	      pidExperiment= 0;
	    }
	}
      else if (killreason==8)
	{
	  if (pidExperiment2) 
	    {
	      killpg(pidExperiment2, SIGTERM);
	      pidExperiment2= 0;
	    }
	}
      else if (killreason==11)
	{
	  if (pidExperiment3) 
	    {
	      killpg(pidExperiment3, SIGTERM);
	      pidExperiment3= 0;
	    }
	}
      else if (killreason==13)
	{
	  if (pidEstimSE) 
	    {
	      killpg(pidEstimSE, SIGTERM);
	      pidEstimSE= 0;
	    }
	}
 else if (killreason==14)
	{
	  if (pidTraps) 
	    {
	      killpg(pidTraps, SIGTERM);
	      pidTraps= 0;
	    }
	}
 else if (killreason==15)
	{
	  if (pidSiphons) 
	    {
	      killpg(pidSiphons, SIGTERM);
	      pidSiphons= 0;
	    }
	}
      CloseDialog();
      DestroyDialog();

      CloseLogwin();
      DestroyLogwin();

    }
  if (button=="Continue")
    {
      CloseDialog();
      DestroyDialog();

      CloseLogwin();
      DestroyLogwin();
    }
}

#endif
