/*$Header: /home/pdv/timenet/CVS/TimeNET/Print/src/Paint.h,v 1.5 1994/12/06 18:02:58 joa Exp $*/
/*******************************************************************************
Modul           :       Paint.h

Purpose         :       Definition der netzbeschreibenden Datenstrukturen

Project Director:       Christoph Lindemann TU Berlin

Programmer      :       Christian L"uhe

History         :       release 1: November 1992

Modifiziert	:	Joachim Schneider
			Benutzung der Typdefintionen aus netio.h
*******************************************************************************/

#ifndef PAINT_H
#define PAINT_H

#include "Result.h"
#include "Structure.h"

#define OK 0
#define OPEN_ERROR 1
#define NONAME_ERROR 2
#define WRONGNET_ERROR 3
#define NOMEM_ERROR 4

#define PixPerInch 90.0
#define PointsPerInch 72.0
#define PixToInch(X)       ((double)(X) / (PixPerInch))
#define InchToPoint(X)       ((X)*(PointsPerInch))
#define DEFAULT_SIZE       16
/* MARK_RADIUS = (DEFAULT_SIZE / 8) */
#define MARK_RADIUS        2
/* MARK_DIAMETER = (DEFAULT_SIZE / 4) */
#define MARK_DIAMETER      4
#define DEFAULT_SPLINE_RADIUS PixToInch(32)



typedef enum {
  NOOBJECT,
  PLACE,
  IMTRANS,
  EXPTRANS,
  DETTRANS,
  GENTRANS,
  ARC,
  MARKPAR,
  RATEPAR,
  RESPAR,
  TAG
} Objects;

typedef enum {
  INFINITE_SERVER,
    SINGLE_SERVER
} EnablingDependence;

typedef struct {
  char    *name;
  double  *value;
} CurveRewardT;

typedef struct {
  char          *parameter;
  double        from;
  double        to;
  double        step;
  int           count;       /* number of steps */
  int           rewcount;
  CurveRewardT  *rew;
} CurveT; /*===================================*/


#ifndef READNET
#ifdef __STDC__
  extern int ReadResult(NetDescr *net, char *name, ResultT *res);
  extern int ReadStructure(NetDescr *net, char *name, StructureT *structure);
#else
  extern int ReadResult();
  extern int ReadStructure();
#endif
#endif



#ifndef PAINTPLACE
#ifdef __STDC__
  extern void PaintPlace(Place place);
#else
  extern void PaintPlace();
#endif
#endif



#ifndef PAINTTRANS
#ifdef __STDC__
  extern void PaintTrans(NetDescr n, Transition trans);
#else
  extern void PaintTrans();
#endif
#endif



#ifndef PAINTNET
  extern int marks;
  extern int tags;
  extern int spline;
  extern double zoom;
  extern int level;
#endif

#endif

