#include "types.h"			/* definitions and types */

extern char *emalloc();
extern char *ecalloc();
 
#define TYPE2CHAR(type) (type==EXP)?'e':((type==DET)?'d':'g')
/* used by file_tang_marking() */
/*
 *	Schreibt die Belegung der Stellen fuer diese Markierung:
 */
file_print_global_marking(tokens,mark)
	int	*tokens;		/* marking */
	tang_marking *mark;
{
	subnet	*sub;
	int pla, tok, no, sb;
	int dis;

	for(pla=0; pla<timed.no_places; pla++)
	{	no = timed.places[pla].number;
		tok = tokens[no];
		fprintf(ftmark," %d", tok);
	}
	for(sb = 0; sb < no_subnets; sb++)
	{	sub = &subnets[sb];
		for(pla=0; pla<sub->no_places; pla++)
		{	no = sub->places[pla].number;
			tok = tokens[no];
			fprintf(ftmark," %d",tok);
		}
	}
	fprintf(ftmark,"\n");
}

/* used by file_tang_tree() */
void
file_tang_marking(sub, tsub, mark)
	subnet *sub;
	t_sub  *tsub;
	tang_marking *mark;
{
	int	*tokens;
	int        path_no;
	tang_path *path;
	timed_t *current_trans;

	fprintf(ftmark,"%d",mark->number);
	tokens = (int *)emalloc(no_places * sizeof(int));
	global_marking(mark->mark, mark->disc, tokens);
	file_print_global_marking(tokens,mark);
	for(path_no=mark->no_time_paths; path_no; )
	{
		path = &(mark->time_paths[--path_no]);
		current_trans = &(tsub->transitions[path->tran_no]);
		fprintf(frrg,"%d %d %d %.15g %.15g",
			mark->number,
			path->marking->number,
			current_trans->number,
			path->delay, path->prob );
		if (ISNEIS_P(current_trans))  /* a nonexponential infinite server */
			fprintf(frrg," %d", (int)(mark->neis_mult[current_trans->det_no]) );
		fprintf(frrg,"\n");
	}
}
	
/* used by file_graph_tree() */
void
file_tang_tree(sub, tsub, node, level)
	subnet	*sub;
	t_sub	*tsub;
	tang_node *node;
	int level;
{
	int pla;
	sp_pointer *lookup;

	if (level > no_subnets)
	{	file_tang_marking(sub, tsub, (tang_marking *)node);
		return;
	}
	for(pla = 0; pla < node->number; pla++)
	{	lookup = (sp_pointer *)node->next;
		file_tang_tree(sub, tsub, lookup[pla].next, level+1);
	}
}

/* is used by main */
void file_graph_tree(sub, tsub, nrrg, ntmark )
subnet *sub;
t_sub  *tsub;
char   *nrrg, *ntmark;
{
	extern tang_node *graph;
	subnet *isub;
	char   *next;
	int sb, np, pla;
#ifndef OLDINTERNINTERFACE
	int tra;
	timed_t *ptra;
#endif

	if (graph == NULL)
	{	fprintf(stderr,"reachability graph tree is empty\n");
		return;
	}
	/*
	 *	nur letzte filenamenkomponente im file anzeigen:
	 */
	for(next=  nrrg; *next; next++) if (*next == '/') nrrg   = next+1;
	for(next=ntmark; *next; next++) if (*next == '/') ntmark = next+1;
	fprintf(frrg,"#\n# file %s containing the edges of the reduced reachability graph (RRG)\n#\n",nrrg);

	fprintf(frrg,"# number of tangible markings #tmark:\n");
	fprintf(frrg,"%d\n",no_tang_markings);

	fprintf(frrg,"# number of edges #edges:\n");
	fprintf(frrg,"%d\n",no_edges);

#ifndef OLDINTERNINTERFACE
	fprintf(frrg,"# number of timed transitions #timedTrans:\n");
	fprintf(frrg,"%d\n",timed.no_trans);

	fprintf(frrg,"# the next #timedTrans rows are describing the timed transitions\n");
	fprintf(frrg,"# format: transName transID  transType     serverType    semantics\n");
	fprintf(frrg,"#         char*     unsigned char* (e|d|g) char *(SS|IS) char* (rs|re|ra)\n");
	for (tra = 0; tra < timed.no_trans; tra++) {
		ptra = &(timed.transitions[tra]);
		fprintf(frrg,"%s %d %c",ptra->name,ptra->number, TYPE2CHAR(ptra->type) );
		switch(ptra->infinite) {
			case SS: /* single   server race enabling   */
				fprintf(frrg," SS re");
				break;
			case IS: /* infinite server race enabling   */
				if (ptra->type!=EXP) {
					fprintf(frrg," IS re");
					break;
				}
				/*
				 *	in case of exponential infinite server, this is now single serv.
				 */
			case RE: /* single   server race enabling   */
				fprintf(frrg," SS re");
				break;
			case RS: /* single   server race resampling */
				fprintf(frrg," SS rs");
				break;
			case RA: /* single   server race age        */
				fprintf(frrg," SS ra");
				break;
			default:
				fprintf(stderr,"INTERNAL ERROR %s(%d)\n",__FILE__,__LINE__);
				break;
		}
		fprintf(frrg,"\n");
	}
	fprintf(frrg,"# the next #edges rows are describing the edges of the RRG\n");
	fprintf(frrg,"# format: fromMark toMark   transID  delay  prob   serverMult\n");
	fprintf(frrg,"#         unsigned unsigned unsigned double double unsigned\n");
#else
	fprintf(frrg,"# the next #edges rows are describing the edges of the RRG\n");
	fprintf(frrg,"# format: fromMark toMark   transType transNo  delay  prob\n");
	fprintf(frrg,"#         unsigned unsigned char      unsigned double double\n");
#endif
	fprintf(ftmark,"#\n# file %s containing the numbering of the tangible markings\n#\n", ntmark );
	fprintf(ftmark,"# number of places in net #places:\n");
	np = timed.no_places;
	for(sb = 0; sb < no_subnets; sb++)
	{
		np += subnets[sb].no_places;
	}
	fprintf(ftmark,"%d\n",np);

	fprintf(ftmark,"# the next #places rows are describing the numbering of places\n# format: placeName placeNo\n");
	np = 0;
	for(pla=0; pla<timed.no_places; pla++)
	{
		fprintf(ftmark,"%s %d\n",
			timed.places[pla].name,
			np++
			);
	}
	for(sb = 0; sb < no_subnets; sb++)
	{
		isub = &subnets[sb];
		for(pla=0; pla<isub->no_places; pla++)
		{
			fprintf(ftmark,"%s %d\n",
				isub->places[pla].name,
				np++
				);
		}
	}

	fprintf(ftmark,"# number of tangible markings #tmark:\n");
	fprintf(ftmark,"%d\n",no_tang_markings);
	fprintf(ftmark,"# the next #tmark rows are giving the marking number of each marking vector\n");
	fprintf(ftmark,"# format: markNo #place0 .. #place(#places-1)\n");

	file_tang_tree(sub, tsub, graph, 0);
}
