#include "types.h"			/* definitions and types */

extern char *emalloc();				/* from utils.c */
extern char *ecalloc();          /* from utils.c */
extern void efree();
extern int  *current_mark;
extern double md_rate();
extern void print_global_marking();

/*
 *	Calculate how often a deterministic infinite server is activated
 * the vaialble current_mark must be set to the current global marking
 * pre: test_global_conc() is already checked!
 */
neis_cnt neis_mult( mark, i_mat )
	int	*mark;		/* local marking      */
	sp_place *i_mat;	/* input matrix row   */
{
	int	pla, value, minvalue;
/***********
	the inhibitor arcs were already checked by test_global_conc():

	for(pla = 1; pla <= h_mat[0].num; pla++) {
		value =h_mat[pla].plu_id?md_arc_mult(h_mat[pla].plu_id):h_mat[pla].value;
		if (value && (mark[h_mat[pla].num] >= value))
			return (neis_cnt)FALSE;		 too many inhibitor token
	}
**************/
	minvalue = MAXINT;
	for(pla = 1; pla <= i_mat[0].num; pla++) {
		/* calculate possible markingdependent markings needed for activation: */
		value = i_mat[pla].plu_id?md_arc_mult(i_mat[pla].plu_id):i_mat[pla].value;
		if (!value) continue; /* inputs with values '0' are ignored! */
		if (!(value = mark[i_mat[pla].num] / value)) {
			/* this should not happen, because of test_global_conc() check */
			fprintf(stderr,"INTERNAL ERROR in %s(%d)\n",__FILE__,__LINE__);
			return (neis_cnt)FALSE;		/* not enough input token */
		}
		if (value<minvalue)
			minvalue = value;
	}
	if (minvalue>(int)MAXNEIS_CNT) {/* memory space for neis_cnt exeeded! */
		fprintf(stderr,"%s: ERROR: non-exponential infinite server is activated %d times, max. %d is allowed here...in marking:\n",progname,minvalue,MAXNEIS_CNT);
		print_global_marking(mark);
		exit(1);
	}
	return (neis_cnt)minvalue;
}
