/* ************************************************************************
*                                                                          
*  Datei	  :	pars_TN.h                     
*                                                                          
*  Aufgabe        :	Typdeklarationen fuer den Scanner / Parser
*			scan_TN.x und pars_TN.y
*                                                                          
*  Programmierer  :     Armin Zimmermann, Ch. Kelling, J. Schneider
*
*  Datum	  :	Februar 1993, Mai 94
*
*  Datum	  :	Juli 94
*
**************************************************************************/

/*
#define YYDEBUG 1
*/

#include <stdio.h>

#define	INPUT	0
#define OUTPUT	1
#define	INHIBIT	2

#define INTEGR_FOR_EXPECTED_VALUE  1
#define INTEGRATE_NORMAL           0

typedef struct place				/* type for places */
{	char	*name;				/* place name */
}  place;

typedef struct name_nr
{	char	*name;				/* object name (mpar) */
	int	val;				/* number or value */
}  name_nr;

typedef enum {Value, Definition} delay_type;

typedef struct name_delay
{	char	*name;			        /* delay parameter name */
	delay_type type;                        /* value, definition */
	union {
	    double	val;				/* value */
	    char        *def;
	} values;
}  name_delay;

typedef struct transition			/* type for transitions */
{	char	*name;				/* place name */
	int	type;				/* transition type, see above*/
	int	id;				/* rate is marking dependent or
						   parameter dependend or 
						   pmf-defined; 
						   value is label in switch */
	int     parameter;                      /* rate parameter;
						   index in r_par[] */
	char    *def;                           /* definition or parameter */
	time_l  *pmf_def;			/* definition of pmf function*/
	int	number;				/* global identification 
						   number */
	int	ok;				/* has been defined */
}  transition;

#define INPARC	0
#define OUTPARC	1
#define INHARC	2

typedef struct md_arc				/* type for marking dependent arcs */
{	int	type;				/* arc type, see above */
	int	place;				/* number of connected place */
	int	trans;				/* number of connected transition */
	int	id;				/* global identification number */
	int	*deter;				/* determining places */
	struct md_arc	*next;
}  md_arc;

typedef struct ena_fct				/* type for marking dep. enabling functions */
{	int	trans;				/* number of transition */
	int	id;				/* global identification number */
	int	*deter;				/* determining places */
}  ena_fct;

typedef struct weight				/* type for marking dep. imm. transition weights */
{	int	trans;				/* number of transition */
	int	*deter;				/* determining places */
}  weight;

time_l  *parse_pmf(); /* 1. bereitet parsieren vor */
int    do_parse();                 /* 1.5 ruft parser mit file temp.pmf auf */
double integrate();           /* 2.1 integrieren */
double expected_value();                 /* 2.2 erwartungswert errechnen */
time_l  *free_whole_stru();               /* 3. speicher freigeben */


time_l  *melt_intervall();
power_m *melt_power();

time_l  *copy_all_intervall();
power_m *copy_all_power();
expo_n  *copy_all_expo();

void        append_one_power();
void        append_one_expo();
void add_or_append_one_power();
void add_or_append_all_expos();

power_m *negate_all_c();

time_l  *make_l_stru();
power_m *make_m_stru();
expo_n  *make_n_stru();
power_m *zero_tail();
time_l  *define_file_access();

