/*****************************************************************************

Programm	:	callinvars

Komponente	:	callinvars.c
                        Berechnet Invarianten
			Eingabe: Inzidenzmatrix, untransponiert
			(Zeilen == Stellen, Spalten == Transitionen)

Programmer	:	Alexander Huck
Date		:	1999

*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "matrixIO.h"
#include "matrixOps.h"
#include "matrix.h"
#include "matrixProcs.h"
#include "timer.h"
#include "invars.h"
#include "malloc.h"
#include "inequalities.h"
#include "invars.h"

/*#define DEBUG*/

int main(argc, argv)
int argc;
char *argv[];
 {
   char filename[500];
   char resultfilename[500];
   INTMATRIX *Mptr, *InvariantsMat, *TransInc=0;
   FILE *infile, *resultfile;
   int numinv;
#ifdef DEBUG
 char debugfilename[500];
  FILE *outfile;
#endif
  
#ifdef DEBUG
  strcpy(debugfilename, "callinvars.out");
  outfile = fopen(debugfilename, "w");
#endif  

   if (argc != 2 && argc !=3 )
     {
       printf("nee, so geht das nicht\n");
       printf("bitte Dateinamen fuer Datei mit Inzidenzmatrix \n");
       printf("und optional Dateinamen fuer Ergebnis\n");
       return 1;
     }

   strcpy(filename, argv[1]); 

   if (argc ==3)
     strcpy(resultfilename, argv[2]); 

   infile = fopen(filename, "r");
   if (infile == NULL)
     printf("does not exist or cannot be opened");
   Mptr = Matrix_Read(infile);
   fclose(infile);

#ifdef DEBUG
   fprintf(outfile,"callinvars: INPUT MATRIX \n");
   FPRINTMATI(outfile,0,Mptr->R-1,0,Mptr->C-1,Mptr);
#endif  

   
   if(Mptr->C && Mptr->R)
     {
       TransInc=TransMat(Mptr);
       FreeMat(Mptr);
       numinv=INVARIANTS(&InvariantsMat, TransInc);
     }
   else numinv =0;
	
   
   /*printf("Anz. Invarianten : %i \n", numinv);*/

#ifdef DEBUG 

   fprintf(outfile,"Loesungen:\n");
   FPRINTMATI(outfile,0,InvariantsMat->R-1,0,InvariantsMat->C-1,InvariantsMat);
  
   fprintf(outfile, "Anz. Loesungen : %i \n", numinv);
   fprintf (outfile,"Time passed with computation: %8.2f s\n", time_passed(0));
   fclose(outfile);
#endif

   if(argc == 3)
     {
       resultfile = fopen(resultfilename, "w");
       if (resultfile == NULL)
	 printf("does not exist or cannot be opened");
       FPRINTMATI(resultfile, 0,InvariantsMat->R-1,0,InvariantsMat->C-1,InvariantsMat);
       fclose(resultfile);
     }

   FreeMat(TransInc);
   if(numinv)
     FreeMat(InvariantsMat);
   return 0;
}

