/*****************************************************************************

Programm	:	struct, traps, siphons, estimse, reachable

Komponente	:	index.c
                        Enthaelt Funktionen zur 
			Indexverwaltung

Programmer	:	Alexander Huck
Date		:	1999

*****************************************************************************/

#include "matrix.h"
#include "sharedVars.h"
#include "lists.h"
/*******************************************************************************************
 row1 and row2 have changed places,
       update Index matrix  
*******************************************************************************************/
void IndexExchange(int row1, int row2)
{
  static USI pos1, pos2;
  static USI temp;
  
  temp = IndexRL->V[row1][0];
  IndexRL->V[row1][0] = IndexRL->V[row2][0];
  IndexRL->V[row2][0] = temp;
  
  pos1 = IndexRL->V[row1][0];
  pos2 = IndexRL->V[row2][0];
  
  if(pos1 != TOP)
    {
      IndexLR->V[pos1][0] = row1;
    }
  
  if(pos2 != TOP)
    {
      IndexLR->V[pos2][0] = row2;
    }
  
  return;
} /*IndexExchange*/

/*******************************************************************************************
  IndexAppend: append thisray to the index list
*******************************************************************************************/
USI IndexAppend(USI thisray)
{
 static int index;
  if (!blockflag)
    index = GetFreeRow(&FLR, &blockflag); /*get index */
  else
    {
      if (NbIndexLR>=IndexLR->R)
	{
	  ResizeRows(&IndexLR, RESIZE_ADDROWS); /*add rows to Index*/
	}
      index = NbIndexLR;
      NbIndexLR++;
    }
  IndexLR->V[index][0] = thisray;  /*write position of thisray*/
  return index;
} /*IndexAppend*/

/*******************************************************************************************
  StoreIndex: store index for ray thisray
*******************************************************************************************/
int StoreIndex(USI thisray)
{
  static USI index;
  static USI pos;
  /*check if thisray is already in LRIndex*/
  pos = IndexRL->V[thisray][0];
  if(pos != TOP)
    return pos; /*do nothing*/
  else
    {
      /*insert thisray in IndexLR, at position index*/
      index = IndexAppend(thisray);
      /*store position in IndexRL*/
      IndexRL->V[thisray][0] = index; 
    }
  return index;
}

/*******************************************************************************************
  ResizeIndexRL: allocate new memory for IndexRL
*******************************************************************************************/
void ResizeIndexRL(USI startrow, USI endrow)
{
  static int i ,resize;
  if (endrow>=IndexRL->R)
    {
      resize =  endrow - IndexRL->R;
      ResizeRows(&IndexRL, resize); /*add rows to Index*/
    }
  NbIndexRL = endrow;
  for (i = startrow; i < endrow; i++)
    {
      IndexRL->V[i][0] = TOP;/*mark as unused*/
    }
}/*ResizeIndexRL*/

/*******************************************************************************************
  RemoveIndices: remove indices startindex .. endindex from the index arrays 
*******************************************************************************************/
void RemoveIndices(USI startindex, USI endindex)
{
  static USI i, pos;
  if (endindex == startindex) return;
  for( i = endindex; i-->startindex;)
    {
      pos = IndexRL->V[i][0];
      /*check if this row is in the IndexLR - Matrix*/
      if(pos != TOP)
	{
	  if( pos == NbIndexLR - 1 )
	    NbIndexLR--;
	  else
	    DelSingleRow(&FLR, &blockflag, pos);
	  IndexLR->V[pos][0] = TOP; /*mark as unused*/
	}
    }
  NbIndexRL = startindex;
}/*RemoveIndices*/
