#ifndef __LISTS_H__
#define __LISTS_H__
#include "matrix.h"

#define maxElements 1000
#define maxList 10
#define maxElementsFL 10000

typedef struct LiListElement
{
  int Elements[maxElements]; /*array for the elements*/
  USI NbElements; /*number of used elements*/
  struct LiListElement *next; /*if more elements are needed: pointer to next element*/ 
}
LiListElement;

typedef struct LiList
{
  int  Indices[maxList];
  LiListElement *AdjRows[maxList];
  USI R; /*number of rows*/
  struct LiList *next;
}
LiList;

typedef struct FreeLi
/*speichert Zeiger auf freie Reihen im FIFO-Prinzip
  Die Reihenindizes bleiben fest, damit nicht bei jedem Lschvorgang
  die Zeiger in allen Listen upgedated werden mssen
  */
{
  int FreeRows[maxElementsFL]; /*indices of free rows*/
  USI Top; /*used elements*/
  USI Bottom;
  struct FreeLi *next; /*if more elements are needed: pointer to next element*/ 
}
FreeLi;

LiList *CreateLiList();
void printLiListElement(LiListElement *ListEl);
void printLiList(LiList *List);
FreeLi *InitFreeList();
void DelFreeList(FreeLi *FreeList);
int GetFreeRow(FreeLi **FreeList, USI *blockflag);
void DelSingleRow(FreeLi **FreeList, USI *blockflag, USI row);
int StorePair(LiList *List, int ray1, int ray2);
void FreeLiList(LiList *List);
void ScanList(LiList *List, int *entrys, int *elems);

#endif
