#ifndef __MATRIX_H__
#define __MATRIX_H__

#define USL unsigned long
#define USI unsigned int

/*matrix of integers*/
typedef struct
{
  unsigned int R; /*number of rows*/
  unsigned int C; /*number of columns*/
  int **V; /*integer array*/
}
INTMATRIX;

/* Allocates space for an m x n matrix. */
INTMATRIX *BuildMat(unsigned int m, unsigned int n);

/* returns the zero  m x n matrix.*/
INTMATRIX *ZeroMatrix(USI m, USI n);

/*identity matrix of siez n x n */
INTMATRIX *IdentityMat(USI n);

/*Add numrows rows to the matrix*/
int ResizeRows(INTMATRIX **A, int numrows);



/* frees the storage allocated to the two-dimensional array Mptr->V. */
void FreeMat(INTMATRIX *Mptr);

/* frees the storage allocated to the rows beginning at startrow */
void PartFreeMat(INTMATRIX **Mptr, USI startrow);


/*copy matrix*/
INTMATRIX *CopyMat(INTMATRIX *Mptr);


/* Prints the size of the matrix in bytes*/
int SIZEOFMATI(INTMATRIX *Mptr);

#endif
