/*****************************************************************************

Programm	:	struct

Komponente	:       matrixIO.c
                        Ein-/ Ausgabe von Matrizen
			Nur fuer Debug-Zwecke

                        
Programmer	:	Alexander Huck
Date		:	1998

*****************************************************************************/

#include "intOps.h"
#include "matrix.h"
#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define LINESIZE 2048


/* a '#' in the first column is a comment line */
INTMATRIX *Matrix_Read(FILE *infile)
{
  INTMATRIX *Mat;
  int i, j, n;
  unsigned NbRows, NbColumns;
  char *c, s[LINESIZE];

  fgets(s, LINESIZE, infile);
  while ( (*s=='#' || *s=='\n') || (sscanf(s, " %d %d", &NbRows, &NbColumns)<2) )
    fgets(s, LINESIZE, infile);

  Mat = ZeroMatrix(NbRows, NbColumns);

  for (i=0;i<NbRows;i++)
  { c = fgets(s, LINESIZE, infile);
    while(c && (*c=='#'  || *c=='\n') ) c = fgets(s, LINESIZE, infile);
    if (!c)
    {  fprintf(stderr, "Matrix_Read: ?not enough rows\n");
       break;
    }
    for (j=0;j<NbColumns;j++)
    {
	if (sscanf(c, " %d%n", &(Mat->V[i][j]), &n)==0)
	{  fprintf(stderr, "Matrix_Read: ?not enough columns\n");
	break;
	}
      c += n;
    }
  }

  return Mat;
} /* Matrix_Read */


void FPRINTMATI(FILE *outfile, USI r1, USI r2, USI c1, USI c2, INTMATRIX *Mptr)
{
	int *p;
	int i, j;
	int r,c;
      

	if(!Mptr) return;
	if(r1<0 || r2<0 || c1<0 || c2<0) return;
	r = r2 - r1 + 1;
	c = c2 - c1 + 1;
	
	fprintf(outfile,"%d %d\n", r, c);
	for (i=r1;i<=r2;i++) 
	{
		p=Mptr->V[i];
		for (j=c1;j<=c2;j++)
		{
				fprintf(outfile,"%4d " , *p++);
		}
		fprintf(outfile, "\n");
	}
}

void PRINTMATI(int r1, int r2, int c1, int c2, INTMATRIX *Mptr)
/*
 * prints *Mptr from rows r1 to r2 and cols c1 to c2.
 */
{
	unsigned int i, j;

	if(!Mptr) return;
	if(r1<0 || r2<0 || c1<0 || c2<0) return;
	i = r2 - r1 + 1;
	j = c2 - c1 + 1;
	if ( j > 80)
	{
		printf("(The number of rows or columns to be printed exceeds 80;\n");
		printf("there is no point in printing this matrix on the screen.)\n");
		return;
	}
	FPRINTMATI(stdout, r1, r2, c1, c2, Mptr);
	return;
}



void printsat(INTMATRIX *Sat, int startrow, int endrow)
{
  int i, j;
  int numcols = Sat->C;

 printf("_________saturation matrix______\n");

	for(i = startrow; i<=endrow; i++){
	for(j = 0; j<numcols; j++)
	  {
	    printf("%08x", Sat->V[i][j]);
	  }
	printf("\n");
}
    printf("________________________________\n");


}
