#ifndef __MATRIXOPS_H__
#define __MATRIXOPS_H__

#include "matrix.h"

/*Updates Mptr by interchanging cols p and q */
INTMATRIX *SwapCols(USI p, USI q, INTMATRIX *Mptr);

/*Updates Mptr by interchanging rows p and q via memory copy
  temp is a temporary row used for the copy operation*/
void RowExchange(INTMATRIX *Mptr, USI a, USI b, int *temp);

/*Updates Mptr by swapping pointers of rows p and q (unused)*/
INTMATRIX *SwapRows(USI p, USI q, INTMATRIX *Mptr);

/*copy row a to row b*/
void CopyRow(INTMATRIX *Mptr, USI a, USI b);

/* adding A times col p to col q of Mptr. (used by hermite2)*/
INTMATRIX *AddMultCol(USI p, USI q, int A, INTMATRIX *Mptr);

/*   row p3 = row p1 | row p2 */
void RowOr(USI p1, USI p2, USI p3, INTMATRIX *Mptr);

/* multiplying the pth column of *Mptr by *A.*/
INTMATRIX *ScalarCol(USI p, int A, INTMATRIX *Mptr);

/* Scans rows >= i, cols >= j for first nonzero row if any. Returns 
 * this row number if there is one, else returns A->R; */
USI RowSeek(INTMATRIX *A, USI i, USI j);

/* returns (*Mptr) * (*Nptr)*/
INTMATRIX *MultMat(INTMATRIX *Mptr, INTMATRIX *Nptr);

/*Transpose Matrix*/
INTMATRIX *TransMat(INTMATRIX *Mptr);
 
/*is row findrow of SRC in SEEK?
  yes => return row of SEEK
  no => return -1*/
int ISIN(int findrow, INTMATRIX *SRC, INTMATRIX *SEEK);

#endif
