#ifndef __MATRIXPROCS_H__
#define __MATRIXPROCS_H__

#include "matrix.h"

/*eliminate identical rows*/
void ElimEqualRows(INTMATRIX **Mptr);

/*eliminate non-minimal supports (used by traps/siphons)*/
void ElimNonMinimal(INTMATRIX **Mptr);

/*remove rows of only zeros*/
void RemoveZeroRows(INTMATRIX **Mptr);

/*eliminate simple constraints*/
void ElimSimpleConstraints(INTMATRIX **Mptr);

/*sort rows, used to sort a constraint matrix*/
void SortRows(INTMATRIX *Mptr);

/*quickSort OV, sort rows p..r, sort by the value of OV->V[index1], also swap index2
modifies only rows p..r and columns index1, index2 
*/
void QuickSort(INTMATRIX *OV, int p, int r, USI index1, USI index2);

#endif
