#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "matrix.h"
#include "matrixIO.h"

int ProgramOutput(INTMATRIX **LoopDomain, int vars)
{
  INTMATRIX *Constraints;
  char filename[50];
  char sbuffer[100];
  FILE *enum_output, *infile;
  int i, j;
  int thisvar;
  int coeffset;
  int nblowbounds, nbupbounds;
  int upboundsstart;
  int right_side, coeff, varcoeff;
  int Dimension;
  char **tab_var;
  int tab_cour = 0;
  int TAB = 1;
  char *tnethome;
  char command[100];
  char s[512];
  int statespace = 0;

  tab_var = (char **) malloc((vars + 1)*sizeof(char *));
  
  tnethome = getenv("TNETHOME");
 
  strcpy(filename, tnethome);
  strcat(filename, "/Shared/bin/loopcount.c");
  enum_output = fopen(filename, "w");
  
  /*Programmkopf ausgeben*/
  fprintf(enum_output,"/*****************************************************************************\n");
  fprintf(enum_output,"Dieses Programm wird von ($TNETHOME)/Shared/src/struct_tn/polycount.c\n");
  fprintf(enum_output,"automatisch generiert und\n");
  fprintf(enum_output,"vom Script ($TNETHOME)/Shared/scripts/count.script uebersetzt und ausgefuehrt\n");
  fprintf(enum_output,"Sinn des Programms: Abschaetzung der Anzahl von Zustaenden im \n");
  fprintf(enum_output,"Erreichbarkeitsgraphen ohne diesen zu erstellen.\n");
  fprintf(enum_output,"Jede for-Schleife bzw. if-Anweisung steht fr die moeglichen Markierungen  \n");
  fprintf(enum_output,"einer Stelle. In der innersten Schleife wird ein Zaehler hochgezaehlt,  \n");
  fprintf(enum_output,"der nach Ablauf des Programms die (geschaetzte) Anzahl von Zustaenden enthaelt.  \n");
  fprintf(enum_output,"*****************************************************************************/\n");
  
  fprintf(enum_output,"#include <stdio.h>\n");
  fprintf(enum_output,"#include <stdlib.h>\n");
  fprintf(enum_output,"#include \"../scripts/execute_h\"\n");
  fprintf(enum_output,"#include \"../scripts/timer_h\"\n");
  fprintf(enum_output,"int main()\n");
  fprintf(enum_output,"{\n");
  fprintf(enum_output,"unsigned int count = 0;\n");
  fprintf(enum_output,"int ");

  for (i=1; i<=vars; i++)
    {
      tab_var[i] = (char *) malloc(10*sizeof(char));
      sprintf(sbuffer, "%i", i);
      strcpy(tab_var[i], "m");
      strcat(tab_var[i],sbuffer);
    }


 for (i=1; i<=vars; i++)
    {
      fprintf(enum_output,"%s", tab_var[i] );
      if (i == vars)
	fprintf(enum_output," ;\n");
      else
	fprintf(enum_output,", ");
    }
  /*Programmkopf fertig*/

 /*Zeitmessung*/
 
 fprintf(enum_output,"start_timer(0);\n");
 fprintf(enum_output,"  reset_all_timer ();\n");

 /*Schleifen*/
 for(thisvar=1; thisvar<=vars; thisvar++)
    {
      Constraints = LoopDomain[thisvar];
      Dimension = Constraints->C -1;
      /* Tabulation */
      for (j=0; j<tab_cour; j++) fprintf(enum_output," ");
      
      /*if - Bedingung ?*/
      if(Constraints->V[0][0] == 0)
	{
	  /*
	    printf("Gleichung bei constraint %i\n", thisvar);
	  */
	  // fprintf(enum_output,"if ( ( %s", tab_var[thisvar]);
	  fprintf(enum_output,"if ( ( ");
	  /*rechte (konstante) Seite der Gleichung*/
	  right_side = - Constraints->V[0][Dimension];
	  if(right_side)
	    {
	      sprintf(sbuffer, "%i", right_side);
	      fprintf(enum_output, sbuffer);
	    }
	  coeffset = 0;
	  for(j = 1; j< thisvar; j++)
	    {
	      coeff = - Constraints->V[0][j];
	      if(coeff)
		{
		  if(coeff>0)
		    fprintf(enum_output, "+");
		  sprintf(sbuffer, "%i", coeff);
		  fprintf(enum_output, sbuffer);
		  fprintf(enum_output, " * %s ", tab_var[j]);
		  coeffset = 1;
		}
	    }
	  if(!coeffset && !right_side)
	    fprintf(enum_output, "0");
	  fprintf(enum_output, ") %% ");
	  varcoeff = Constraints->V[0][thisvar];
	  sprintf(sbuffer, "%i", varcoeff);
	  fprintf(enum_output, sbuffer);
	  fprintf(enum_output, " == 0 ) {\n ");
	} 
     else
       {
      /* for */
      fprintf(enum_output,"for (%s=", tab_var[thisvar]);

      /* untere Grenze */
      nblowbounds = 0;
      for(i=0; i<Constraints->R; i++)
	{
	  if (Constraints->V[i][thisvar]<0) /*upperbound*/
	    break;
	  nblowbounds++;
	}
      upboundsstart = i;
      /*
      printf("this constraint has %i lowbounds\n", nblowbounds);
      */
      if(nblowbounds == 0)
	{
	  printf("ERROR! no lower bound for domain %i\n", thisvar);
	  return -1;
	}

      if(nblowbounds>1)
	fprintf(enum_output,"max%d(", nblowbounds);
      for(i=0; i<nblowbounds; i++)
	{
	  varcoeff = Constraints->V[i][thisvar];
	  if(varcoeff>1)
	    fprintf(enum_output,"div("); 
	  /*rechte (konstante) Seite der Gleichung*/
	  right_side = - Constraints->V[i][Dimension];
	  if(right_side)
	    {
	      sprintf(sbuffer, "%i", right_side);
	      fprintf(enum_output, sbuffer);
	    }
	  coeffset = 0;
	  for(j = 1; j< thisvar; j++)
	    {
	      coeff = - Constraints->V[i][j];
	      if(coeff)
		{
		  if(coeff>0)
		    fprintf(enum_output, "+");
		  sprintf(sbuffer, "%i", coeff);
		  fprintf(enum_output, sbuffer);
		  fprintf(enum_output, " * %s ", tab_var[j]);
		  coeffset =1;
		}
	    }
	  if(!coeffset && !right_side)
	    fprintf(enum_output, "0");
	  
	  if(varcoeff>1)
	    {
	      fprintf(enum_output, ",%i", varcoeff); /*closing bracket for div*/
	      fprintf(enum_output, ")");
	    }
	  
	  if(i+1< nblowbounds)
	    fprintf(enum_output, ",");
	}
      if(nblowbounds>1)
	fprintf(enum_output,")"); /*closing bracket for max(*/
      
      fprintf(enum_output,"; %s<=", tab_var[thisvar]);
      
      /* obere Grenze */
      nbupbounds = Constraints->R - upboundsstart;
      if(nbupbounds == 0)
	{
	  printf("ERROR! no upper bound for domain %i\n", thisvar);	
	  return -1;
	}

      if(nbupbounds>1)
	fprintf(enum_output,"min%d(", nbupbounds);
      
      for(i=upboundsstart; i<Constraints->R; i++)
	{
	  varcoeff = -Constraints->V[i][thisvar];
	  if(varcoeff>1)
	    fprintf(enum_output,"div("); 
	  /*rechte (konstante) Seite der Gleichung*/
	  right_side =  Constraints->V[i][Dimension];
	  if(right_side)
	    {
	      sprintf(sbuffer, "%i", right_side);
	      fprintf(enum_output, sbuffer);
	    }
	  coeffset = 0;
	  for(j = 1; j< thisvar; j++)
	    {
	      coeff =  Constraints->V[i][j];
	      if(coeff)
		{
		  if(coeff>0)
		    fprintf(enum_output, "+");
		  sprintf(sbuffer, "%i", coeff);
		  fprintf(enum_output, sbuffer);
		  fprintf(enum_output, " * %s ", tab_var[j]);
		  coeffset =1;
		}
	    }
	  if(!coeffset && !right_side)
	    fprintf(enum_output, "0");
	  if(varcoeff>1)
	    {
	      fprintf(enum_output, ",%i", varcoeff); /*closing bracket for div*/
	      fprintf(enum_output, ")");
	    }
	  
	  if(i+1< Constraints->R)
	    fprintf(enum_output, ",");
	}

      if(nbupbounds>1)
	fprintf(enum_output,")");/*closing bracket for min(*/
        
      fprintf(enum_output,"; %s++) {\n", tab_var[thisvar]);   
     }
      tab_cour+=TAB;
    }
  
 /*Weiterzaehlen*/
  fprintf(enum_output,"count++;\n");

 /*Klammern zu*/

  for (i=0; i<vars; i++)
    { /* Tabulation */
      tab_cour-=TAB;
      for (j=0; j<tab_cour; j++) fprintf(enum_output," ");
      
        fprintf(enum_output,"}\n");        
    }

  /*Programmschluss drucken*/
  
  fprintf(enum_output,"printf(\"count: %%i \\n\", count);\n");
   
 
  fprintf(enum_output,"stop_timer(0);\n");
  fprintf(enum_output,"printf (\"Time passed with computation: %%8.2f s\\n\", time_passed(0) );\n");

  fprintf(enum_output,"return 0;\n");
  fprintf(enum_output,"}\n");

 fclose(enum_output);
 for (i=1; i<=vars; i++)
    {
      free(tab_var[i]);
    }
 free(tab_var);

 /*Programm ausfhren*/
 /*result-Datei loeschen*/
 sprintf(command,"'rm' -f %s/Shared/bin/count_result", tnethome);
 system(command);
 
 sprintf(command,"csh -e -f %s/Shared/scripts/count.script",
	 tnethome
	 );
 system(command);
 
 strcpy(filename, tnethome);
 strcat(filename, "/Shared/bin/count_result");
 /*versuchen, Datei zu oeffnen*/
 infile = NULL;
 while(infile == NULL)
   {
     infile = fopen(filename, "r");
   }
 /*Ergebnis auslesen*/
 fgets(s, 512, infile);
 sscanf(s, "%s %d", sbuffer, &statespace);
 /*
  printf("Statespace : %i\n", statespace);
 */
 return statespace;
}
