#ifndef __SHAREDOPS_H__
#define __SHAREDOPS_H__
#include "matrix.h"
#include "lists.h"

/*combine new ray r3 from r1 and r2, update Sat matrix*/
int Combine(int r1, int r2, int r3, INTMATRIX *Mptr);
/*combine new ray r3 from r1 and r2, dont update Sat matrix*/
int SimpleCombine(int r1, int r2, int r3, INTMATRIX *Mptr);
/*create lookup-table*/
void CreateLookUpMat();
/*count rays in the Ray-matrix*/
int CountRays(INTMATRIX *_Ray);
/*extract rays from the ray-matrix*/
INTMATRIX* ExtractRays(INTMATRIX *_Ray, int numsol);
/*compute dot-product r.constraint for all rays*/
void EvalConstraint(int *constraint);
/*check for vertex that remains valid*/
int CheckForStartingVertex(int startrow, USI Start, USI End);
/*sort rays by MinF-value*/
void SortRaysMinF(int sup_bound, int equal_bound);
/*combine adjacent rays*/
int CombineNewRays(LiListElement *ListEl, int thisrow);

int ObtainNewRays(LiList *List);
void EvalAllConstraints(int startrow, USI Start, USI End);
int CheckedLater(USI i, USI k, USI rplus, USI rminus);
void BuildBorder(USI sup_bound);
USI GetBorder(USI thisBorder);
USI GetUpperBound();
int ConstrainL(USI step);
/*add new lines to _Ray*/
INTMATRIX *AddLines(INTMATRIX *_Ray, int newlines);

/* compute status words of the ray matrix from Constraints and  Sat*/
void WriteStatus(INTMATRIX *Constraints, INTMATRIX *Ray, INTMATRIX *Sat);
/* compute status words of the ray matrix  from Constraints and  Sat*/
void WriteStatusConstraints2(INTMATRIX *Constraints, INTMATRIX *Ray, INTMATRIX *Sat, int maxray);
void WriteStatus(INTMATRIX *Constraints, INTMATRIX *Ray, INTMATRIX *Sat);

INTMATRIX *BuildSat(INTMATRIX *Mat, INTMATRIX *_Ray, USI NbCon);

int Init();
#endif
