/*****************************************************************************

Programm	:	dualungleich

Komponente	:	ungleich.c
                        loest homogenes Ungleichungssystem
			(unabhaengig von Petri-Netzen)

Programmer	:	Alexander Huck
Date		:	1999

*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "matrixIO.h"
#include "matrix.h"
#include "matrixProcs.h"
#include "timer.h"
#include "invars.h"
#include "malloc.h"
#include "inequalities.h"
#include "invars.h"

/*#define DEBUG*/

int main(argc, argv)
int argc;
char *argv[];
 {
   char filename[50];
   INTMATRIX *Mptr, *Solution;
   FILE *infile;
   int numsol;
#ifdef DEBUG
 char debugfilename[50];
  FILE *outfile;
#endif
  
#ifdef DEBUG
  strcpy(debugfilename, "ungleich.out");
  outfile = fopen(debugfilename, "w");
#endif  

   if (argc != 2)
     {
       printf("nee, so geht das nicht\n");
       printf("bitte Dateinamen fuer Datei mit Inzidenzmatrix \n");
       return 1;
     }

   strcpy(filename, argv[1]); 

   infile = fopen(filename, "r");
   if (infile == NULL)
     printf("does not exist or cannot be opened");
   Mptr = Matrix_Read(infile);
   fclose(infile);

#ifdef DEBUG
   fprintf(outfile,"dualungleich: INPUT MATRIX \n");
   FPRINTMATI(outfile,0,Mptr->R-1,0,Mptr->C-1,Mptr);
#endif  

   ElimEqualRows(&Mptr);
   ElimSimpleConstraints(&Mptr);
   SortRows(Mptr);

#ifdef DEBUG
   fprintf(outfile,"dualungleich: nach sortieren \n");
   FPRINTMATI(outfile,0,Mptr->R-1,0,Mptr->C-1,Mptr);
#endif  
  
   numsol=SolveInequationSystem(&Solution, Mptr, 1000000);
   printf("Anz. Loesungen : %i \n", numsol);
   printf ("Time passed with computation: %8.2f s\n", time_passed(0));
#ifdef DEBUG 
   fprintf(outfile, "Anz. Loesungen : %i \n", numsol);
  fprintf (outfile,"Time passed with computation: %8.2f s\n", time_passed(0));
  fclose(outfile);
  
#endif


   FreeMat(Mptr);
   return 0;
}

