/*****************************************************************************

Programm	:       countpoly

Komponente	:	zaehlen.c
                        Bestimmt den Inhalt eines Polyeders
			(unabhaengig von Petri-Netzen)

Programmer	:	Alexander Huck
Date		:	1999

*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "matrixIO.h"
#include "matrixOps.h"
#include "matrixProcs.h"
#include "matrix.h"
#include "timer.h"
#include "polycount.h"
#include "malloc.h"

int main(argc, argv)
int argc;
char *argv[];
 {
   char filename[50];
   char str[50];
   INTMATRIX *Mptr;
   FILE *infile;
   int statespace = 0;
   int vars;
   
   if (argc != 2 && argc != 3)
     {
       printf("nee, so geht das nicht\n");
       printf("bitte Dateinamen fuer Datei mit constraints \n");
       printf("und Anzahl von Variablen angeben, die gescannt werden sollen.\n");
       return 1;
     }

   strcpy(filename, argv[1]); 

   printf("filename : %s\n", filename);
   infile = fopen(filename, "r");
   if (infile == NULL)
     printf("does not exist or cannot be opened");
   Mptr = Matrix_Read(infile);
   fclose(infile);
   printf("matrices from file %s successfully inputted\n", filename);

   if (argc == 3)
     {
       strcpy(str, argv[2]);
       sscanf (str,"%i",&vars);
     }
   else
     {
       vars = Mptr->C - 2;
     }
   
   printf("vars: %i \n", vars);
   
   
#ifdef DEBUG	    
   printf("eliminieren: \n");
#endif
   ElimEqualRows(&Mptr);
   ElimSimpleConstraints(&Mptr);
   
#ifdef DEBUG
   printf("sortieren: \n");
#endif
   SortRows(Mptr);
   
#ifdef DEBUG
   printf("Sortiert und eliminiert:\n ");
   PRINTMATI(0,Mptr->R-1,0,Mptr->C-1, Mptr);
   fprintf(outfile,"Sortiert und eliminiert:\n ");
   FPRINTMATI(outfile,0,Mptr->R-1,0,Mptr->C-1,Mptr);
#endif
   
   statespace = PolyEnum(Mptr, vars);
   
   FreeMat(Mptr);
   return 0;
}

