// File    : TimeWrapper.h        (C Interface) 
// Module  : TimeWrapper          (Ressource Monitoring Functions)
//
// Purpose : Time and memory measuring functions.
//
// Author  : Oliver Hesse
// Date    : September 1999

#ifndef TIME_WRAPPER_H
#define TIME_WRAPPER_H


// times usages
void* getCPUTime_C();
void* getTimeOfDay_C();

// output of time in format "hh:mm:ss.msec"
void  printTime_C(void *time);
// output of time in format "sec.msec"
void  printTimeSec_C(void *time);

// output of time difference in format "hh:mm:ss.msec"
void  printTimeDiff_C(void *endTime, void *startTime);
// output of time difference in format "sec.msec"
void  printTimeDiffSec_C(void *endTime, void *startTime);

// time operations
void* addTimes_C(void *firstTime, void *secTime);
void* subTimes_C(void *endTime, void *startTime);

// write and load times
void  saveTime_C(void *time, char* netname, char* timeType);
void* loadTime_C(char* netname, char* timeType);

// delete time pointer
void  freeTime_C(void *time);



// memory usage
long  getUsedMem_C();

// output of memory
void  printMem_C(long mem);
// output of memory difference
long  printMemDiff_C(long memAtEnd, long memAtStart);

// write and load memory
void saveMem_C(const long mem, char* netname, char* memType);
long loadMem_C(char* netname, char* memType);


#endif

