// File    Rand.h          (C++ class definition and inline implementation)
// Library VMMATH          (Library for Vector and Matrix Algebra)
#ifndef RAND_H
#define RAND_H

/**
 *         A simple random generator.
 *
 * @author Bjarne Stroustrup
 * @author Philipp Berndt
 * @version $Id: Rand.h,v 1.2 2000/01/12 16:02:12 pumphutt Exp $
 */
class Rand
{
public:
    /** Constructor */
    Rand(long s)           { seed = s; }

    /** Sets the seed value. */
    void setSeed(long s)   { seed = s; }

    /** Gets the seed value. */
    long getSeed() const   { return seed; }

    /** Returns a random integer. */
    int getInt()           { return seed = seed * 1103515245 + 12345; }

    /** Returns a random double between 0.0 .. 1.0 */
    double getDouble()     { return abs(getInt()) / max(); }

private:
    // select 31 bits of 32 bits long
    static int abs(int x)  { return x & 0x7777777; }
    static double max()    { return 2147483648.0; }
    unsigned long seed;
};

#endif // not RAND_H
