// Testprogramm zum experimentieren mit VMMATH

#include <iostream>
#undef PVM_SUPPORT
#include "../sysdep/Time.h"
#include "vmmath.h"

void mul(Vector &v1, Vector &v2)
{
    cout << "\nmul:" << v1*v2 << '\n';
}

int main()
{
    cout << "Hello world!" << endl;

    SparseVector a(15);
    for(int i =0; i<a.getCols(); ++i)
        a[i] = i+1;

    cout << "a:" << a;
//     cout << "b:" << Vector(a);
    DiagMatrix dm(a);
    cout << "\ndm:" << dm;

    cout << "Hello world!" << endl;

//     while(true)
//      {
//      SparseVector b(a);
//      a *= 1.00005;
//      b *= 1.00005;
//      cout << "mem:" << getUsedMem() << endl;
//      }

    // olivers tests anfang !!!

    /*
      SparseVector v_oli(4);
      v_oli[0] = 0.0;
      v_oli[1] = 2.0;
      v_oli[2] = 0.0;
      v_oli[3] = 0.0;
      cout << "Vector: " << endl;
      cout << v_oli;
    */

    SparseMatrix m_oli(4, 4);

    m_oli(2, 3) = 1.0;
    m_oli(3, 0) = 1.0;

    cout << "Matrix M: " << endl;
    cout << m_oli;

    FilterMatrix I_oli(4);
    I_oli(2, 2) = 1.0;
    I_oli(3, 3) = 1.0;
    cout << "Matrix I: " << endl;
    cout << I_oli;

    FilterMatrix comp_I_oli(4);
    comp_I_oli = I_oli.getComplement();
    cout << "Matrix complement I: " << endl;
    cout << comp_I_oli;

    m_oli += comp_I_oli;
    cout << "Matrix new M: " << endl;
    cout << m_oli;
    /*
      SparseVector vres_oli(4);
      vres_oli = v_oli * m_oli;  
      cout << "Multiplikation m = v * m: " << endl;
      cout << vres_oli;

      vres_oli = v_oli;  
      vres_oli *= m_oli;  
      cout << "Multiplikation m *= v: " << endl;
      cout << vres_oli;
    */

    cout << "fertig ! " << endl;

    // olivers tests ende !!!

    SparseVector v(10);
    v[3] = 6.0;
    v[7] = 10.0;

    v.print(cout);
    //  cout << '\n' << v*v << '\n';

    Vector& vek = v;

    clock_t start,end;
    double d = 0.0;

    start = clock();
    for(int i=0;i<10000;i++)
        d += vek*vek;
    end = clock();
    cout << "Vector: " << end-start << "\n";


    start = clock();
    for(int i=0;i<10000;i++)
        d += v*v;
    end = clock();
    cout << "SparseVector: " << end-start << "\n";

    cout <<d;
    mul(v,v);
  
    for(SparseVector::SVRep::const_iterator i= v.getSVRep().begin();
        i!=v.getSVRep().end(); i++)
        cout << i.getIndex() << ": " << *i << '\n';
  
    for(SparseVector::SVRep::iterator i= v.getSVRep().begin();
        i != v.getSVRep().end(); i++)
        *i += 1;
  
    for(SparseVector::SVRep::const_iterator i= v.getSVRep().begin();
        i!=v.getSVRep().end(); i++)
        cout << i.getIndex() << ": " << *i << '\n';

    for(int i= 0; i<10; i++)
        v[i] = i;
    v.print(cout);

    SparseVector v2(10);
    v2 = v;
    for(int i= 0; i<10; i++)
        v2[i] *= -1;
 
    v2.print(cout);
    v.print(cout);

    SparseMatrix sm(15,15);
 
    FilterMatrix fm(15);
    fm.setDiagElem(3,true);
    fm.setDiagElem(4,true);
    fm.setDiagElem(5,true);

    for(int r=0; r<10; r++)
        for(int c=0; c<10; c++)
            sm(r,c) = r*17+c+1;    
    sm.print(cout);

    cout << "\nFilterMatrix:\n";
    fm.print(cout);

    cout << "\nFilterMatrix.getComplement():\n";
    fm.getComplement().print(cout);

    cout << "\nHerausgefiltert:\n";
    SparseMatrix nm(15,15);
    (sm*fm).print(cout);

    cout << "\nKopiert:\n";

    SparseMatrix g(sm);

    cout << "copied." << endl;
    for(int r=0; r<10; r++)
        for(int c=0; c<10; c++)
            g(r,c) *= -1;    
    g = sm*fm;

    g.print(cout);

    cout << "\nGefiltert:\n" << endl;
    sm *= fm;
    sm.print(cout);

    sm += fm.getComplement();

    cout << "\nMit Filter.compl:\n" << endl;
    sm.print(cout);
 
    DenseVector dv(10);
  
    dv=v;
    cout << "dv (dense) : \n";
    dv.print(cout);
    cout << endl;

    SparseMatrix A = sm;
    A /= 5.0;
    cout << "A = sm; A /= 5.0\n" << A;

    A = sm;
    A += fm;
    cout << "A = sm; A += fm\n" << A;

    A = sm/5.0;
    cout << "A = sm/5.0\n" << A;

    A = sm + fm;
    cout << "A = sm + fm\n" << A;

    A = sm/5.0 + fm;
    cout << "A = sm/5.0 + fm\n" << A;

    cout << "OnesVector:" << OnesVector(5);
    cout << v << endl << v * OnesVector(5) << endl;
}
