/************************************************************************

  filename:     analysis.h


*************************************************************************/

#define true  1
#define false 0

/* Constant values for initializing parameters */
#define ALPHAT_DEF      (1.0-(double)conf_level/100.0)

#define ANALYSIS_SIZE      100
#define RESULT             0
#define TEMP               1
#define SAMPLE_MALLOC_SIZE 10*ANALYSIS_SIZE
#define PREC_LIMIT         1000




/* Environment used by the batch means analysis for each opened STATISTICS */
typedef struct t_StatisticsEnvironment
{
  char                  name[30];
  bool                  StopSimulation; 
  bool                  StopSendedToSlave;
  bool                  StopSendedToBackend;
  double                EndTime; 
  double                PrecPortion;
  str_sample_type       **SampleBlock;
  str_sample_type       *dummy_samples; 
  long                  SampleCount;
  int                   MemoryCounter;
  int                   SendFactor; 
  double                *Epsilon;
  double                *AveragedMean;
  double                *DeltaX;
  double                *Variance;
} Str_Stat;














