/**************************************************************************
 File:		expoly.h

 Purpose:	include-file for expoly.c and rspnrand.c
		contains headers of functions to manipulate expolynomial
		distributions
		
		for data structure of an expolynomial distribution
		see expoly_types.h

 Programmer:	Reinhard German

 History:	Release 1: June 2, 1993 (Reinhard German)
                Release 2: May, 1999 (Oliver Hesse)    
**************************************************************************/

#include "expoly_types.h"


#define MAXINDEX    4000000      /* maximum size of array of factors */   
#define MAXRUNS     5            /* maximum number of runs */

#define MINVALUE    (double )1.0e-300
#define MAXVALUE    (double )1.0e300


/**************************************************************************
 function headers:
**************************************************************************/

void print_expoly();
int scan_expoly();
time_l *set_det_expoly();
time_l *set_uniform_expoly();

void poisson_prob();

void print_factors();
void calculate_factors();
