#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#ifndef __NetBSD__
#include <sys/types.h>             /* size_t */
#endif

#define LINE_LEN 256

char* s;

#ifdef __STDC__
char* fgetline(FILE *f, size_t *l)
#else
char* fgetline(f, l)
    FILE *f;
    size_t *l;
#endif
{
    static size_t max;
    int i,j=0;
    char c;

    *l = 0;

    if (!s)
	if (!(s = (char*)malloc(sizeof(char)*(max = LINE_LEN)))) {
	    fprintf(stderr, "not enough memory for malloc().\n");
	    return NULL;
	}
	    
    while ((i = getc(f)) != EOF) {
	if ( j == max-1 )
	    if (!(s = (char*)realloc(s, sizeof(char)*(max += LINE_LEN)))) {
		fprintf(stderr, "not enough memory for realloc().\n");
		return NULL;
	    }
	
	c = (char)i;
	if ( c == '\n') {
	    s[j++] = '\0';
	    *l = j;
	    return s;
	}
	else
	    s[j++] = c;
    }

    if (ferror(f)) {
	fprintf(stderr, "fgetline(): error on stream in getc() %d.\n",
		ferror(f));
	return NULL;
    }

    if ( j == max-1 )
	if (!(s = (char*)realloc(s, sizeof(char)*(max += 1)))) {
	    fprintf(stderr, "not enough memory for realloc().\n");
	    return NULL;
	}

    if (j) {
	s[j++] = '\0';
	*l = j;
	return s;
    }
    *l = 0;
    return NULL;
}


