/******************************************************/
/*** Srukturen fuer das Format der Generatormatrix: ***/
/******************************************************/
/* im transienten Fall und Mexp: */
static struct Q_row_header {
  double neg_sum;			/* negative Summe aller Uebergangsraten dieser Zeile */
  unsigned row_index;			/* Zeilennummer */
  unsigned entries_in_row;		/* Anzahl nachfolgender Eintraege in dieser Zeile
					   (Je Eintrag eine Q_row_entry-Struktur) */
} Q_row_header;
#define SIZEOF_Q_row_header sizeof (Q_row_header)

/* im Fall Mdet(k): */
static struct Q_tau_row_header {
  double tau;				/* det. Schaltzeit tau zu dieser Markierung */
  double neg_sum;			/* negative Summe aller Uebergangsraten dieser Zeile */
  unsigned row_index;			/* Zeilennummer */
  unsigned entries_in_row;		/* Anzahl nachfolgender Eintraege in dieser Zeile
					   (Je Eintrag eine Q_row_entry-Struktur) */
} Q_tau_row_header;
#define SIZEOF_Q_tau_row_header sizeof (Q_tau_row_header)

static struct Q_row_entry {
  double rate;				/* Uebergangsrate */
  unsigned column_index;		/* Spaltennummer des Eintrages */
} Q_row_entry;
#define SIZEOF_Q_row_entry (sizeof (double) + sizeof (unsigned))


/****************************************************/
/*** Strukturen fuer das Format der Delta-Matrix: ***/
/****************************************************/
static struct delta_row_header {
  unsigned row_index;			/* Zeilennummer */
  unsigned entries_in_row;		/* Anzahl nachfolgender Eintraege in dieser Zeile
					   (Je Eintrag eine delta_row_entry-Struktur) */
} delta_row_header;
#define SIZEOF_delta_row_header sizeof (delta_row_header)

static struct delta_row_entry {
  double probability;			/* Uebergangswahrscheinlichkeit */
  unsigned column_index;		/* Spaltennummer des Eintrages */
} delta_row_entry;
#define SIZEOF_delta_row_entry (sizeof (double) + sizeof (unsigned))
