/****************************************************************************
** Evaluation : STATIONARY ANALYSIS                                        **
*****************************************************************************
** Program    : solve                                                      **
** Component  : solve_exp                                                  **
** File       : solve_exp.cpp (C++ source)                                 **
**                                                                         **
** Purpose    : implementations of member functions of the structure       **
**              ExpMarkings for the EMC at regeneration points (S^E)       **
**                                                                         **
** Master's T.: realis. of an iterative solution method for not marc. SPNs **
**                                                                         **
** Programmer : Oliver Hesse                                               **
**                                                                         **
** Date       : june of 1999                                               **
****************************************************************************/

/****************************************************************************
** LIST OF IMPORTS                                                         **
****************************************************************************/

#include "solve_exp.h"                    // structure ExpMarkings


/****************************************************************************
** CONSTRUCTOR OF 'EXP MARKINGS'                                           **
****************************************************************************/

ExpMarkings::ExpMarkings(int dim)
  : I(dim), P(dim,dim), C(dim,dim) {}


/****************************************************************************
** MEMBER FUNCTIONS OF 'EXP MARKINGS'                                      **
****************************************************************************/

#ifdef PVM_SUPPORT
ExpMarkings::ExpMarkings(PVM_UNPACK_t)
  : I(PVM_UNPACK),
    P(PVM_UNPACK),
    C(PVM_UNPACK) {}

void ExpMarkings::pvm_pack()
{
  I.pvm_pack();
  P.pvm_pack();
  C.pvm_pack();
}

ExpMarkings ExpMarkings::pvm_unpack()
{ return ExpMarkings(PVM_UNPACK); }

#endif

