/****************************************************************************
** Evaluation : STATIONARY ANALYSIS                                        **
*****************************************************************************
** Program    : solve                                                      **
** Component  : solve_exp                                                  **
** File       : solve_exp.h (C++ header)                                   **
**                                                                         **
** Purpose    : definition of the structure ExpMarkings for the EMC at     **
**              regeneration points (S^E) which is used by the iterative   **
**              solution method with fill-in avoidance                     **
**                                                                         **
** Master's T.: realis. of an iterative solution method for not marc. SPNs **
**                                                                         **
** Programmer : Oliver Hesse                                               **
**                                                                         **
** Date       : june of 1999                                               **
****************************************************************************/

#ifndef SOLVE_EXP_H
#define SOLVE_EXP_H

/****************************************************************************
** LIST OF IMPORTS                                                         **
****************************************************************************/

#include "vmmath.h"                // vector and matrics representations
                                   // and operations


/****************************************************************************
** DEFINITIONS OF TYPES                                                    **
****************************************************************************/

struct ExpMarkings                 // exponential markings 'Exp'
{
  FilterMatrix   I;                // filter matrix
  SparseMatrix   P;                // stochastic matrix
  SparseMatrix   C;                // conversion matrix


  ExpMarkings(int dim);            // constructor definition

#ifdef PVM_SUPPORT
  ExpMarkings(PVM_UNPACK_t);
  void pvm_pack();
  static ExpMarkings pvm_unpack();
#endif

};


#endif
