/****************************************************************************
** Evaluation : STATIONARY ANALYSIS                                        **
*****************************************************************************
** Program    : solve                                                      **
** Component  : solve_factors                                              **
** File       : solve_factors.cpp (C++ source)                             **
**                                                                         **
** Purpose    : definitions of interfaces to call calculate alpha factors  **
**              and errors from 'C' or 'C++" sources                       **
**                                                                         **
** Master's T.: realis. of an iterative solution method for not marc. SPNs **
**                                                                         **
** Programmer : Oliver Hesse                                               **
**                                                                         **
** Date       : june of 1999                                               **
****************************************************************************/

#ifndef SOLVE_FACTORS_H
#define SOLVE_FACTORS_H


/****************************************************************************
** LIST OF IMPORTS                                                         **
****************************************************************************/

#include "expoly_types.h"

#ifdef __cplusplus
#include "RR.h"
#endif


/****************************************************************************
** DEFINITIONS OF FUNCTIONS                                                **
****************************************************************************/

#ifdef __cplusplus
void calculate_factors_CPP(long ArbBits, time_l *expoly,
                           double TruncError, double q,
                           vector<double> &alpha_f_factors,
		           vector<double> &alpha_F_bar_factors, unsigned &R,
		           double &alpha_f_error, double &alpha_F_bar_error);

extern "C"
#endif
void calculate_factors_C(long ArbBits, time_l *expoly,
                         double TruncError, double q,
                         double **alpha_f_factors,
                         double **alpha_F_bar_factors, unsigned *R,
                         double *alpha_f_error, double *alpha_F_bar_error);

#endif
